2010-01-29  Mark Rowe  <mrowe@apple.com>

        Fix the Mac build.

        Disable ENABLE_INDEXED_DATABASE since it is "completely non-functional".

        As the comment in FeatureDefines.xcconfig notes, the list of feature defines
        needs to be kept in sync across the various files.  The default values also
        need to be kept in sync between these files and build-webkit.

        * Configurations/FeatureDefines.xcconfig:

2010-01-29  Alexey Proskuryakov  <ap@apple.com>

        Reviewed by Dan Bernstein.

        <rdar://problem/7441982> REGRESSION (TOT): Adobe CS4: Installer alerts are displayed as
        blank windows

        * WebView/WebView.mm:
        (shouldEnableLoadDeferring): Load deferring is enabled unless the application is Adobe
        Installer.
        (-[WebView _preferencesChangedNotification:]): Call setLoadDeferringEnabled().

2010-01-28  Enrica Casucci  <enrica@apple.com>

        Reviewed by Maciej Stachowiak.

        Huge plain text pastes are slow
        <rdar://problem/5195056>
        https://bugs.webkit.org/show_bug.cgi?id=34237

        Mail is ignoring the fragment created from plain text or HTML that is
        passed to the delegate function, that creates a new one.
        This fix avoids creating the fragment twice.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _pasteWithPasteboard:allowPlainText:]):

2010-01-25  Anders Carlsson  <andersca@apple.com>

        Featureless build fixes.

        * Misc/WebCache.mm:
        (+[WebCache empty]):
        * WebCoreSupport/WebApplicationCache.mm:
        * WebCoreSupport/WebChromeClient.h:
        * WebView/WebDataSource.mm:
        (-[WebDataSource _transferApplicationCache:]):
        * WebView/WebFrame.mm:
        (-[WebFrame _cacheabilityDictionary]):
        * WebView/WebView.mm:
        (WebKitInitializeApplicationCachePathIfNecessary):
        (-[WebView _close]):
        * WebView/WebViewData.mm:
        (-[WebViewPrivate dealloc]):
        (-[WebViewPrivate finalize]):

2010-01-25  Steve Falkenburg  <sfalken@apple.com>

        Reviewed by Simon Fraser.

        A WebGeolocationControllerClient is leaked for every WebView
        https://bugs.webkit.org/show_bug.cgi?id=34145

        * WebCoreSupport/WebGeolocationControllerClient.h:
        * WebCoreSupport/WebGeolocationControllerClient.mm:
        (WebGeolocationControllerClient::geolocationDestroyed):

2010-01-22  Steve Falkenburg  <sfalken@apple.com>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=34025
        Enable client-based Geolocation abstraction for Mac, Windows AppleWebKit targets.

        * Configurations/FeatureDefines.xcconfig:

2010-01-22  Brady Eidson  <beidson@apple.com>

        Reviewed by Adele Peterson.

        [WebFrame loadRequest:] does not null check the WebCore::Frame
        <rdar://problem/7416286> and https://bugs.webkit.org/show_bug.cgi?id=34021

        * WebView/WebFrame.mm:
        (-[WebFrame loadRequest:]): Null check the WebCore::Frame as it can disappear
          out of underneath a WebFrame.

2010-01-22  Peter Kasting  <pkasting@google.com>

        Reviewed by David Hyatt.

        When scrolling by page, hold back 1/8th of the visible size instead of
        40 px.
        https://bugs.webkit.org/show_bug.cgi?id=32595

        * WebView/WebFrameView.mm:
        (-[WebFrameView _verticalPageScrollDistance]):
        (-[WebFrameView initWithFrame:]):
        (-[WebFrameView _horizontalPageScrollDistance]):

2010-01-20  Jian Li  <jianli@chromium.org>

        Reviewed by Dmitry Titov.

        Implement File and Blob interfaces as defined in File API spec.
        https://bugs.webkit.org/show_bug.cgi?id=32912

        * MigrateHeaders.make:

2010-01-19  Timothy Hatcher  <timothy@apple.com>

        Fix erroneous page scrolls when trying to select text or use form elements
        with the Web Inspector docked.

        http://webkit.org/b/24403
        rdar://problem/6753925

        Reviewed by John Sullivan and Darin Adler.

        * WebCoreSupport/WebChromeClient.mm:
        (WebChromeClient::scrollRectIntoView): The scrollRect.move() call was
        incorrectly converting the rect under the assumption that the frame view
        is the same size as the WebView. Using convertRect:fromView: instead
        is enough to fix the bug, but that code isn't needed since WebCore
        already takes care of scrolling the main frame's document view, so it
        was redundant to do it here too.

2010-01-20  Steve Falkenburg  <sfalken@apple.com>

        Reviewed by Darin Adler and Adam Roben.

        Feature defines are difficult to maintain on Windows builds
        https://bugs.webkit.org/show_bug.cgi?id=33883

        * Configurations/FeatureDefines.xcconfig: Add comments about keeping feature definitions in sync.

2010-01-20  Dan Bernstein  <mitz@apple.com>

        Reviewed by Simon Fraser.

        <rdar://problem/7489504> Clicking on an overflow scrollbar when the window doesn't have
        focus only focuses the window; it should start scrolling too
        https://bugs.webkit.org/show_bug.cgi?id=33906

        * Misc/WebElementDictionary.mm:
        (+[WebElementDictionary initializeLookupTable]): Initialize WebElementIsInScrollBarKey.
        (-[WebElementDictionary _isInScrollBar]): Added. Returns whether the HitTestResult contains
        a scroll bar.
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _isScrollBarEvent:]): Added. Returns whether the event point is in a scroll
        bar in this view.
        (-[WebHTMLView acceptsFirstMouse:]): Accept scroll bar events.
        * WebView/WebView.mm: Define WebElementIsInScrollBarKey.
        * WebView/WebViewPrivate.h: Declare WebElementIsInScrollBarKey.

2010-01-19  Dan Bernstein  <mitz@apple.com>

        Redo Tiger build fix without making WebTypesInternal.h a private header

        * WebView/WebHTMLRepresentation.h: Define and use WebNSUInteger.
        * WebView/WebHTMLRepresentation.mm: Import WebTypesInternal.h.

2009-12-18  Anders Carlsson  <andersca@apple.com>

        Reviewed by Dan Bernstein.

        <rdar://problem/7068584> Crash at NetscapePluginHostProxy::processRequests

        * Plugins/Hosted/NetscapePluginInstanceProxy.h:
        (WebKit::NetscapePluginInstanceProxy::waitForReply): Wrapped with calls
        to willCallPluginFunction/didCallPluginFunction. This prevents the plug-in
        from being stopped while waiting for reply.
        * Plugins/Hosted/NetscapePluginInstanceProxy.mm:
        (WebKit::NetscapePluginInstanceProxy::createBindingsInstance): Protect the
        instance proxy in case the plug-in host crashes while waiting for reply.
        * Plugins/Hosted/ProxyInstance.h:
        (WebKit::ProxyInstance::waitForReply): Added. Calls through to
        NetscapePluginInstanceProxy::waitForReply(), but returns a null reply if the
        proxy gets invalidated while waiting for the reply.
        * Plugins/Hosted/ProxyInstance.mm:
        (WebKit::ProxyInstance::invoke): Use ProxyInstance::waitForReply().
        (WebKit::ProxyInstance::supportsInvokeDefaultMethod): Ditto.
        (WebKit::ProxyInstance::supportsConstruct): Ditto.
        (WebKit::ProxyInstance::getPropertyNames): Ditto.
        (WebKit::ProxyInstance::methodsNamed): Ditto.
        (WebKit::ProxyInstance::fieldNamed): Ditto.
        (WebKit::ProxyInstance::fieldValue): Ditto.
        (WebKit::ProxyInstance::setFieldValue): Ditto.

2010-01-19  John Sullivan  <sullivan@apple.com>

        Tiger build fix.
        
        * WebView/WebHTMLRepresentation.h:
        Added #import for WebTypesInternal.h so NSUInteger will be defined on Tiger.

2010-01-19  Brian Weinstein  <bweinstein@apple.com>

        Reviewed by Tim Hatcher.

        Part of <http://webkit.org/b/28622>.
        Caught exceptions still pause the debugger.
        
        Update WebScriptDebugger::exception to have the hasHandler parameter.
        
        This just adds a new parameter, no behavior is changed.

        * WebView/WebScriptDebugger.h:
        * WebView/WebScriptDebugger.mm:
        (WebScriptDebugger::exception):

2010-01-19  Jon Honeycutt  <jhoneycutt@apple.com>

        MSAA: The child <option> elements of a non-multiple <select> are not
        exposed

        https://bugs.webkit.org/show_bug.cgi?id=33773
        <rdar://problem/7550556>

        * WebCoreSupport/WebViewFactory.mm:
        (-[WebViewFactory AXMenuListPopupActionVerb]):
        Stubbed.
        (-[WebViewFactory AXMenuListActionVerb]):
        Stubbed.

2010-01-19  John Sullivan  <sullivan@apple.com>

        https://bugs.webkit.org/show_bug.cgi?id=33854
        Would like a variant of WebHTMLRepresentation's searchForLabelsBeforeElement that returns 
        more info about where the result was found

        Reviewed by Darin Adler

        * WebView/WebHTMLRepresentation.h:
        Declare -searchForLabels:beforeElement:resultDistance:resultIsInCellAbove.
        
        * WebView/WebHTMLRepresentation.mm:
        (-[WebHTMLRepresentation searchForLabels:beforeElement:]):
        Now calls through to searchForLabels:beforeElement:resultDistance:resultIsInCellAbove.
        (-[WebHTMLRepresentation searchForLabels:beforeElement:resultDistance:resultIsInCellAbove:]):
        New method, calls through to WebCore.

2010-01-19  Dave Hyatt  <hyatt@apple.com>

        Reviewed by Adam Roben.

        Add an API to obtain the WebScriptWorld for a given JSGlobalContextRef.

        * WebView/WebScriptWorld.h:
        * WebView/WebScriptWorld.mm:
        (+[WebScriptWorld scriptWorldForGlobalContext:]):

2010-01-19  Steve Block  <steveblock@google.com>

        Unreviewed build fix.

        Fixes Snow Leopard build due to http://trac.webkit.org/changeset/53464

        * Plugins/Hosted/WebHostedNetscapePluginView.mm: Modified. Import <WebCore/Bridge.h>

2010-01-19  Steve Block  <steveblock@google.com>

        Reviewed by Adam Barth.

        Renames WebCore/bridge/runtime.[cpp|h] to WebCore/bridge/Bridge.[cpp|h]
        https://bugs.webkit.org/show_bug.cgi?id=33801

        * Plugins/Hosted/ProxyInstance.h:

2010-01-18  Enrica Casucci  <enrica@apple.com>

        Reviewed by Darin Adler.

        Script attributes are copied and pasted, making cross-domain attacks possible (30019)
        <rdar://problem/6008809>
        https://bugs.webkit.org/show_bug.cgi?id=30019

        * WebView/WebFrame.mm:
        (-[WebFrame _documentFragmentWithMarkupString:baseURLString:]): Modified the call to createMarkupString.

2010-01-18  Steve Falkenburg  <sfalken@apple.com>

        Rubber-stamped by Sam Weinig.

        Add missing export for Geolocation.

        * WebKit.exp:

2010-01-18  Adam Roben  <aroben@apple.com>

        Add +[WebView _setDomainRelaxationForbidden:forURLScheme:]

        WebKit/mac part of fixing <http://webkit.org/b/33806>
        <rdar://problem/7552837> Would like API to disallow setting of
        document.domain for pages with certain URL schemes

        Reviewed by Sam Weinig.

        * WebView/WebView.mm:
        (+[WebView _setDomainRelaxationForbidden:forURLScheme:]):
        * WebView/WebViewPrivate.h:
        Added. Calls through to SecurityOrigin.

2010-01-16  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Oliver Hunt.

        Cache JS string values made from DOM strings (Dromaeo speedup)
        https://bugs.webkit.org/show_bug.cgi?id=33768
        <rdar://problem/7353576>
        
        * Plugins/Hosted/ProxyInstance.mm:
        (WebKit::ProxyInstance::stringValue): Explicitly make a String, since char*
        is now ambiguous.

2010-01-13  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Darin Adler.

        <rdar://problem/7532544>
        
        Expose new method on WebKitSystemInterface, WKGetUserToBaseCTM(), which will
        be used for a shadow drawing fix.

        * WebCoreSupport/WebSystemInterface.m:
        (InitWebCoreSystemInterface):

2010-01-13  Kevin Decker  <kdecker@apple.com>

        Reviewed by Mark Rowe.

        https://bugs.webkit.org/show_bug.cgi?id=33610
        <rdar://problem/7288546> Silverlight full screen performance problem seen on Snow Leopard.
        
        * Plugins/WebNetscapePluginView.mm:
        (-[WebNetscapePluginView _workaroundSilverlightFullScreenBug:]): Added. Work around Silverlight full screen
         performance issue by maintaining an accelerated GL pixel format. We can safely remove this at some point in
         the future when both Microsoft releases a genuine fix for 7288546 and enough Silverlight users update to the
         new Silverlight. For now, we'll distinguish older broken versions of Silverlight by asking the plug-in if it
         resolved its full screen badness.
        (-[WebNetscapePluginView _createPlugin]): Call _workaroundSilverlightFullScreenBug:YES if this is Silverlight.
        (-[WebNetscapePluginView _destroyPlugin]): Call _workaroundSilverlightFullScreenBug:NO if this is Silverlight.

2010-01-11  Mark Rowe  <mrowe@apple.com>

        Reviewed by Darin Adler.

        <rdar://problem/7512726> Flash full-screen does not work correctly with Flash 10.1 beta

        Explicitly track when the plug-in shows and hides a full-screen window to determine
        whether a plug-in is currently full-screen, rather than relying on menu bar visibility.
        This ensures that we activate the plug-in host process and client application as
        appropriate when the plug-in enters or exits full-screen.

        * Plugins/Hosted/NetscapePluginHostProxy.h:
        (WebKit::NetscapePluginHostProxy::isFullScreenWindowShowing):
        * Plugins/Hosted/NetscapePluginHostProxy.mm:
        (WebKit::NetscapePluginHostProxy::NetscapePluginHostProxy):
        (WebKit::NetscapePluginHostProxy::setMenuBarVisible):
        (WebKit::NetscapePluginHostProxy::didEnterFullScreen):
        (WebKit::NetscapePluginHostProxy::didExitFullScreen):
        (WebKit::NetscapePluginHostProxy::setFullScreenWindowIsShowing):
        (WKPCSetMenuBarVisible):
        (WKPCSetFullScreenWindowIsShowing):
        * Plugins/Hosted/WebKitPluginClient.defs:

2010-01-11  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Kevin Decker.

        https://bugs.webkit.org/show_bug.cgi?id=33455
        Allows plugins to participate in accelerated compositing

        * Plugins/Hosted/WebHostedNetscapePluginView.mm:
        (-[WebHostedNetscapePluginView createPlugin]):
        * Plugins/WebNetscapePluginView.mm:
        (-[WebNetscapePluginView createPlugin]): If accelerated compositing is
        available, don't use a layer-backed NSView for plugins. Instead, tickle the
        accelerated compositing code via setNeedsStyleRecalc(SyntheticStyleChange),
        which will parent the plugin's layer in the accelerated compositing layer
        tree.

2010-01-09  Adam Barth  <abarth@webkit.org>

        Reviewed by Darin Adler.

        ScriptController::isEnabled needs to be renamed
        https://bugs.webkit.org/show_bug.cgi?id=32063

        Rename ScriptController::isEnabled to
        ScriptController::canExecuteScripts.

        * Plugins/Hosted/NetscapePluginInstanceProxy.mm:
        (WebKit::NetscapePluginInstanceProxy::getWindowNPObject):
        (WebKit::NetscapePluginInstanceProxy::demarshalValueFromArray):

2010-01-07  Daniel Bates  <dbates@rim.com>

        Reviewed by Eric Seidel.

        https://bugs.webkit.org/show_bug.cgi?id=32987

        Added ENABLE_XHTMLMP flag. Disabled by default.

        * Configurations/FeatureDefines.xcconfig:

2010-01-07  Alexey Proskuryakov  <ap@apple.com>

        More build fix.

        * WebKitPrefix.h: Define JS_EXPORTCLASS here, as well (as empty).

2010-01-07  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Simon Fraser.

        REGRESSION (r48075): Clicking and dragging in a widget's text field doesn't create a selection; drags widget instead ( Translation, Weather, Ski Report )
        https://bugs.webkit.org/show_bug.cgi?id=33348
        <rdar://problem/7310616>
        
        * WebView/WebView.mm:
        (-[WebView _preferencesChangedNotification:]): We only want to
        handle file: URLs for the user stylesheet now, so special-case the
        DashboardClient's funky user stylesheet URL by mapping it to the
        equivalent file URL.

2010-01-07  Kevin Decker  <kdecker@apple.com>

        Reviewed by Simon Fraser.

        https://bugs.webkit.org/show_bug.cgi?id=33331   
        (WebHostedNetscapePluginView should pass acceleratedCompositingEnabled bool to NetscapePluginHostManager when instantiating plug-ins)
        
        * Plugins/Hosted/NetscapePluginHostManager.h: Modify method signature for instantiatePlugin to include acceleratedCompositingEnabled bool.
        * Plugins/Hosted/NetscapePluginHostManager.mm:
        (WebKit::NetscapePluginHostManager::instantiatePlugin):
        * Plugins/Hosted/WebHostedNetscapePluginView.mm:
        (-[WebHostedNetscapePluginView createPlugin]): Pass accelerated compositing status to NetscapePluginHostManage

2010-01-06  Kevin Decker  <kdecker@apple.com>

        Reviewed by Simon Fraser.

        Third step of:
        <rdar://problem/6398111> Integrate hardware layers with out-of-process plug-ins layer hosting mechanism

        * Plugins/WebNetscapePluginView.mm:
        (-[WebNetscapePluginView getVariable:value:]): Add case for WKNVSupportsCompositingCoreAnimationPluginsBool.

2010-01-06  Kevin Decker  <kdecker@apple.com>

        Reviewed by Simon Fraser.

        Second step of:
        <rdar://problem/6398111> Integrate hardware layers with out-of-process plug-ins layer hosting mechanism

        * Plugins/Hosted/WebHostedNetscapePluginView.h: Expose the CALayer of the plugin by adding -pluginLayer method.
        * Plugins/Hosted/WebHostedNetscapePluginView.mm:
        (-[WebHostedNetscapePluginView pluginLayer]): Added.
        * Plugins/WebNetscapePluginView.h: Expose the CALayer of the plugin by adding -pluginLayer method.
        * Plugins/WebNetscapePluginView.mm:
        (-[WebNetscapePluginView pluginLayer]): Added.

2010-01-06  Kevin Decker  <kdecker@apple.com>

        Reviewed by Eric Carlson.

        First step toward:
        <rdar://problem/6398111> Integrate hardware layers with out-of-process plug-ins layer hosting mechanism
        
        Small refactoring moving the PluginWidget class from WebKit to WebCore.

        * WebCoreSupport/WebFrameLoaderClient.mm: Use the WebCore version of PluginWidget.

2010-01-05  Dan Bernstein  <mitz@apple.com>

        Reviewed by Mark Rowe.

        Re-enable plug-in halting on Mac after r51953

        * WebCoreSupport/WebPluginHalterClient.mm:
        (WebPluginHalterClient::enabled): Test for the correct selector.

2010-01-04  Dan Bernstein  <mitz@apple.com>

        Reviewed by Ada Chan and Mark Rowe.

        Updated copyright string

        * Info.plist:

2009-12-27  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Alexey Proskuryakov.

        plugins/get-url-with-iframe-target.html fails on SnowLeopard (64-bit)
        https://bugs.webkit.org/show_bug.cgi?id=32982
        
        This test has been failing on SnowLeopard since it was landed.
        
        The problem is that we never delivered the notification for
        NPN_GetURLNotify, in the frame-targeting case, for out-of-process
        plugins on Mac.
        
        I implemented support for this based on how in-process Mac plugins
        do it.

        * Plugins/Hosted/HostedNetscapePluginStream.h:
        * Plugins/Hosted/HostedNetscapePluginStream.mm:
        (WebKit::HostedNetscapePluginStream::reasonForError):
        * Plugins/Hosted/NetscapePluginInstanceProxy.h:
        * Plugins/Hosted/NetscapePluginInstanceProxy.mm:
        (WebKit::NetscapePluginInstanceProxy::PluginRequest::create):
        (WebKit::NetscapePluginInstanceProxy::PluginRequest::PluginRequest):
        (WebKit::NetscapePluginInstanceProxy::destroy):
        (WebKit::NetscapePluginInstanceProxy::performRequest):
        (WebKit::NetscapePluginInstanceProxy::webFrameDidFinishLoadWithReason):
        (WebKit::NetscapePluginInstanceProxy::requestTimerFired):
        (WebKit::NetscapePluginInstanceProxy::loadRequest):
        * Plugins/Hosted/WebHostedNetscapePluginView.h:
        * Plugins/Hosted/WebHostedNetscapePluginView.mm:
        (-[WebHostedNetscapePluginView webFrame:didFinishLoadWithReason:]):
        (-[WebHostedNetscapePluginView webFrame:didFinishLoadWithError:]):

2009-12-22  Darin Adler  <darin@apple.com>

        Reviewed by Mark Rowe.

        Turn off datagrid by default, at least for all platforms Apple ships.
        The datagrid implementation isn't ready for general web use yet.

        * Configurations/FeatureDefines.xcconfig: Turn off datagrid by default.

2009-12-21  Mark Rowe  <mrowe@apple.com>

        Reviewed by Sam Weinig.

        Don't allocate a WebGeolocationControllerClient unless that compile-time setting is enabled.

        * WebView/WebView.mm:
        (-[WebView _commonInitializationWithFrameName:groupName:usesDocumentViews:]):

2009-12-18  Sam Weinig  <sam@webkit.org>

        Reviewed by Dan Bernstein.

        Add Mac WebKit side of the client based geolocation provider.

        * Misc/WebKitErrors.m:
        (registerErrors): Add Geolocation errors.
        * Misc/WebKitErrorsPrivate.h:
        * WebCoreSupport/WebGeolocationControllerClient.h: Added.
        (WebGeolocationControllerClient::webView):
        * WebCoreSupport/WebGeolocationControllerClient.mm: Added.
        (WebGeolocationControllerClient::WebGeolocationControllerClient):
        (WebGeolocationControllerClient::startUpdating):
        (WebGeolocationControllerClient::stopUpdating):
        (WebGeolocationControllerClient::lastPosition):
        Add implementation of the WebGeolocationControllerClient.

        * WebView/WebGeolocationPosition.h: Added.
        * WebView/WebGeolocationPosition.mm: Added.
        (-[WebGeolocationPositionInternal initWithCoreGeolocationPosition:]):
        (core):
        (-[WebGeolocationPosition initWithTimestamp:latitude:longitude:accuracy:]):
        * WebView/WebGeolocationPositionInternal.h: Added.
        Add an Objective-C wrapper for GeolocationPosition.
 
        * WebView/WebView.mm:
        (-[WebView _commonInitializationWithFrameName:groupName:usesDocumentViews:]): Set the GeolocationControllerClient.
        (-[WebView _setGeolocationProvider:]): Set the GeolocationProvider
        (-[WebView _geolocationProvider]): Return the GeolocationProvider.
        (-[WebView _geolocationDidChangePosition:]): Notify WebCore that the position changed.
        (-[WebView _geolocationDidFailWithError:]): Notify WebCore that an error occured.
        * WebView/WebViewData.h:
        * WebView/WebViewPrivate.h:

2009-12-18  Eric Seidel  <eric@webkit.org>

        Reviewed by Adam Barth.

        REGRESSION(52325) Chromium build broken due to link failure
        https://bugs.webkit.org/show_bug.cgi?id=32753

        * WebCoreSupport/WebSystemInterface.m:
         - Chromium Mac builds use this file, but do not
           enable Pre-compiled Header (PCH) files so that
           Chromium build bots can take advantage of the faster
           distcc 3.  Eventually all mac builds will likely use
           distcc, but for now we'll add Platform.h here and document
           its usage so it's not removed by accident.

2009-12-18  Sam Weinig  <sam@webkit.org>

        Reviewed by Anders Carlsson.

        Fix preference key name.

        * WebView/WebPreferenceKeysPrivate.h:

2009-12-18  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        Pass preference to plug-in host.

        * Plugins/Hosted/NetscapePluginHostManager.mm:
        (WebKit::NetscapePluginHostManager::spawnPluginHost):

2009-12-18  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        Add WKPCRunSyncOpenPanel implementation.

        * Plugins/Hosted/NetscapePluginHostProxy.mm:
        (WKPCRunSyncOpenPanel):
        * Plugins/Hosted/WebKitPluginClient.defs:
        * Plugins/Hosted/WebKitPluginHost.defs:

2009-12-18  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        Add a useProxiedOpenPanel WebPreference and tunnel it through to the plug-in host.

        * Plugins/Hosted/NetscapePluginHostManager.h:
        * Plugins/Hosted/NetscapePluginHostManager.mm:
        (WebKit::NetscapePluginHostManager::hostForPackage):
        (WebKit::NetscapePluginHostManager::spawnPluginHost):
        (WebKit::NetscapePluginHostManager::instantiatePlugin):
        * WebView/WebPreferenceKeysPrivate.h:
        * WebView/WebPreferences.mm:
        (+[WebPreferences initialize]):
        (-[WebPreferences usesProxiedOpenPanel]):
        (-[WebPreferences setUsesProxiedOpenPanel:]):
        * WebView/WebPreferencesPrivate.h:

2009-12-18  Sam Weinig  <sam@webkit.org>

        Reviewed by Anders Carlsson.

        Update WebKitSystemInterface for <rdar://problem/7237059>.        

        * WebCoreSupport/WebSystemInterface.m:
        (InitWebCoreSystemInterface):

2009-12-18  Adam Roben  <aroben@apple.com>

        Add #includes needed after WebCore clean-up

        Rubber-stamped by Anders Carlsson.

        Fixes <http://webkit.org/b/32718>.

        * WebView/WebFrame.mm:
        * WebView/WebFrameView.mm:
        * WebView/WebView.mm:

2009-12-17  Adam Roben  <aroben@apple.com>

        Mac build fix

        * WebView/WebVideoFullscreenController.mm: Added now-needed #import.

2009-12-13  Sam Weinig  <sam@webkit.org>

        Reviewed by Dan Bernstein.

        Fix for https://bugs.webkit.org/show_bug.cgi?id=32499
        Add client based Geolocation provider

        Add first cut of a client based Geolocation provider. This is guarded by
        ENABLE(CLIENT_BASED_GEOLOCATION) and is off by default for now. This adds a
        GeolocationControllerClient interface that no-one currently implements,
        but will in a subsequent patch.

        * WebView/WebView.mm:
        (-[WebView _commonInitializationWithFrameName:groupName:usesDocumentViews:]):

2009-12-10  Jon Honeycutt  <jhoneycutt@apple.com>

        Mac build fix. Unreviewed.

        Re-adds code that was mistakenly removed from my last patch.

        * WebCoreSupport/WebPluginHalterClient.mm:
        Add necessary #import.

        * WebView/WebDelegateImplementationCaching.h:
        Declare a new overload of CallUIDelegateReturningBoolean.

        * WebView/WebDelegateImplementationCaching.mm:
        (CallDelegateReturningBoolean):
        Add a new overload with different arguments.
        (CallUIDelegateReturningBoolean):
        Ditto.

2009-12-10  Jon Honeycutt  <jhoneycutt@apple.com>

        Pass more information about a plug-in to the PluginHalterDelegate

        Reviewed by Adam Roben.

        * Plugins/WebBaseNetscapePluginView.mm:
        (WebHaltablePlugin::isWindowed):
        Return false - the Mac doesn't really have windowed plug-ins.
        (WebHaltablePlugin::pluginName):
        Return the name from the plug-in package.

        * WebCoreSupport/WebPluginHalterClient.h:
        Update for new parameters.

        * WebCoreSupport/WebPluginHalterClient.mm:
        (WebPluginHalterClient::shouldHaltPlugin):
        Ditto; pass them when making the delegate call.

        * WebView/WebUIDelegatePrivate.h:
        Update for new parameters.

2009-12-08  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Dan Bernstein.

        <rdar://problem/7295070> WebKit video fullscreen keeps playing after closing the window
        
        Fix a leak of the QTMovieView when exiting fullscreen video, and remove the
        old workaround.

        * WebView/WebVideoFullscreenController.mm:
        (-[WebVideoFullscreenController windowDidLoad]): Set the movie view as the contentView directly.
        (-[WebVideoFullscreenController setMediaElement:WebCore::]): Cast the contentView to a movie view.
        (-[WebVideoFullscreenController windowDidExitFullscreen]): Remove the old workaround.

2009-12-08  Dmitry Titov  <dimich@chromium.org>

        Rubber-stamped by David Levin.

        Revert and reopen "Add asserts to RefCounted to make sure ref/deref happens on the right thread."
        It may have caused massive increase of reported leaks on the bots.
        https://bugs.webkit.org/show_bug.cgi?id=31639

        * ForwardingHeaders/wtf/ThreadVerifier.h: Removed.

2009-12-08  Dmitry Titov  <dimich@chromium.org>

        Reviewed by Darin Adler.

        Add asserts to RefCounted to make sure ref/deref happens on the right thread.
        https://bugs.webkit.org/show_bug.cgi?id=31639

        * ForwardingHeaders/wtf/ThreadVerifier.h: Added.

2009-12-07  Dmitry Titov  <dimich@chromium.org>

        Rubber-stamped by Darin Adler.

        Remove ENABLE_SHARED_SCRIPT flags
        https://bugs.webkit.org/show_bug.cgi?id=32245
        This patch was obtained by "git revert" command and then un-reverting of ChangeLog files.

        * Configurations/FeatureDefines.xcconfig:

2009-12-07  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Darin Adler.

        <rdar://problem/7450481> One compositing test keeps DRT in "compositing mode", breaks repaint tests

        The counter that WebView used to keep track of the number of enclosed WebHTMLViews using
        accelerated compositing was hard to manage, and maintained incorrectly in a number of cases.
        This caused one compositing test make DumpRenderTree think that all subsequent tests
        were compositing too.
        
        Replace this counter with notifications, which are only fired if a client (DRT) requests them. The
        notification informs the client that a WebHTMLView entered compositing mode (or an already-
        compositing WebHTML was added); it does not say when a view becomes uncomposited, or all
        compositing subviews were removed, since this is tricky to get right.
        
        Change -[WebView _isUsingAcceleratedCompositing] to manually walk the frames, and
        return YES if any document view is composited.

        * WebKit.exp:
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView close]):
        (-[WebHTMLView viewDidMoveToSuperview]):
        (-[WebHTMLView attachRootLayer:]):
        (-[WebHTMLView detachRootLayer]):
        * WebView/WebView.mm:
        (+[WebView automaticallyNotifiesObserversForKey:]):
        (-[WebView _postsAcceleratedCompositingNotifications]):
        (-[WebView _setPostsAcceleratedCompositingNotifications:]):
        (-[WebView _isUsingAcceleratedCompositing]):
        * WebView/WebViewData.h:
        * WebView/WebViewInternal.h:
        * WebView/WebViewPrivate.h:

2009-12-07  Gavin Barraclough  <barraclough@apple.com>

        Reviewed by Oliver Hunt.

        https://bugs.webkit.org/show_bug.cgi?id=32184
        Handle out-of-memory conditions with JSC Ropes with a JS exception, rather than crashing.
        Switch from using fastMalloc to tryFastMalloc, pass an ExecState to record the exception on.

        * WebView/WebView.mm:
        (aeDescFromJSValue):

2009-12-07  Nikolas Zimmermann  <nzimmermann@rim.com>

        Reviewed by Holger Hans Peter Freyther.

        Turn on (SVG) Filters support, by default.
        https://bugs.webkit.org/show_bug.cgi?id=32224

        * Configurations/FeatureDefines.xcconfig: Enable FILTERS build flag.

2009-12-03  Brady Eidson  <beidson@apple.com>

        Reviewed by Sam Weinig.

        <rdar://problem/7214236> and http://webkit.org/b/32052 - Implement HTML5 state object history API

        * WebCoreSupport/WebFrameLoaderClient.h:
        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::dispatchDidPushStateWithinPage):
        (WebFrameLoaderClient::dispatchDidReplaceStateWithinPage):
        (WebFrameLoaderClient::dispatchDidPopStateWithinPage):
        * WebView/WebDelegateImplementationCaching.h:
        * WebView/WebFrameLoadDelegatePrivate.h:
        * WebView/WebView.mm:
        (-[WebView _cacheFrameLoadDelegateImplementations]):

2009-12-03  Pavel Feldman  <pfeldman@dhcp-172-28-174-220.spb.corp.google.com>

        Reviewed by Timothy Hatcher.

        Web Inspector: Simplify the settings support in inspector controller.

        https://bugs.webkit.org/show_bug.cgi?id=32076

        * WebCoreSupport/WebInspectorClient.h:
        * WebCoreSupport/WebInspectorClient.mm:
        (-[WebInspectorWindowController showWindow:]):
        (-[WebInspectorWindowController attach]):
        (-[WebInspectorWindowController detach]):

2009-12-03  Ben Murdoch  <benm@google.com>

        Reviewed by Brady Eidson.

        [Android] notifyHistoryItemChanged() should pass a pointer to the HistoryItem that changed.
        https://bugs.webkit.org/show_bug.cgi?id=31915

        * History/WebHistoryItem.mm:
        (WKNotifyHistoryItemChanged): Update WKNotifyHistoryItemChanged() to add the new HistoryItem parameter added in the WebCore portion of this patch.
        * History/WebHistoryItemInternal.h: ditto.

2009-12-03  Ben Murdoch  <benm@google.com>

        Reviewed by Brady Eidson.

        [Android] The FrameLoaderClient is unaware of BackForwardList changes.
        https://bugs.webkit.org/show_bug.cgi?id=31914

        * WebCoreSupport/WebFrameLoaderClient.h:
        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::dispatchDidAddBackForwardItem): Add an empty implementation. Method added to FrameLoaderClient by Android (see bug).
        (WebFrameLoaderClient::dispatchDidRemoveBackForwardItem): ditto.
        (WebFrameLoaderClient::dispatchDidChangeBackForwardIndex): ditto.

2009-12-02  Dan Bernstein  <mitz@apple.com>

        Reviewed by Mark Rowe.

        Fix a mistake in the previous change

        * WebView/WebView.mm:
        (+[WebView _viewClass:andRepresentationClass:forMIMEType:allowingPlugins:]):
        Make sure to include the image types’ view and representation classes
        even when plug-ins are not allowed.

2009-12-02  Dan Bernstein  <mitz@apple.com>

        Reviewed by Anders Carlsson.

        Fixed <rdar://problem/7254127> WebKit can load plug-ins even when
        plug-ins are disabled

        Ensure that the shared WebPluginDatabase is not instantiated if no
        WebViews are used that have plug-ins enabled.

        * DefaultDelegates/WebDefaultPolicyDelegate.m:
        (-[WebDefaultPolicyDelegate webView:decidePolicyForMIMEType:request:frame:decisionListener:]):
        Call -[WebView _canShowMIMEType:] on the WebView instead of calling the
        class method.

        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::canShowMIMEType): Ditto.
        (WebFrameLoaderClient::transitionToCommittedForNewPage): Call
        -[WebFrameView _viewClassForMIMEType:] on the WebView instead of calling
        the class method.
        (WebFrameLoaderClient::objectContentType): Ditto.

        * WebView/WebDataSource.mm:
        (+[WebDataSource _representationClassForMIMEType:allowingPlugins:]):
        Added the allowPlugins parameter, which is passed through to
        +[WebView _viewClass:andRepresentationClass:forMIMEType:allowingPlugins:].
        (-[WebDataSource _makeRepresentation]): Pass an allowPlugins value
        based on the WebView’s preferences.

        * WebView/WebFrameView.mm:
        (-[WebFrameView _makeDocumentViewForDataSource:]): Call
        -[WebFrameView _viewClassForMIMEType:] instead of calling the class
        method.
        (+[WebFrameView _viewClassForMIMEType:allowingPlugins:]): Added the
        allowPlugins parameter, which is passed through to
        +[WebView _viewClass:andRepresentationClass:forMIMEType:allowingPlugins:].
        (-[WebFrameView _viewClassForMIMEType:]): Added. Passes an allowPlugins
        value based on the WebView’s preferences.

        * WebView/WebFrameViewInternal.h:
        * WebView/WebView.mm:
        (+[WebView _viewClass:andRepresentationClass:forMIMEType:allowingPlugins:]):
        Added the allowPlugins parameter. If false, skip the instantiation of
        the shared WebPluginDatabase.
        (-[WebView _viewClass:andRepresentationClass:forMIMEType:]): Pass an
        allowPlugins value based on the WebView’s preferences.
        (+[WebView _canShowMIMEType:allowingPlugins:]): Passes allowPlugins to
        +_viewClass:andRepresentationClass:forMIMEType:allowingPlugins:.
        (+[WebView canShowMIMEType:]): Changed to pass YES to
        +_canShowMIMEType:allowingPlugins:.
        (-[WebView _canShowMIMEType:]): Added. Passes an allowPlugins value
        based on the WebView’s preferences.
        (-[WebView _pluginForMIMEType:]): Return nil if plug-ins are disabled.
        (-[WebView _pluginForExtension:]): Ditto.
        (-[WebView _isMIMETypeRegisteredAsPlugin:]): Return NO if plug-ins are
        disabled.
        * WebView/WebViewInternal.h:

2009-12-02  Timothy Hatcher  <timothy@apple.com>

        Fixes a crash when scrolling a frame that goes away mid-scroll.

        <rdar://problem/7400263>

        Reviewed by John Sullivan.

        * WebView/WebDynamicScrollBarsView.mm:
        (-[WebDynamicScrollBarsView scrollWheel:]): Retain self incase the last
        reference is released when calling super.

2009-11-13  Timothy Hatcher  <timothy@apple.com>

        Migrate DOMHTMLInputElementPrivate.h as a private header.

        Reviewed by Darin Adler.

        * MigrateHeaders.make:

2009-12-01  Nikolas Zimmermann  <nzimmermann@rim.com>

        Reviewed by Simon Fraser.

        Add SVG animation test framework with 'snapshot' functionality
        https://bugs.webkit.org/show_bug.cgi?id=31897

        Add API used by the new 'sampleSVGAnimationForElementAtTime' DRT method,
        forwarding the call to SVGDocumentExtensions, if SVG is enabled.

        Implemented just like the existing pauseAnimation* methods for CSS animations.

        * WebView/WebFrame.mm:
        (-[WebFrame _pauseSVGAnimation:onSMILNode:atTime:]):
        * WebView/WebFramePrivate.h:

2009-12-01  Sam Weinig  <sam@webkit.org>

        Reviewed by Mark Rowe.

        Simplify [WebView userAgentForURL:].  No need to call into helper function.

        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::userAgent):
        * WebView/WebView.mm:
        (-[WebView userAgentForURL:]):
        * WebView/WebViewInternal.h:

2009-11-24  Gavin Barraclough  <barraclough@apple.com>

        Reviewed by Geoff Garen.

        Bug 31859 - Make world selection for JSC IsolatedWorlds automagical.

        WebCore presently has to explicitly specify the world before entering into JSC,
        which is a little fragile (particularly since property access via a
        getter/setter might invoke execution). Instead derive the current world from
        the lexical global object.

        Since WebCore no longer needs to explicitly specify the world on entry to JSC DebuggerCallFrame::evaluate can be called directly.

        * WebView/WebScriptDebugDelegate.mm:
        (-[WebScriptCallFrame evaluateWebScript:]):

2009-11-24  Dmitry Titov  <dimich@chromium.org>

        Reviewed by Eric Seidel.

        Add ENABLE_SHARED_SCRIPT feature define and flag for build-webkit
        https://bugs.webkit.org/show_bug.cgi?id=31444

        * Configurations/FeatureDefines.xcconfig:

2009-11-24  Alexey Proskuryakov  <ap@apple.com>

        Reviewed by Brady Eidson.

        https://bugs.webkit.org/show_bug.cgi?id=31844
        SocketStreamHandleCFNet should support CONNECT proxy credentials

        * WebCoreSupport/WebSystemInterface.m: (InitWebCoreSystemInterface): Add WKSI methods.

2009-11-23  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Dan Bernstein.

        DocumentMarkers need to be educated about transforms
        https://bugs.webkit.org/show_bug.cgi?id=31751
        
        Find highlight is incorrect with transforms
        <rdar://problem/6358394>
        
        Allow callers to specify that Frame::selectionTextRects() takes transforms into account
        when computing the set of rects that encompass a selection. For transformed elemenets, the
        selection rect will be the bounding box of the selected content.
        
        Fix DocumentMarkers to cache rects in absolute coordinates, rather than painting coordinates.
        
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView selectionTextRects]):
        Pass RespectTransforms to get a list of rects with transforms taken into account.

2009-11-23  Kevin Decker  <kdecker@apple.com>

        Reviewed by Adam Roben.
        
        <rdar://problem/7401503>
        
        Added a workaround for plug-ins not drawing immediately.
        
        * Plugins/WebBaseNetscapePluginView.mm: Added new constant.
        (-[WebBaseNetscapePluginView _clearSubstituteImage]): Added.
        (-[WebBaseNetscapePluginView resumeFromHalt]): Call above new method.

2009-11-20  Dave Hyatt  <hyatt@apple.com>

        Reviewed by Darin Adler.

        Make sure to export WebSerializedJSValue.

        * WebKit.exp:

2009-11-20  Dave Hyatt  <hyatt@apple.com>

        Reviewed by Oliver Hunt and Jon Honeycutt.

        Add support for WebSerializedJSValue to WebKit.  This object wraps the SerializedScriptValue functionality in WebCore
        and exposes the ability to do JS value serialization/deserialization to WebKit clients.

        * WebView/WebSerializedJSValue.h: Added.
        * WebView/WebSerializedJSValue.mm: Added.
        (-[WebSerializedJSValue initWithValue:context:]):
        (-[WebSerializedJSValue deserialize:]):
        (-[WebSerializedJSValue dealloc]):

2009-11-20  Chris Fleizach  <cfleizach@apple.com>

        Reviewed by Beth Dakin.

        WAI-ARIA: add support for 'math' role
        https://bugs.webkit.org/show_bug.cgi?id=31706

        * WebCoreSupport/WebViewFactory.mm:
        (-[WebViewFactory AXARIAContentGroupText:]):

2009-11-19  Eric Carlson  <eric.carlson@apple.com>

        Reviewed by Dan Bernstein.

        <rdar://problem/7035231>
        Support closed caption in <video> element

        * WebCoreSupport/WebSystemInterface.m:
        (InitWebCoreSystemInterface):
            Add QTMovieHasClosedCaptions and QTMovieSetShowClosedCaptions.

        * WebCoreSupport/WebViewFactory.mm:
        (-[WebViewFactory localizedMediaControlElementString:]):
        (-[WebViewFactory localizedMediaControlElementHelpText:]):
            Add accessibility help strings for media controller closed caption button.

2009-11-18  Michelangelo De Simone  <micdesim@gmail.com>

        Reviewed by Darin Adler.

        Fix for <https://bugs.webkit.org/show_bug.cgi?id=27959>.
        Support for validationMessage attribute, as per HTML5 specs.

        * WebCoreSupport/WebViewFactory.mm:
        (-[WebViewFactory validationMessageValueMissingText]):
        (-[WebViewFactory validationMessageTypeMismatchText]):
        (-[WebViewFactory validationMessagePatternMismatchText]):
        (-[WebViewFactory validationMessageTooLongText]):
        (-[WebViewFactory validationMessageRangeUnderflowText]):
        (-[WebViewFactory validationMessageRangeOverflowText]):
        (-[WebViewFactory validationMessageStepMismatchText]):

2009-11-18  Sam Weinig  <sam@webkit.org>

        Reviewed by Anders Carlsson.

        Make the Mac Geolocation API async.

        * WebCoreSupport/WebChromeClient.mm:
        (WebChromeClient::requestGeolocationPermissionForFrame):
        (-[WebGeolocationPolicyListener initWithGeolocation:]):
        (-[WebGeolocationPolicyListener allow]):
        (-[WebGeolocationPolicyListener deny]):
        Add WebGeolocationPolicyListener implementation of the new WebGeolocationPolicyListener
        protocol and use if to implement requestGeolocationPermissionForFrame using the new async
        API.
        
        * WebCoreSupport/WebGeolocation.mm: Removed.
        * WebCoreSupport/WebGeolocationInternal.h: Removed.
        * WebCoreSupport/WebGeolocationMock.mm: Remove bogus include.
        * WebCoreSupport/WebGeolocationPrivate.h: Removed.
        * WebView/WebUIDelegatePrivate.h: Remove requestGeolocationPermission and add
        WebGeolocationPolicyListener protocol and decidePolicyForGeolocationRequestFromOrigin delegate
        method.

2009-11-18  Chris Marrin  <cmarrin@apple.com>

        Reviewed by Simon Fraser.

        Add Preferences for WebKitShowDebugBorders and WebKitShowRepaintCounter
        https://bugs.webkit.org/show_bug.cgi?id=31601

        These are used to debug accelerated compositing layers

        * WebView/WebPreferenceKeysPrivate.h:
        * WebView/WebPreferences.mm:
        (+[WebPreferences initialize]):
        (-[WebPreferences showDebugBorders]):
        (-[WebPreferences setShowDebugBorders:]):
        (-[WebPreferences showRepaintCounter]):
        (-[WebPreferences setShowRepaintCounter:]):
        * WebView/WebPreferencesPrivate.h:
        * WebView/WebView.mm:
        (-[WebView _preferencesChangedNotification:]):

2009-11-17  Pavel Feldman  <pfeldman@chromium.org>

        Reviewed by Timothy Hatcher.

        Web Inspector: Make DRT show web inspector for tests in inspector/ folder.
        - Updated DRT to show/close inspector for all tests under /inspector
        - Introduced LayoutTestController::setTimelineProfilingEnabled and
          WebInspector::setTimelineProfilingEnabled beside setJavaScriptProfilingEnabled
        - Removed reload on each inspector test
        - Renamed fast/inspector to fast/inspector-support in order not to trigger
        inspector for those.
        - Reimplemented timeline tests in order to get rid of reload there.
        - Moved tests that don't require harness into the fast group.

        https://bugs.webkit.org/show_bug.cgi?id=31472

        * WebInspector/WebInspector.h:
        * WebInspector/WebInspector.mm:
        (-[WebInspector isTimelineProfilingEnabled]):
        (-[WebInspector setTimelineProfilingEnabled:]):

2009-11-14  Chris Fleizach  <cfleizach@apple.com>

        Reviewed by Darin Adler.

        Need to implement ARIA role="directory"
        https://bugs.webkit.org/show_bug.cgi?id=31516

        Fix a spelling error in the comment of a localized (accessibility) string.

        * WebCoreSupport/WebViewFactory.mm:
        (-[WebViewFactory AXARIAContentGroupText:]):

2009-11-14  Eric Carlson  <eric.carlson@apple.com>

        Reviewed by Oliver Hunt.

        <rdar://problem/7287487> 
        Do not use QuickTime version to detect media controller theme

        * WebCoreSupport/WebSystemInterface.m:
        (InitWebCoreSystemInterface): Initialize wkMediaControllerThemeAvailable.

2009-11-13  Adam Roben  <aroben@apple.com>

        Tell the WebFrameLoadDelegate when window objects in isolated worlds
        are cleared

        Fixes <http://webkit.org/b/31124>.

        Reviewed by Dave Hyatt.

        * WebCoreSupport/WebFrameLoaderClient.h:
        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::dispatchDidClearWindowObjectInWorld):
        Replaced windowObjectCleared with this function. If the delegate
        implements it, call
        -webView:didClearWindowObjectForFrame:inScriptWorld:. Otherwise, if
        the passed-in world is the mainThreadNormalWorld(), call
        -webView:didClearWindowObject:forFrame:.

        * WebView/WebDelegateImplementationCaching.h: Added a new entry in the
        frame load delegate implementation cache for the new delegate method.

        * WebView/WebFrameLoadDelegatePrivate.h:
        * WebView/WebScriptWorld.mm:
        (allWorlds): Added. Returns a HashMap of all the WebScriptWorlds in
        existence.
        (-[WebScriptWorld initWithWorld:]): Add ourselves to allWorlds().
        (-[WebScriptWorld dealloc]): Remove ourselves from allWorlds().
        (+[WebScriptWorld findOrCreateWorld:]): Returns the existing
        WebScriptWorld for this DOMWrapperWorld, or a new one if one doesn't
        already exist.

        * WebView/WebScriptWorldInternal.h: Declared +findOrCreateWorld:.

        * WebView/WebView.mm:
        (-[WebView _cacheFrameLoadDelegateImplementations]): Cache the
        implementation of the new frame load delegate method.

2009-11-13  Adam Roben  <aroben@apple.com>

        Finish replacing worldIDs with world objects

        The only remaining use of worldIDs was in a method only used by DRT
        for the isolated worlds tests.

        Fixes <http://webkit.org/b/31414> Replace worldIDs with world objects

        Reviewed by Mark Rowe.

        * WebView/WebFrame.mm:
        (-[WebFrame _stringByEvaluatingJavaScriptFromString:withGlobalObject:inScriptWorld:]):
        * WebView/WebFramePrivate.h:
        Renamed from
        _stringByEvaluatingJavaScriptInIsolatedWorld:WithGobalObject:FromString:.
        Now takes a WebScriptWorld instead of a worldID, so we don't need to
        maintain a map of worldID -> world anymore.

2009-11-12  Dan Bernstein  <mitz@apple.com>

        Reviewed by Adele Peterson.

        When exiting full-screen video, rather than resetting the system UI
        mode, restore it to what it was when full-screen mode was entered.

        * WebView/WebVideoFullscreenController.h: Cleaned up style, removed
        unnecessary imports, and added _savedUIMode and _savedUIOptions ivars.
        * WebView/WebVideoFullscreenController.mm:
        (-[WebVideoFullscreenController delegate]): Cleaned up style.
        (-[WebVideoFullscreenController setDelegate:]): Ditto.
        (-[WebVideoFullscreenController windowDidExitFullscreen]): Restore the
        system UI mode.
        (-[WebVideoFullscreenController windowDidEnterFullscreen]): Save the
        system UI mode.
        * WebView/WebView.mm: Added now-necessary import.

2009-11-12  Shinichiro Hamaji  <hamaji@chromium.org>

        Reviewed by Darin Adler.

        externalRepresentation should take Frame as the argument
        https://bugs.webkit.org/show_bug.cgi?id=31393

        No new tests as this is just a refactoring.

        * Misc/WebCoreStatistics.mm:
        (-[WebFrame renderTreeAsExternalRepresentation]):

2009-11-12  Adam Roben  <aroben@apple.com>

        Replace worldIDs with world objects

        WebScriptWorld is the new object that represents a world.  The only
        place worldID is still used is in -[WebFrame
        _stringByEvaluatingJavaScriptInIsolatedWorld:WithGlobalObject:FromString:],
        but that will change soon.

        Part of <http://webkit.org/b/31414> Implement new SPI for dealing with
        user scripts/stylesheets and isolated worlds

        Reviewed by Sam Weinig.

        * WebKit.exp: Export WebScriptWorld.

        * WebView/WebFrame.mm:
        (-[WebFrame _stringByEvaluatingJavaScriptInIsolatedWorld:WithGlobalObject:FromString:]):
        Moved the bizarre world caching/creation logic that DRT depends on
        here from the findWorld function in ScriptController.cpp. Updated to
        use ScriptController::executeScriptInWorld instead of
        ScriptController::executeScriptInIsolatedWorld.
        (-[WebFrame _contextForWorld:]): Renamed from contextForWorldID:. Now
        takes a WebScriptWorld.

        * WebView/WebFramePrivate.h: Replaced contextForWorldID: with
        _contextForWorld:.

        * WebView/WebScriptWorld.h: Added.
        * WebView/WebScriptWorld.mm: Added.
        (-[WebScriptWorld initWithWorld:]): Store the passed-in world in our
        _private member.
        (-[WebScriptWorld init]): Create a new DOMWrapperWorld and pass it to
        -initWithWorld:.
        (-[WebScriptWorld dealloc]): Release _private.
        (+[WebScriptWorld standardWorld]): Returns a shared instance that
        represents WebCore's mainThreadNormalWorld().
        (+[WebScriptWorld world]): Returns a new instance.
        (core): Returns the DOMWrapperWorld for this WebScriptWorld.

        * WebView/WebScriptWorldInternal.h: Added.

        * WebView/WebView.mm:
        (+[WebView _addUserScriptToGroup:world:source:url:whitelist:blacklist:injectionTime:]):
        (+[WebView _addUserStyleSheetToGroup:world:source:url:whitelist:blacklist:]):
        (+[WebView _removeUserScriptFromGroup:world:url:]):
        (+[WebView _removeUserStyleSheetFromGroup:world:url:]):
        (+[WebView _removeUserScriptsFromGroup:world:]):
        (+[WebView _removeUserStyleSheetsFromGroup:world:]):
        * WebView/WebViewPrivate.h:
        Changed these functions to take a WebScriptWorld instead of a worldID.

2009-11-12  Chris Fleizach  <cfleizach@apple.com>

        Reviewed by Darin Adler.

        ARIA: add alert type roles
        https://bugs.webkit.org/show_bug.cgi?id=31392

        * WebCoreSupport/WebViewFactory.mm:
        (-[WebViewFactory AXARIAContentGroupText:]):

2009-11-10  Daniel Bates  <dbates@webkit.org>

        Reviewed by Oliver Hunt.

        https://bugs.webkit.org/show_bug.cgi?id=30754

        Removed method draggedImage:movedTo:

        * WebView/WebFrame.mm:
        * WebView/WebFrameInternal.h:
        * WebView/WebHTMLView.mm:

2009-11-10  Beth Dakin  <bdakin@apple.com>

        Reviewed by Darin Adler.

        Small WebKit part of:
        Fix for <rdar://problem/7059710> 
        -and corresponding-
        https://bugs.webkit.org/show_bug.cgi?id=31196 Implement -webkit-
        color-correction for CSS colors

        * Misc/WebKitNSStringExtras.mm:
        (-[NSString _web_drawAtPoint:font:textColor:]): setFillColor now 
        requires callers to pass a ColorSpace.

2009-11-10  Dan Bernstein  <mitz@apple.com>

        Reviewed by Eric Carlson and Darin Adler.

        WebKit part of making full-screen video pause during scrubbing.

        * WebView/WebVideoFullscreenHUDWindowController.h: Added _isScrubbing
        ivar.
        * WebView/WebVideoFullscreenHUDWindowController.mm:
        (-[WebVideoFullscreenHUDWindowController dealloc]): Assert that
        _isScrubbing is NO.
        (-[WebVideoFullscreenHUDWindowController endScrubbing]): Call
        HTMLMediaElement::endScrubbing().
        (-[WebVideoFullscreenHUDWindowController timelinePositionChanged:]):
        If scrubbing has just begun, call HTMLMediaElement::beginScrubbing()
        and schedule -endScrubbing to be called when mouse tracking ends.

2009-11-09  Mark Mentovai  <mark@chromium.org>

        Reviewed by Dan Bernstein.

        Track "can have scrollbar" state within FrameView independently of the
        individual scrollbar states in ScrollView.

        rdar://problem/7215132, https://bugs.webkit.org/show_bug.cgi?id=29167
        REGRESSION (r48064): mint.com loses scrollbars after coming out of
        edit mode.

        rdar://problem/7314421, https://bugs.webkit.org/show_bug.cgi?id=30517
        REGRESSION (r48064): Extra scroll bars in GarageBand Lesson Store.

        Test: fast/overflow/scrollbar-restored.html

        * WebView/WebFrameView.mm:
        (-[WebFrameView _install]):

2009-11-08  Dan Bernstein  <mitz@apple.com>

        Reviewed by Eric Carlson.

        Made the full-screen video HUD appear when playback stops, such as when
        the end of the video is reached.

        * WebView/WebVideoFullscreenHUDWindowController.h: Cleaned up.
        * WebView/WebVideoFullscreenHUDWindowController.mm:
        (-[WebVideoFullscreenHUDWindowController scheduleTimeUpdate]): Updated
        for the renaming of -updateRate to -updatePlayButton.
        (-[WebVideoFullscreenHUDWindowController updatePlayButton]): Renamed
        -updateRate to this.
        (-[WebVideoFullscreenHUDWindowController updateRate]): This method now
        responds to changes to the playback rate by updating the play button
        and showing or hiding the HUD as necessary.
        (-[WebVideoFullscreenHUDWindowController togglePlaying:]): Now only
        toggles playing. UI updates are driven by -updateRate being called.
        (-[WebVideoFullscreenHUDWindowController playing]): Cleaned up.

2009-11-02  Eric Carlson  <eric.carlson@apple.com>

        Reviewed by John Sullivan and Mark Rowe.

        <rdar://problem/7356733> Voiceover does not read correct media controller time values

        * WebCoreSupport/WebViewFactory.mm:
        (-[WebViewFactory localizedMediaTimeDescription:]):

2009-11-02  Dan Bernstein  <mitz@apple.com>

        Reviewed by Anders Carlsson.

        Made the remaining time display show negative zero at the end of the
        video.

        Made other cleanup.

        * WebView/WebVideoFullscreenHUDWindowController.h: Reverted the types of
        _timeline and _volumeSlider to the more generic NSControl.
        * WebView/WebVideoFullscreenHUDWindowController.mm:
        (-[WebVideoFullscreenHUDWindowController scheduleTimeUpdate]): Cleaned
        up style.
        (-[WebVideoFullscreenHUDWindowController windowDidLoad]): Added an
        assertion that the cast to NSButton * is legal. Removed casts.
        (-[WebVideoFullscreenHUDWindowController updateTime]): Use
        -setValue:forKey: instead of an NSSlider method.
        (timeToString): Changed to support only non-negative values and
        simplified.
        (-[WebVideoFullscreenHUDWindowController remainingTimeText]): Always
        prepend a “-” to the time.

2009-11-02  Dan Bernstein  <mitz@apple.com>

        Reviewed by John Sullivan.

        WebKit part of making the appearance of the full-screen video HUD match
        QuickTime Player X’s HUD.

        * WebView/WebVideoFullscreenHUDWindowController.h: Removed unnecessary
        #import statements, cleaned up style, and changed _timeline,
        _volumeSlider and _playButton to have more specific types.
        * WebView/WebVideoFullscreenHUDWindowController.mm: Updated #import
        statements.
        (webkit_CGFloor): Added this helper function.
        (-[WebVideoFullscreenHUDWindowController init]): Cleaned up style.
        (createTimeTextField): Changed to use the bold system font.
        (-[WebVideoFullscreenHUDWindowController windowDidLoad]): Changed the
        subviews’ metrics and the text fields’ text alignment.
        (-[WebVideoFullscreenHUDWindowController updateTime]): Avoid conversion
        from double to float.
        (stringToTimeTextAttributed): Removed this useless function that
        returned an NSAttributedString masquerading as an NSString.
        (-[WebVideoFullscreenHUDWindowController remainingTimeText]): Removed
        call to stringToTimeTextAttributed().
        (-[WebVideoFullscreenHUDWindowController elapsedTimeText]): Ditto.

2009-11-02  Chris Fleizach  <cfleizach@apple.com>

        Reviewed by Beth Dakin.

        Support ARIA "tab" roles
        https://bugs.webkit.org/show_bug.cgi?id=30842

        * WebCoreSupport/WebViewFactory.mm:
        (-[WebViewFactory AXARIAContentGroupText:]):

2009-11-01  Dan Bernstein  <mitz@apple.com>

        Reviewed by Mark Rowe.

        Made the space bar toggle playing state in full-screen video when
        modifier keys are down. Made it do so without highlighting the
        Play/Pause button.

        * WebView/WebVideoFullscreenHUDWindowController.mm:
        (-[WebVideoFullscreenHUDWindowController keyDown:]):

2009-11-01  Dan Bernstein  <mitz@apple.com>

        Reviewed by Mark Rowe.

        Made the full-screen video HUD respond to the up and down arrow keys by
        increasing and decreasing the volume by 1/10 of the range or, when
        combined with the Option key, all the way up or down.

        Made the volume buttons in the full-screen video HUD match the behavior
        of their equivalents in the QuickTime Player HUD by turning the volume
        all the way up or down.

        Made the volume slider update immediately when the keyboard or volume
        buttons are used to change the volume, rather than at the nearest 1/4
        second interval.

        Made the elapsed and remaining time displays update immediately when the
        play head is dragged across the timeline, rather than at 1/4 second
        intervals.

        * WebView/WebVideoFullscreenHUDWindowController.mm:
        (-[WebVideoFullscreenHUDWindowController keyDown:]): Handle the up and
        down arrow keys.
        (-[WebVideoFullscreenHUDWindowController windowDidLoad]): Changed the
        actions of the volume up and volume down buttons.
        (-[WebVideoFullscreenHUDWindowController setCurrentTime:]): Call
        -updateTime.
        (-[WebVideoFullscreenHUDWindowController setVolumeToZero:]): Added this
        action for the volume down button.
        (-[WebVideoFullscreenHUDWindowController setVolumeToMaximum:]): Added
        this action for the volume up button.
        (-[WebVideoFullscreenHUDWindowController decrementVolume]): No longer
        and action method.
        (-[WebVideoFullscreenHUDWindowController incrementVolume]): Ditto.
        (-[WebVideoFullscreenHUDWindowController setVolume:]): Call
        -updateVolume.

2009-10-30  Evan Stade  <estade@chromium.org>

        Reviewed by David Levin.

        Notify the chrome when the focused node has changed.
        https://bugs.webkit.org/show_bug.cgi?id=30832

        Added stub implementation for new ChromeClient function.

        * WebCoreSupport/WebChromeClient.h:
        * WebCoreSupport/WebChromeClient.mm:
        (WebChromeClient::focusedNodeChanged):

2009-10-30  Roland Steiner  <rolandsteiner@chromium.org>

        Reviewed by Eric Seidel.

        Remove ENABLE_RUBY guards as discussed with Dave Hyatt and Maciej Stachowiak.

        Bug 28420 -  Implement HTML5 <ruby> rendering
        (https://bugs.webkit.org/show_bug.cgi?id=28420)

        No new tests (no functional change).

        * Configurations/FeatureDefines.xcconfig:

2009-10-29  Mark Rowe  <mrowe@apple.com>

        Reviewed by Oliver Hunt.

        Validate the stopSpeaking: selector so that is not always enabled when a WebView is first responder.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView validateUserInterfaceItemWithoutDelegate:]):

2009-10-29  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        https://bugs.webkit.org/show_bug.cgi?id=30932
        <rdar://problem/7350269>
        
        REGRESSION: Crash when turning on Private Browsing on site with flash.
        
        Null check setValue.
        
        * Plugins/WebNetscapePluginView.mm:
        (-[WebNetscapePluginView privateBrowsingModeDidChange]):

2009-10-29  Eric Carlson  <eric.carlson@apple.com>

        Reviewed by Kevin Decker.

        Refactor some duplicate plug-in clean up code into shared functions.

        * Plugins/WebPluginController.mm:
        (-[WebPluginController stopOnePlugin:]): New, stop a plug-in.
        (-[WebPluginController destroyOnePlugin:]): New, destroy plug-in.
        (-[WebPluginController stopAllPlugins]): Call stopOnePlugin.
        (-[WebPluginController destroyPlugin:]): Call stopOnePlugin and destroyOnePlugin.
        (-[WebPluginController destroyAllPlugins]): Call destroyOnePlugin.

2009-10-28  Eric Carlson  <eric.carlson@apple.com>

        Reviewed by Simon Fraser.

        <rdar://problem/7303145> 
        Can't exit full screen mode or restart movie after pressing command -R.

        * WebView/WebVideoFullscreenController.mm:
        (-[WebVideoFullscreenController _requestExit]): 
            New, call media element's exitFullscreen method.
        (-[WebVideoFullscreenController requestExitFullscreenWithAnimation:]): 
            Call mediaElement->exitFullscreen() after a delay as it turns around and calls
            WebVideoFullscreenController:exitFullscreen.

        * WebView/WebVideoFullscreenHUDWindowController.h:
        * WebView/WebVideoFullscreenHUDWindowController.mm:
        (-[WebVideoFullscreenHUDWindow resignFirstResponder]):
            New, don't give up responder status.
        (-[WebVideoFullscreenHUDWindow performKeyEquivalent:]):
            New, block all command key events.
        (-[WebVideoFullscreenHUDWindowController exitFullscreen:]):
            Remember when we are in the process of exiting fullscreen, don't allow recursion.

        * WebView/WebView.mm:
        (-[WebView _exitFullscreen]):
            Early return if fullscreen controller is nil.

        * WebView/WebWindowAnimation.h: 
            Correct comment about _window retain status.
        * WebView/WebWindowAnimation.m:
        (-[WebWindowScaleAnimation dealloc]):
            Don't release _window, we never reatained it.

2009-10-27  Shinichiro Hamaji  <hamaji@chromium.org>

        Reviewed by Darin Adler.

        Provide a way to get counter values with layoutTestContoller
        https://bugs.webkit.org/show_bug.cgi?id=30555

        Add counterValueForElement in WebFrame to call WebCore::counterValueForElement.

        * Misc/WebCoreStatistics.h:
        * Misc/WebCoreStatistics.mm:
        (-[WebFrame counterValueForElement:]):

2009-10-27  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Sam Weinig.

        Updated for refactoring in the date code.

        * WebView/WebView.mm:
        (aeDescFromJSValue): Since we just want a number of milliseconds, do that
        instead of something more complicated.

2009-10-26  Sam Weinig  <sam@webkit.org>

        Reviewed by Anders Carlsson.

        Move some WebView event handling code into its own file, WebViewEventHandling.mm

        * WebView/WebView.mm:
        (-[WebView _close]):
        (-[WebView _selectedOrMainFrame]):
        * WebView/WebViewEventHandling.mm: Added.
        (-[WebView _closingEventHandling]):
        (-[WebView _setMouseDownEvent:]):
        (-[WebView mouseDown:]):
        (-[WebView mouseUp:]):
        (+[WebView _updateMouseoverWithEvent:]):
        (-[WebView _updateMouseoverWithFakeEvent]):
        (_updateMouseoverWithEvent:fakeEvent::if):
        (-[WebView _stopAutoscrollTimer]):
        (-[WebView _setToolTip:]):
        * WebView/WebViewInternal.h:

2009-10-26  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Sam Weinig.

        <rdar://problem/6988966> Hardware layers do not show up in page snapshots

        * WebView/WebHTMLViewPrivate.h:
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _compositingLayersHostingView]):
        Add a private method that returns the NSView used to host compositing layers.
        
2009-10-23  Mark Rowe  <mrowe@apple.com>

        Fix engineering builds in the mysterious future.

        * Configurations/DebugRelease.xcconfig:

2009-10-23  Gavin Barraclough  <barraclough@apple.com>

        Reviewed by Geoff Garen.

        https://bugs.webkit.org/show_bug.cgi?id=30729
        Provide private API to request the global context for a specific world.
        Used to initialize parameters on the global object.

        * WebView/WebFramePrivate.h:
        * WebView/WebFrame.mm:
        (-[WebFrame contextForWorldID:]):

2009-10-22  Eric Carlson  <eric.carlson@apple.com>

        Reviewed by John Sullivan.

        <rdar://problem/7322847>
        Pressing space bar key in full screen mode should pause movie but doesn't

        * WebView/WebVideoFullscreenHUDWindowController.mm:
        (-[WebVideoFullscreenHUDWindowController keyDown:]):  New, toggle playback on space key.
        (-[WebVideoFullscreenHUDWindowController windowDidLoad]): Play button action is now called togglePlaying.
        (-[WebVideoFullscreenHUDWindowController togglePlaying:]): Rename from playingChanged.

2009-10-22  Gavin Barraclough  <barraclough@apple.com>

        Reviewed by NOBODY (build fix).
        Build fix following bug #30696.

        * Plugins/Hosted/NetscapePluginInstanceProxy.mm:
        (WebKit::NetscapePluginInstanceProxy::getWindowNPObject):
        (WebKit::NetscapePluginInstanceProxy::evaluate):
        (WebKit::NetscapePluginInstanceProxy::invoke):
        (WebKit::NetscapePluginInstanceProxy::invokeDefault):
        (WebKit::NetscapePluginInstanceProxy::construct):
        (WebKit::NetscapePluginInstanceProxy::getProperty):
        (WebKit::NetscapePluginInstanceProxy::setProperty):
        (WebKit::NetscapePluginInstanceProxy::removeProperty):
        (WebKit::NetscapePluginInstanceProxy::hasProperty):
        (WebKit::NetscapePluginInstanceProxy::hasMethod):
        (WebKit::NetscapePluginInstanceProxy::enumerate):

2009-10-16  Gavin Barraclough  <barraclough@apple.com>

        Reviewed by Sam Weinig & Geoff Garen.

        https://bugs.webkit.org/show_bug.cgi?id=30696
        Update to incorporate support for IsolatedWorlds in JSC bindings.

        * WebView/WebFrame.mm:
        (-[WebFrame _attachScriptDebugger]):
        (-[WebFrame _stringByEvaluatingJavaScriptFromString:forceUserGesture:]):
        (-[WebFrame globalContext]):
        * WebView/WebScriptDebugDelegate.mm:
        (-[WebScriptCallFrame evaluateWebScript:]):
        * WebView/WebView.mm:
        (-[WebView aeDescByEvaluatingJavaScriptFromString:]):

2009-10-22  Eric Carlson  <eric.carlson@apple.com>

        Reviewed by Dan Bernstein & Simon Fraser.

        <rdar://problem/7297717>
        https://bugs.webkit.org/show_bug.cgi?id=30323
        Play/pause button in full-screen video controller does not reflect current state

        * WebView/WebVideoFullscreenController.mm:
        (-[WebVideoFullscreenController setMediaElement:WebCore::]): Register for QTMovieRateDidChangeNotification
        (-[WebVideoFullscreenController rateChanged:]): Call HUD controller when rate changes.

        * WebView/WebVideoFullscreenHUDWindowController.h:
        * WebView/WebVideoFullscreenHUDWindowController.mm:
        (-[WebVideoFullscreenHUDWindowController scheduleTimeUpdate]): Call updateRate so play button
        reflects playback state.
        (-[WebVideoFullscreenHUDWindowController updateRate]): New, set play button state according to
        movie state.
        (-[WebVideoFullscreenHUDWindowController playingChanged:]): Only call [self playing] once.

2009-10-21  John Sullivan  <sullivan@apple.com>

        Rubber-stamped by Dan Bernstein.

        * WebView/WebDynamicScrollBarsView.h:
        Corrected a couple of long-obsolete comments regarding Safari's use of this class.

2009-10-20  Dan Bernstein  <mitz@apple.com>

        Rubber-stamped by Mark Rowe.

        <rdar://problem/7319749> REGRESSION(r49806): Contextual Menu items missing
        https://bugs.webkit.org/show_bug.cgi?id=30568

        Revert accidental change from r49806.

        * WebCoreSupport/WebContextMenuClient.mm:
        (WebContextMenuClient::getCustomMenuFromDefaultItems):

2009-10-20  Fumitoshi Ukai  <ukai@chromium.org>

        Reviewed by David Levin.

        Removed WebSocket runtime settings.
        https://bugs.webkit.org/show_bug.cgi?id=29896

        WebSocket runtime configuration is supported by chromium/v8 only.

        * WebView/WebPreferenceKeysPrivate.h:
        * WebView/WebPreferences.mm:
        (+[WebPreferences initialize]):
        * WebView/WebPreferencesPrivate.h:
        * WebView/WebView.mm:
        (-[WebView _preferencesChangedNotification:]):

2009-10-19  Nate Chapin  <japhet@chromium.org>

        Reviewed by Alexey Proskuryakov.

        Update call to loadFrameRequest to match new parameters.

        * WebView/WebPDFView.mm:
        (-[WebPDFView PDFViewWillClickOnLink:withURL:]): Update call to loadFrameRequest.

2009-10-19  David Kilzer  <ddkilzer@apple.com>

        Documentation fix for -[NSObject(WebResourceLoadDelegate) webView:resource:willSendRequest:redirectResponse:fromDataSource:]

        Reviewed by Dan Bernstein.

        * WebView/WebResourceLoadDelegate.h: Prepended "webView:" to the
        @method declaration of
        -webView:resource:willSendRequest:redirectResponse:fromDataSource:
        which was absent before r3953 and was missed during the great
        documentation clean up of r4269.

2009-10-19  Anders Carlsson  <andersca@apple.com>

        Fix build.

        * Plugins/WebNetscapePluginView.mm:
        (-[WebNetscapePluginView saveAndSetNewPortStateForUpdate:]):

2009-10-19  Dan Bernstein  <mitz@apple.com>

        Reviewed by Anders Carlsson.

        Split assertions of conjunctions into separate statements or remove
        redundant assertions.

        * Plugins/Hosted/NetscapePluginHostProxy.mm:
        (WebKit::NetscapePluginHostProxy::deadNameNotificationCallback):
        * Plugins/Hosted/WebHostedNetscapePluginView.mm:
        (-[WebHostedNetscapePluginView setAttributeKeys:andValues:]):
        (-[WebHostedNetscapePluginView _webPluginContainerCancelCheckIfAllowedToLoadRequest:]):
        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView halt]):
        (-[WebBaseNetscapePluginView resumeFromHalt]):
        * Plugins/WebNetscapePluginView.mm:
        (-[WebNetscapePluginView saveAndSetNewPortStateForUpdate:]):
        (-[WebNetscapePluginView _webPluginContainerCancelCheckIfAllowedToLoadRequest:]):
        * WebCoreSupport/WebContextMenuClient.mm:
        (WebContextMenuClient::getCustomMenuFromDefaultItems):
        * WebCoreSupport/WebEditorClient.mm:
        (WebEditorClient::checkGrammarOfString):
        (WebEditorClient::checkTextOfParagraph):
        * WebView/WebTextCompletionController.mm:
        (-[WebTextCompletionController _reflectSelection]):

2009-10-18  Mark Rowe  <mrowe@apple.com>

        Reviewed by Dan Bernstein.

        <rdar://problem/7309062> Crashes in WebCore::DocumentLoader::isStopping below WebKit::NetscapePluginInstanceProxy::loadRequest.

        * Plugins/Hosted/NetscapePluginInstanceProxy.mm:
        (WebKit::NetscapePluginInstanceProxy::loadRequest): Null-check the DocumentLoader before deferencing it.

2009-10-16  Kevin Decker  <kdecker@apple.com>

        Reviewed by Jon Honeycutt.

        <rdar://problem/7304575>
        
        * Plugins/WebBaseNetscapePluginView.h: Added new boolean ivar and -hasBeenHalted instance method.
        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView halt]):Update _hasBeenHalted.
        (-[WebBaseNetscapePluginView hasBeenHalted]): Added.
        * WebView/WebView.mm:
        (+[WebView _hasPluginForNodeBeenHalted:]): Checks to see if a plug-in node's been halted.
        * WebView/WebViewPrivate.h: Added -_hasPluginForNodeBeenHalted method.

2009-10-16  Kevin Decker  <kdecker@apple.com>

        Reviewed by Anders Carlson.

        Small code cleanup
        
        * Plugins/WebBaseNetscapePluginView.mm:
        (WebHaltablePlugin::halt): Just call -[WebBaseNetscapePluginView halt].
        (WebHaltablePlugin::restart): Just call -[WebBaseNetscapePluginView resumeFromHalt]
        (-[WebBaseNetscapePluginView halt]): 
        (-[WebBaseNetscapePluginView resumeFromHalt]):
        * WebView/WebView.mm:
        (_pluginViewForNode): Added a check if a render is a widget. This prevents a later assertion.

2009-10-16  Kevin Decker  <kdecker@apple.com>

        Reviewed by Anders Carlson.

        Last part of:
        <rdar://problem/7273354>

        * WebView/WebView.mm: 
        (_pluginViewForNode): Added with code extracted from _isNodeHaltedPlugin
        (+[WebView _isNodeHaltedPlugin:]): Made this a class method.
        (+[WebView _restartHaltedPluginForNode:]): Added. Restarts a plug-in
        * WebView/WebViewPrivate.h: Added +_restartHaltedPluginForNode to header.

2009-10-16  Kevin Decker  <kdecker@apple.com>

        Reviewed by Anders.

        <rdar://problem/7273354> 

        * Plugins/WebBaseNetscapePluginView.h: Added _isHalted ivar and three new methods: -halt, -resumeFromHalt, and -isHalted
        * Plugins/WebBaseNetscapePluginView.mm:
        (WebHaltablePlugin::halt): Call -halt instead of -stop.  
        (WebHaltablePlugin::restart):Call -resumeFromHalt instead of -start. 
        (-[WebBaseNetscapePluginView halt]): Added. Stop the plug-in, update _isHalted.
        (-[WebBaseNetscapePluginView resumeFromHalt]): Added. Start the plug-in, update _isHalted.
        (-[WebBaseNetscapePluginView isHalted]): Added.
        * WebView/WebView.mm:
        (-[WebView _isNodeHaltedPlugin:]): Added. Queries a DOMNode to determine if it's a halted plug-in.
        * WebView/WebViewPrivate.h: Added _isNodeHaltedPlugin.

2009-10-15  Eric Carlson  <eric.carlson@apple.com>

        Reviewed by Adele Peterson.

        <rdar://problem/7306052> Fullscreen max/min volume buttons non-functional

        * WebView/WebVideoFullscreenHUDWindowController.mm:
        (-[WebVideoFullscreenHUDWindowController windowDidLoad]): Set volume buttons target and action.
        (-[WebVideoFullscreenHUDWindowController decrementVolume:]): New, decrement the volume by 10%.
        (-[WebVideoFullscreenHUDWindowController incrementVolume:]): New, increment the volume by 10%.

2009-10-15  Eric Carlson  <eric.carlson@apple.com>

        Reviewed by Simon Fraser.

        <rdar://problem/7295738> No way to mute/unmute a movie in full screen video mode

        * WebView/WebVideoFullscreenHUDWindowController.mm:
        (-[WebVideoFullscreenHUDWindowController setVolume:]): Unmute movie before changing volume.

2009-10-14  Kevin Decker  <kdecker@apple.com>

        Unbreak the world.
        
        * Plugins/WebBaseNetscapePluginView.mm:
        (WebHaltablePlugin::restart):

2009-10-14  Kevin Decker  <kdecker@apple.com>

        Reviewed by Anders Carlsson and Jon Honeycutt

        <rdar://problem/7304295> snapshots of halted plug-ins are missing
        
        * Plugins/WebBaseNetscapePluginView.mm: Move bodies of WebHaltablePlugin virtual functions from WebHaltablePlugin class definition.
        (WebHaltablePlugin::halt): Provide a substitute image to the RenderWidget for the plug-in view.
        (WebHaltablePlugin::restart): Clear the substitute image.

2009-10-13  Dave Hyatt  <hyatt@apple.com>

        Reviewed by Adam Roben.

        Change the order of arguments on some methods.  Split removal for user stylesheets and script into
        separate functions based off the type of object being removed.

        * WebView/WebView.mm:
        (+[WebView _addUserScriptToGroup:worldID:source:url:whitelist:blacklist:injectionTime:]):
        (+[WebView _addUserStyleSheetToGroup:worldID:source:url:whitelist:blacklist:]):
        (+[WebView _removeUserScriptFromGroup:worldID:url:]):
        (+[WebView _removeUserStyleSheetFromGroup:worldID:url:]):
        (+[WebView _removeUserScriptsFromGroup:worldID:]):
        (+[WebView _removeUserStyleSheetsFromGroup:worldID:]):
        * WebView/WebViewPrivate.h:

2009-10-13  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        <rdar://problem/6660507> Add "privacy mode" to Netscape Plug-in API

        Listen for WebPreferences notifications and update the _isPrivateBrowsingEnabled ivar 
        when the value changes. Also call -[WebBaseNetscapePluginView privateBrowsingModeDidChange] when the
        value changes. In process this just calls NPP_SetValue, and OOP it sends a MIG message to the plug-in host.
        
        * Plugins/Hosted/NetscapePluginHostManager.h:
        * Plugins/Hosted/NetscapePluginHostManager.mm:
        (WebKit::NetscapePluginHostManager::instantiatePlugin):
        * Plugins/Hosted/NetscapePluginInstanceProxy.h:
        * Plugins/Hosted/NetscapePluginInstanceProxy.mm:
        (WebKit::NetscapePluginInstanceProxy::privateBrowsingModeDidChange):
        * Plugins/Hosted/WebHostedNetscapePluginView.mm:
        (-[WebHostedNetscapePluginView createPlugin]):
        (-[WebHostedNetscapePluginView privateBrowsingModeDidChange]):
        * Plugins/Hosted/WebKitPluginHost.defs:
        * Plugins/WebBaseNetscapePluginView.h:
        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView privateBrowsingModeDidChange]):
        (-[WebBaseNetscapePluginView viewDidMoveToWindow]):
        (-[WebBaseNetscapePluginView preferencesHaveChanged:]):
        * Plugins/WebNetscapePluginView.mm:
        (-[WebNetscapePluginView privateBrowsingModeDidChange]):
        (-[WebNetscapePluginView getVariable:value:]):

2009-10-12  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Darin Adler.

        Video keeps playing after going fullscreen, then closing window
        https://bugs.webkit.org/show_bug.cgi?id=30164
        
        Clear the QTMovie on the QTMovieView when coming out of fullscreen,
        to fix issue where the underlying movie keeps playing.

        * WebView/WebVideoFullscreenController.mm:
        (-[WebVideoFullscreenController windowDidExitFullscreen]):

2009-10-11  Dan Bernstein  <mitz@apple.com>

        Reviewed by Darin Adler.

        <rdar://problem/7294267> REGRESSION (r48492): Gmail voice and video chat
        doesn’t work
        https://bugs.webkit.org/show_bug.cgi?id=30295

        Test: plugins/setProperty.html

        * Plugins/Hosted/ProxyInstance.mm:
        (WebKit::ProxyInstance::setFieldValue): Fixed a typo. The function
        should return early if m_instanceProxy is null.

2009-10-09  Adam Barth  <abarth@webkit.org>

        Reviewed by Darin Adler.

        Factor HistoryController out of FrameLoader
        https://bugs.webkit.org/show_bug.cgi?id=30246

        Update API call.

        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::restoreViewState):
        * WebView/WebView.mm:
        (-[WebView _loadBackForwardListFromOtherView:]):

2009-10-09  Mark Rowe  <mrowe@apple.com>

        Reviewed by Brady Eidson.

        <rdar://problem/7290671> Crash after navigating away from a page with subframe containing plug-in

        At the time that -stop is called on a WebBaseNetscapePluginView that is contained within a subframe
        the WebFrame's data source has been zeroed out.  This was causing -[WebBaseNetscapePluginView webFrame]
        to return nil during -stop, preventing the plug-in view from unregistering itself from the PluginHalter.
        We fix this by having -webFrame retrieve the frame directly rather than retrieving it from the data source.

        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView dataSource]): Get the data source from the WebFrame.
        (-[WebBaseNetscapePluginView webFrame]): Get the Frame directly from the element's document rather
        than taking a windy route through the WebDataSource.

2009-10-09  Brady Eidson  <beidson@apple.com>

        Reviewed by Dan Bernstein.

        Add SPI to specifically enable visited link tracking.

        * History/WebHistory.mm:
        (+[WebHistory _setVisitedLinkTrackingEnabled:]):
        * History/WebHistoryPrivate.h:

2009-10-08  Jon Honeycutt  <jhoneycutt@apple.com>

        Remove the WebKitPluginHalterEnabledPreferenceKey in favor of checking
        for the existence of a PluginHalterDelegate.

        Reviewed by Dan Bernstein.

        * WebCoreSupport/WebPluginHalterClient.h:
        Add declaration for new function.

        * WebCoreSupport/WebPluginHalterClient.mm:
        (WebPluginHalterClient::enabled):
        Check whether the UIDelegate responds to shouldHaltPlugin.

        * WebView/WebPreferenceKeysPrivate.h:
        Remove the "enabled" preference key.

        * WebView/WebPreferences.mm:
        (+[WebPreferences initialize]):
        Remove the initialization of the pref.

        * WebView/WebPreferencesPrivate.h:
        Remove the getter/setter for this pref.

        * WebView/WebView.mm:
        (-[WebView _preferencesChangedNotification:]):
        Remove propagation of the pref. 

2009-10-08  Adam Barth  <abarth@webkit.org>

        Reviewed by Eric Seidel.

        Move executeScript from FrameLoader to ScriptController
        https://bugs.webkit.org/show_bug.cgi?id=30200

        Update API call.

        * WebView/WebFrame.mm:
        (-[WebFrame _stringByEvaluatingJavaScriptFromString:forceUserGesture:]):
        * WebView/WebView.mm:
        (-[WebView aeDescByEvaluatingJavaScriptFromString:]):

2009-10-08  Brady Eidson  <beidson@apple.com>

        Reviewed by Dan Bernstein.

        Ask the History Delegate to populate the visited links hash.
        <rdar://problem/7285293> and https://webkit.org/b/29904

        * History/WebHistory.mm:
        (+[WebHistory _removeAllVisitedLinks]):
        * History/WebHistoryPrivate.h:
        * WebCoreSupport/WebChromeClient.mm:
        (WebChromeClient::populateVisitedLinks):
        * WebView/WebDelegateImplementationCaching.h:
        * WebView/WebDelegateImplementationCaching.mm:
        (CallHistoryDelegate):
        * WebView/WebHistoryDelegate.h:
        * WebView/WebView.mm:
        (-[WebView _cacheHistoryDelegateImplementations]):
        (-[WebView addVisitedLinks:]):
        * WebView/WebViewPrivate.h:

2009-10-08  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        Remove the shouldLoadMediaElementURL implementation.

        * WebCoreSupport/WebFrameLoaderClient.h:
        * WebCoreSupport/WebFrameLoaderClient.mm:
        * WebView/WebPolicyDelegatePrivate.h:

2009-10-07  Simon Fraser  <simon.fraser@apple.com>

        Re-land 49269-49271 since reverting them did not fix the tests.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView drawRect:]):

2009-10-07  Simon Fraser  <simon.fraser@apple.com>

        Revert 49269-49271 to see if it fixes test failures on SnowLeopard that do not
        reproduce locally.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView drawRect:]):

2009-10-07  Adam Barth  <abarth@webkit.org>

        Reviewed by Darin Adler.

        Factor PolicyChecker out of FrameLoader
        https://bugs.webkit.org/show_bug.cgi?id=30155

        Move the policy callback to the policy object.

        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::dispatchWillSubmitForm):
        (WebFrameLoaderClient::receivedPolicyDecison):

2009-10-07  Brady Eidson  <beidson@apple.com>

        Reviewed by Darin Adler.

        Send title changes to the global history delegate.
        <rdar://problem/7285293> and https://webkit.org/b/29904

        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::setTitle):
        * WebView/WebDelegateImplementationCaching.h:
        * WebView/WebHistoryDelegate.h:
        * WebView/WebView.mm:
        (-[WebView _cacheHistoryDelegateImplementations]):

2009-10-07  Darin Adler  <darin@apple.com>

        Reviewed by John Sullivan.

        Make the setMetadataURL function foolproof by having it remove user info
        https://bugs.webkit.org/show_bug.cgi?id=30178
        rdar://problem/6544670

        * Misc/WebNSFileManagerExtras.m:
        (-[NSFileManager _webkit_setMetadataURL:referrer:atPath:]):
        Call _web_URLByRemovingUserInfo on the passed in URL string after converting
        it to a URL, and then convert it back to a string.

        * Misc/WebNSURLExtras.h: Added _web_URLByRemovingUserInfo.
        * Misc/WebNSURLExtras.mm: Removed unused WebKitURLComponents struct.
        (-[NSURL _web_URLByTruncatingOneCharacterBeforeComponent:]): Renamed to be
        clearer on what this does.
        (-[NSURL _webkit_URLByRemovingFragment]): Changed to call new name.
        (-[NSURL _webkit_URLByRemovingResourceSpecifier]): Ditto.
        (-[NSURL _web_URLByRemovingComponentAndSubsequentCharacter:]): Added.
        (-[NSURL _web_URLByRemovingUserInfo]): Added.

2009-10-07  Simon Fraser  <simon.fraser@apple.com>

        Make Dan Bernstein happy.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView drawRect:]):

2009-10-07  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Dan Bernstein.

        Avoid Obj-C message dispatch when possible by storing accessed objects
        in local variables.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView drawRect:]):

2009-10-07  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Dan Bernstein.

        Animation stalls for a few seconds partway through
        https://bugs.webkit.org/show_bug.cgi?id=30182
        
        Make sure that we only call -disableScreenUpdatesUntilFlush when a window
        update is actually going to happen, otherwise screen updates are disabled
        for too long.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView drawRect:]):

2009-10-06  Pavel Feldman  <pfeldman@chromium.org>

        Reviewed by Timothy Hatcher.

        Web Inspector: default to an attached inspector window on Windows (as on Mac).

        https://bugs.webkit.org/show_bug.cgi?id=30134

        * WebCoreSupport/WebInspectorClient.mm:
        (-[WebInspectorWindowController showWindow:]):

2009-10-06  Adam Barth  <abarth@webkit.org>

        Reviewed by Eric Seidel.

        Move FrameLoader::canLoad to SecurityOrigin
        https://bugs.webkit.org/show_bug.cgi?id=30111

        * Plugins/Hosted/HostedNetscapePluginStream.mm:
        (WebKit::HostedNetscapePluginStream::HostedNetscapePluginStream):
        * Plugins/Hosted/NetscapePluginInstanceProxy.mm:
        (WebKit::NetscapePluginInstanceProxy::loadRequest):
        * Plugins/WebBaseNetscapePluginStream.mm:
        (WebNetscapePluginStream::WebNetscapePluginStream):
        * Plugins/WebNetscapePluginView.mm:
        (-[WebNetscapePluginView loadRequest:inTarget:withNotifyData:sendNotification:]):
        * Plugins/WebPluginContainerCheck.mm:
        (-[WebPluginContainerCheck _isForbiddenFileLoad]):
        * WebView/WebFrame.mm:
        (-[WebFrame _allowsFollowingLink:]):

2009-10-06  Adam Barth  <abarth@webkit.org>

        Reviewed by Eric Seidel.

        Move setLocalLoadPolicy and friends to SecurityOrigin
        https://bugs.webkit.org/show_bug.cgi?id=30110

        Call the new API.

        * WebView/WebView.mm:
        (-[WebView _commonInitializationWithFrameName:groupName:usesDocumentViews:]):

2009-10-06  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Mark Rowe.

        accessibility/media-element.html crashes (and has incorrect result)
        https://bugs.webkit.org/show_bug.cgi?id=30108

        Fix up the accessibilty label for the newly added fullscreen button,
        and update the test result accordingly.

        * WebCoreSupport/WebViewFactory.mm:
        (-[WebViewFactory localizedMediaControlElementString:]):
        Handle "ControlsPanel" which is just an empty container, to avoid
        asserting in debug builds.

2009-10-06  Daniel Bates  <dbates@webkit.org>

        Reviewed by Eric Seidel.

        https://bugs.webkit.org/show_bug.cgi?id=30107
        
        Fixes an issue where the Mac build does return the correct drop effect
        with respect to the HTML 5 specification when effectAllowed == "none".
        
        Currently, when effectAllowed == "none" and dropEffect == "copy" or 
        dropEffect == "move" the resulting drop effect is "copy" and "move",
        respectively. However, the HTML 5 specification states that regardless
        of the specified dropEffect, when effectAllowed == "none" the resulting
        drop effect should be "none".

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView draggingSourceOperationMaskForLocal:]):

2009-10-06  Pavel Feldman  <pfeldman@chromium.org>

        Reviewed by Timothy Hatcher.

        Web Inspector: close inspector client view on
        InspectorController::close API call.

        In order to run batch web inspector layout tests (and not affect 
        subsequent tests) we should close inspector client's view upon
        InspectorController::close API call.

        https://bugs.webkit.org/show_bug.cgi?id=30009

        * WebCoreSupport/WebInspectorClient.mm:
        (WebInspectorClient::createPage):

2009-10-05  Dan Bernstein  <mitz@apple.com>

        Rubber-stamped by Mark Rowe.

        Moved a WebPluginHalterClient out of the WebCore namesapce.

        * WebCoreSupport/WebPluginHalterClient.h:

2009-10-05  Kevin Decker  <kdecker@apple.com>

        Reviewed by Dan Bernstein.

        Added new PluginHalter client, delegate and few more WebPreferences keys.

        * WebView/WebPreferenceKeysPrivate.h: Added two new keys.
        * WebView/WebPreferences.mm:
        (+[WebPreferences initialize]): Initialize newly added key.
        (-[WebPreferences pluginAllowedRunTime]): Added.
        (-[WebPreferences setPluginAllowedRunTime:]): Added.
        * WebView/WebPreferencesPrivate.h: Added above two methods.
        * WebView/WebUIDelegatePrivate.h: Added shouldHaltPlugin delegate.
        * WebView/WebView.mm:
        (-[WebView _commonInitializationWithFrameName:groupName:usesDocumentViews:]):
        Setup a new WebPluginHalterClient.
        (-[WebView _preferencesChangedNotification:]): Update WebCore settings accordingly.
        * WebCoreSupport/WebPluginHalterClient.h: Added.
        * WebCoreSupport/WebPluginHalterClient.mm: Added.
        (WebPluginHalterClient::WebPluginHalterClient):
        (WebPluginHalterClient::shouldHaltPlugin): Added, invoke the delegate.

2009-10-05  Simon Fraser  <simon.fraser@apple.com>

        More build fixes for Tiger.

        * WebView/WebVideoFullscreenController.mm:

2009-10-05  Simon Fraser  <simon.fraser@apple.com>

        More build fixes for Tiger.

        * WebView/WebVideoFullscreenController.mm:
        (-[WebVideoFullscreenWindow animationDidEnd:]):
        * WebView/WebWindowAnimation.m:

2009-10-05  Simon Fraser  <simon.fraser@apple.com>

        More build fixes for Tiger.

        * WebView/WebVideoFullscreenController.mm:
        * WebView/WebVideoFullscreenHUDWindowController.mm:
        (-[WebVideoFullscreenHUDWindow initWithContentRect:styleMask:backing:defer:]):
        (-[WebVideoFullscreenHUDWindowController scheduleTimeUpdate]):
        (-[WebVideoFullscreenHUDWindowController fadeWindowIn]):
        (-[WebVideoFullscreenHUDWindowController fadeWindowOut]):
        (-[WebVideoFullscreenHUDWindowController closeWindow]):

2009-10-05  Simon Fraser  <simon.fraser@apple.com>

        Build fixes for Tiger.

        * WebView/WebVideoFullscreenHUDWindowController.h:
        * WebView/WebVideoFullscreenHUDWindowController.mm:
        (-[WebVideoFullscreenHUDWindow initWithContentRect:styleMask:backing:defer:]):
        (-[WebVideoFullscreenHUDWindowController dealloc]):
        (-[WebVideoFullscreenHUDWindowController closeWindow]):
        (-[WebVideoFullscreenHUDWindowController windowDidLoad]):

2009-10-05  Simon Fraser  <simon.fraser@apple.com>

        Build fix. If you call Node::hasTagName(), you also have to include Element.h.

        * WebCoreSupport/WebChromeClient.mm:

2009-10-05  Pierre d'Herbemont  <pdherbemont@webkit.org>

        Reviewed by Simon Fraser
        
        Support fullscreen in MediaPlayer (Mac)
        https://bugs.webkit.org/show_bug.cgi?id=26742

        Add a fullscreen button to the <video> controller if the media engine,
        and the theme have support for fullscreen, and can show appropriate controls.
        Clicking the button calls through the ChromeClient to the WebVideoFullscreenController
        in WebKit to do a nice animation to fullscreen, with a custom controller.

        * WebCoreSupport/WebChromeClient.h:
        * WebCoreSupport/WebChromeClient.mm:
        (WebChromeClient::supportsFullscreenForNode):
        (WebChromeClient::enterFullscreenForNode):
        (WebChromeClient::exitFullscreenForNode):
        New methods to ask whether fullscreen is possible for a given node, and
        notifications on enterying and exiting fullscreen.
        
        * WebView/WebVideoFullscreenController.h: Added.
        * WebView/WebVideoFullscreenController.mm: Added.
        WebVideoFullscreenController is responsible for creating the fullscreen window,
        and coordinating the various animations when going fullscreen.

        * WebView/WebVideoFullscreenHUDWindowController.h: Added.
        * WebView/WebVideoFullscreenHUDWindowController.mm: Added.
        This class manages the heads-up display (HUD) control bar.

        * WebView/WebView.mm:
        (-[WebView _close]):
        Make sure we come out of fullscreen if the WebView is torn down (e.g. if
        you close a background window).

        (-[WebView _enterFullscreenForNode:WebCore::]):
        Make a WebVideoFullscreenController and tell is to start to go fullscreen.
        
        (-[WebView _exitFullscreen]):
        Tell the WebVideoFullscreenController to come out of fullscreen, and clean up.
        
        * WebView/WebViewData.h:
        * WebView/WebViewData.mm:
        (-[WebViewPrivate dealloc]):
        (-[WebViewPrivate finalize]):
        * WebView/WebViewInternal.h:
        Keep a pointer to the WebVideoFullscreenController.
        
        * WebView/WebWindowAnimation.h: Added.
        * WebView/WebWindowAnimation.m: Added.
        (WebWindowAnimationDurationFromDuration):
        (scaledRect):
        (squaredDistance):
        Handle the animations used during the transitition to fullscreen.

2009-10-05  Anders Carlsson  <andersca@apple.com>

        Reviewed by Kevin Decker.
       
        WebKit side of <rdar://problem/7179166>
       
        * Plugins/Hosted/NetscapePluginInstanceProxy.h:
        Add an m_pluginIsWaitingForDraw member variable.
        
        * Plugins/Hosted/NetscapePluginInstanceProxy.mm:
        (WebKit::NetscapePluginInstanceProxy::NetscapePluginInstanceProxy):
        Initialize m_pluginIsWaitingForDraw.
        
        (WebKit::NetscapePluginInstanceProxy::invalidateRect):
        Set m_pluginIsWaitingForDraw to true.
        
        (WebKit::NetscapePluginInstanceProxy::didDraw):
        If m_pluginIsWaitingForDraw is true, call _WKPHPluginInstanceDidDraw.
        
        * Plugins/Hosted/WebHostedNetscapePluginView.mm:
        (-[WebHostedNetscapePluginView drawRect:]):
        Call didDraw.
        
        * Plugins/Hosted/WebKitPluginHost.defs:
        Add PHPluginInstanceDidDraw.

2009-10-02  Chris Marrin  <cmarrin@apple.com>

        Reviewed by Adele Peterson.

        Add functionality to pause/throttle CSS transitions/animations in a WebView
        https://bugs.webkit.org/show_bug.cgi?id=29942

        Added both a setter and getter function

        * WebView/WebView.mm:
        (-[WebView cssAnimationsSuspended]):
        (-[WebView setCSSAnimationsSuspended:]):
        * WebView/WebViewData.h:
        * WebView/WebViewData.mm:
        (-[WebViewPrivate init]):
        * WebView/WebViewPrivate.h:

2009-10-04  Kevin Decker  <kdecker@apple.com>

        Reviewed by Sam Weinig.

        <rdar://problem/7273363> Plug-ins should use PluginHalter
        
        * Plugins/WebBaseNetscapePluginView.h: Add WebHaltablePlugin forward declare and _haltable ivar.
        * Plugins/WebBaseNetscapePluginView.mm:
        (WebHaltablePlugin::WebHaltablePlugin): Added.
        (WebHaltablePlugin::halt): New method that stops a plug-in.
        (WebHaltablePlugin::restart): New method that starts a plug-in.
        (WebHaltablePlugin::node): Added. Provides the DOMNode corresponding to the plug-in in WebBaseNetscapePluginView.
        (-[WebBaseNetscapePluginView initWithFrame:pluginPackage:URL:baseURL:MIMEType:attributeKeys:attributeValues:loadManually:element:WebCore::]):
        Initialize new _haltable ivar.
        (-[WebBaseNetscapePluginView start]): Call the page's didStartPlugin() upon starting a plug-in.
        (-[WebBaseNetscapePluginView stop]): Call the page's didStopPlugin() upon stopping a plug-in.

2009-10-05  Pavel Feldman  <pfeldman@chromium.org>

        Reviewed by Timothy Hatcher.

        Web Inspector: add testing harness for Web Inspector.

        https://bugs.webkit.org/show_bug.cgi?id=30010

        * WebInspector/WebInspector.mm:
        (-[WebInspector evaluateInFrontend:callId:script:]):
        * WebInspector/WebInspectorPrivate.h: Added.

2009-10-04  Kevin Decker  <kdecker@apple.com>

        Reviewed by Cameron Zwarich.

        * WebView/WebPreferenceKeysPrivate.h: Added new key.
        * WebView/WebPreferences.mm:
        (+[WebPreferences initialize]): Leave plug-in halting disabled by default.
        (-[WebPreferences pluginHalterEnabled]): Added.
        (-[WebPreferences setPluginHalterEnabled:]): Ditto.
        * WebView/WebPreferencesPrivate.h: Added above new methods. 

2009-10-02  Dave Hyatt  <hyatt@apple.com>

        Reviewed by Adam Roben.

        Add support for blacklist patterns to user stylesheets and scripts in addition to whitelist patterns.

        * WebView/WebView.mm:
        (toStringVector):
        (+[WebView _addUserScriptToGroup:source:url:worldID:whitelist:blacklist:injectionTime:]):
        (+[WebView _addUserStyleSheetToGroup:source:url:worldID:whitelist:blacklist:]):
        * WebView/WebViewPrivate.h:

2009-10-01  Mark Rowe  <mrowe@apple.com>

        Fix the Tiger build.  Don't unconditionally enable 3D canvas as it is not supported on Tiger.

        * Configurations/FeatureDefines.xcconfig:

2009-10-01  Chris Marrin  <cmarrin@apple.com>

        Reviewed by Oliver Hunt.

        Turn on ENABLE_3D_CANVAS in TOT
        https://bugs.webkit.org/show_bug.cgi?id=29906

        * Configurations/FeatureDefines.xcconfig:
        * WebView/WebPreferenceKeysPrivate.h:
        * WebView/WebPreferences.mm:
        (+[WebPreferences initialize]):
        (-[WebPreferences webGLEnabled]):
        (-[WebPreferences setWebGLEnabled:]):
        * WebView/WebPreferencesPrivate.h:
        * WebView/WebView.mm:
        (-[WebView _preferencesChangedNotification:]):

2009-09-30  Sam Weinig  <sam@webkit.org>

        Reviewed by Dan Bernstein.

        Fix for <rdar://problem/7259706>
        Need WebKit API or SPI on Mac and Windows to test whether it's safe to load a page in a new tab/window

        * WebView/WebFrame.mm:
        (-[WebFrame _allowsFollowingLink:]):
        * WebView/WebFramePrivate.h:

2009-09-30  Dave Hyatt  <hyatt@apple.com>

        Reviewed by Adam Roben.

        Add the ability to remove user stylesheets and scripts by URL.

        * WebView/WebView.mm:
        (+[WebView _removeUserContentFromGroup:url:worldID:]):
        * WebView/WebViewPrivate.h:

2009-09-29  Brady Eidson  <beidson@apple.com>

        Rubberstamped by Dan Bernstein.

        Fix license and some sorting in new files.

        * WebView/WebHistoryDelegate.h:
        * WebView/WebNavigationData.h:
        * WebView/WebNavigationData.mm:

2009-09-29  Brady Eidson  <beidson@apple.com>

        Reviewed by John Sullivan.

        WebKit Mac API should provide a delegate interface for global history.
        <rdar://problem/7042773> and https://webkit.org/b/29904

        * WebView/WebHistoryDelegate.h: Added. New interface for WebKit clients to implement to manage 
          their own global history store.

        Object to store all of the bits of data relevant to a page visit:
        * WebView/WebNavigationData.h: Added.
        * WebView/WebNavigationData.mm: Added.
        (-[WebNavigationDataPrivate dealloc]):
        (-[WebNavigationData initWithURLString:title:originalRequest:response:hasSubstituteData:clientRedirectSource:]):
        (-[WebNavigationData url]):
        (-[WebNavigationData title]):
        (-[WebNavigationData originalRequest]):
        (-[WebNavigationData response]):
        (-[WebNavigationData hasSubstituteData]):
        (-[WebNavigationData clientRedirectSource]):
        (-[WebNavigationData dealloc]):

        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::updateGlobalHistory): If the delegate exists, don't use the built-in WebHistory.
          If the implementation for this method exists, call it.
        (WebFrameLoaderClient::updateGlobalHistoryRedirectLinks): Ditto

        * WebView/WebDelegateImplementationCaching.h:
        * WebView/WebDelegateImplementationCaching.mm:
        (WebViewGetHistoryDelegateImplementations):
        (CallHistoryDelegate):

        * WebView/WebView.mm:
        (-[WebView _cacheHistoryDelegateImplementations]):
        (-[WebView setHistoryDelegate:]):
        (-[WebView historyDelegate]):
        * WebView/WebViewData.h:
        * WebView/WebViewPrivate.h:

2009-09-29  Kenneth Russell  <kbr@google.com>

        Reviewed by Dimitri Glazkov.

        Add support for run-time flag for 3D canvas
        https://bugs.webkit.org/show_bug.cgi?id=29826

        * WebView/WebView.mm:
        (-[WebView _preferencesChangedNotification:]): Enable experimental
        WebGL flag when 3D_CANVAS is enabled in the build.

2009-09-28  Fumitoshi Ukai  <ukai@chromium.org>

        Reviewed by Eric Seidel.

        Add experimentalWebSocketsEnabled in WebPreferences.
        https://bugs.webkit.org/show_bug.cgi?id=28941

        * WebView/WebPreferenceKeysPrivate.h:
        * WebView/WebPreferences.mm:
        (+[WebPreferences initialize]):
        (-[WebPreferences experimentalWebSocketsEnabled]):
        (-[WebPreferences setExperimentalWebSocketsEnabled:]):
        * WebView/WebPreferencesPrivate.h:
        * WebView/WebView.mm:
        (-[WebView _preferencesChangedNotification:]):

2009-09-28  Dan Bernstein  <mitz@apple.com>

        Reviewed by Anders Carlsson.

        <rdar://problem/7240911> REGRESSION (r48586): Crash occurs when loading
        a PDF

        CGPDFObjectRef is not a CFTypeRef, and cannot be retained or released.
        Its lifetime is managed by its container. Just use a Vector to store
        CGPDFObjectRefs, relying on the CGPDFDocument to keep them alive.

        * WebView/WebPDFDocumentExtras.mm:
        (appendValuesInPDFNameSubtreeToVector):
        (getAllValuesInPDFNameTree):
        (web_PDFDocumentAllScripts):

2009-09-24  Jon Honeycutt  <jhoneycutt@apple.com>

        Reviewed by Alice Liu.

        * WebView/WebView.mm:
        (-[WebView _commonInitializationWithFrameName:groupName:usesDocumentViews:]):
        Pass 0 for new Page constructor argument.

2009-09-14  John Gregg  <johnnyg@google.com>

        Reviewed by Eric Seidel.

        isEnabled switch for notifications (experimental) in Page Settings
        https://bugs.webkit.org/show_bug.cgi?id=28930

        Adds support for the experimentalNotificationsEnabled flag in Settings
        through WebPreferencesPrivate.

        * WebView/WebPreferenceKeysPrivate.h:
        * WebView/WebPreferences.mm:
        (+[WebPreferences initialize]):
        (-[WebPreferences experimentalNotificationsEnabled]):
        (-[WebPreferences setExperimentalNotificationsEnabled:]):
        * WebView/WebPreferencesPrivate.h:
        * WebView/WebView.mm:
        (-[WebView _preferencesChangedNotification:]):

2009-09-23  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Sam Weinig.

        Updated for a WebCore rename.

        * WebView/WebFrame.mm:
        (-[WebFrame _cacheabilityDictionary]):

2009-09-23  Darin Adler  <darin@apple.com>

        Reviewed by Dan Bernstein.

        Speed up access to history items by caching date computation.

        * History/WebHistory.mm:
        (getDayBoundaries): Refactored from timeIntervalForBeginningOfDay.
        Returns the beginning of the day that the passed time is within and
        the beginning of the next day.
        (beginningOfDay): Added. Uses getDayBoundaries so it can be fast for
        multiple dates within the same day, which is the common case.
        (dateKey): Added. Calls beginningOfDay and converts to an integer.
        (-[WebHistoryPrivate findKey:forDay:]): Changed to call dateKey
        insetad of timeIntervalForBeginningOfDay.

2009-09-23  David Kilzer  <ddkilzer@apple.com>

        Move definition of USE(PLUGIN_HOST_PROCESS) from WebKitPrefix.h to Platform.h

        Reviewed by Mark Rowe.

        * WebKitPrefix.h: Removed definition of
        WTF_USE_PLUGIN_HOST_PROCESS.

2009-09-22  Timothy Hatcher  <timothy@apple.com>

        Prevent scrolling multiple frames during latched wheel events.

        Reviewed by Anders Carlsson.

        * WebView/WebDynamicScrollBarsView.h:
        * WebView/WebDynamicScrollBarsView.mm:
        (-[WebDynamicScrollBarsView scrollWheel:]):

2009-09-22  Dan Bernstein  <mitz@apple.com>

        Reviewed by John Sullivan.

        <rdar://problem/7240911> REGRESSION (r48586): Crash occurs when loading
        a PDF

        * WebView/WebPDFDocumentExtras.mm:
        (addWebPDFDocumentExtras): Made methodList static, because
        class_addMethods() doesn't copy it.

2009-09-21  Dan Bernstein  <mitz@apple.com>

        Attempt to fix the Tiger build

        * WebView/WebPDFDocumentExtras.mm:
        (addWebPDFDocumentExtras):

2009-09-21  Dan Bernstein  <mitz@apple.com>

        Attempt to fix the Tiger build

        * WebView/WebPDFDocumentExtras.mm:
        (web_PDFDocumentAllScripts):
        (addWebPDFDocumentExtras):

2009-09-21  Dan Bernstein  <mitz@apple.com>

        Attempt to fix the Tiger build

        * WebView/WebPDFDocumentExtras.mm:
        * WebView/WebPDFRepresentation.mm:

2009-09-21  Dan Bernstein  <mitz@apple.com>

        Attempt to fix the Leopard and Tiger builds

        * WebView/WebPDFDocumentExtras.mm:

2009-09-21  Dan Bernstein  <mitz@apple.com>

        Reviewed by Anders Carlsson.

        <rdar://problem/4137135> iFrame with PDF not being handled correctly on
        usps.com
        https://bugs.webkit.org/show_bug.cgi?id=4151

        * WebView/WebJSPDFDoc.h: Added.
        * WebView/WebJSPDFDoc.mm: Added.
        (jsPDFDocInitialize): Retains the WebDataSource.
        (jsPDFDocFinalize): Releases the WebDataSource.
        (jsPDFDocPrint): Call the WebUIDelegate method -webView:printFrameView:
        with the PDF document's view.
        (makeJSPDFDoc): Makes and returns a JavaScript Doc instance that wraps
        the WebDataSource.
        * WebView/WebPDFDocumentExtras.h: Added.
        * WebView/WebPDFDocumentExtras.mm: Added.
        (appendValuesInPDFNameSubtreeToArray): Traverses a subtree of a PDF name
        tree and adds all values in the subtree to an array.
        (allValuesInPDFNameTree): Returns an array with all of the values in a
        PDF name tree.
        (web_PDFDocumentAllScripts): This is the implementation of -[PDFDocument
        _web_allScripts]. It gets all values in the document-level "JavaScript"
        name tree, which are action dictionaries, and returns an array of the
        actions' scripts.
        (addWebPDFDocumentExtras): Adds the -_web_allScripts method to
        PDFDocument.
        * WebView/WebPDFRepresentation.h:
        * WebView/WebPDFRepresentation.m: Removed.
        * WebView/WebPDFRepresentation.mm: Copied from WebKit/mac/WebView/WebPDFRepresentation.m.
        (+[WebPDFRepresentation initialize]): Added. Calls
        addWebPDFDocumentExtras().
        (-[WebPDFRepresentation finishedLoadingWithDataSource:]): Get the
        scripts from the PDF document, create a JavaScript Doc object for the
        document, and a JavaScript execution context, then execute every script
        in the context, with the Doc object as "this".

2009-09-17  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Dave Hyatt.

        Compositing layers are incorrectly positioned after scrolling with position:fixed
        https://bugs.webkit.org/show_bug.cgi?id=29262
        
        When scrolling a page with compositing layers inside a position:fixed element,
        we need to update the compositing layer positions when the scroll position changes.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _frameOrBoundsChanged]):
        Call the new FrameView::scrollPositionChanged() method rather than sending the
        scroll event directly.

2009-09-17  Kenneth Rohde Christiansen  <kenneth@webkit.org>

        Reviewed by Simon Hausmann.

        Make PlatformWindow return something else than PlatformWidget
        https://bugs.webkit.org/show_bug.cgi?id=29085

        Reflect the rename of platformWindow and it's return type.

        * WebCoreSupport/WebChromeClient.h:
        * WebCoreSupport/WebChromeClient.mm:
        (WebChromeClient::platformPageClient):

2009-09-17  Anders Carlsson  <andersca@apple.com>

        Reviewed by Oliver Hunt.

        <rdar://problem/7007541> 
        CrashTracer: 4800+ crashes in Safari at com.apple.WebKit • WTF::HashTableIterator...

        Add null checks for m_instanceProxy (It will be null when a plug-in has crashed).
        
        * Plugins/Hosted/ProxyInstance.mm:
        (WebKit::ProxyInstance::invoke):
        (WebKit::ProxyInstance::supportsInvokeDefaultMethod):
        (WebKit::ProxyInstance::supportsConstruct):
        (WebKit::ProxyInstance::getPropertyNames):
        (WebKit::ProxyInstance::methodsNamed):
        (WebKit::ProxyInstance::fieldNamed):
        (WebKit::ProxyInstance::fieldValue):
        (WebKit::ProxyInstance::setFieldValue):
        (WebKit::ProxyInstance::invalidate):

2009-09-16  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Dan Bernstein.

        Work around a bug in AppKit on Leopard which causes compositing layers to jitter, and
        become misplaced when the WebHTMLView is resized or scrolled sometimes.
        <rdar://problem/7071636>
        
        The previous fix didn't fix the case where the layers jiggle when resizing the docked
        inspector when the view size is over 2048px tall, on Leopard.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _updateLayerHostingViewPosition]):

2009-09-16  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Oliver Hunt.

        Work around a bug in AppKit on Leopard which causes compositing layers to jitter, and
        become misplaced when the WebHTMLView is resized or scrolled sometimes.
        <rdar://problem/7071636>
        
        We call an internal AppKit method to make sure the layer geometry is updated correctly.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _updateLayerHostingViewPosition]):

2009-09-15  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Dan Bernstein.

        Fixed position elements flash when CSS transforms are applied on page > 2048px tall
        https://bugs.webkit.org/show_bug.cgi?id=27272
        
        Update the previous workaround for misplaced compositing layers, which used a 4096px
        threshold, to 2048px since that's the GPU max texture size on some older hardware.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _updateLayerHostingViewPosition]):

2009-09-15  Alex Milowski  <alex@milowski.com>

        Reviewed by Tor Arne Vestbø.

        Added the ENABLE_MATHML to the feaure defines

        * Configurations/FeatureDefines.xcconfig:

2009-09-15  Mark Rowe  <mrowe@apple.com>

        Reviewed by Anders Carlsson.

        <rdar://problem/7224378> REGRESSION(r48360): Dragging a tab with a plug-in out of a window, the plug-in gets slow and confused

        In r48360, the fix for <rdar://problem/7090444>, I neglected to consider the case where the plug-in had already been started and
        -start would do an early-return rather than calling -restartTimers and -addWindowObservers itself.

        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView viewDidMoveToWindow]): Reinstate the call to -restartTimers and -addWindowObservers, but guard them
        with a check that the view is still in the window.

2009-09-14  Brady Eidson  <beidson@apple.com>

        Reviewed by Alexey Proskuryakov.

        Safari 4 cannot be used to update firmware on Linksys routers.
        <rdar://problem/7174050> and https://bugs.webkit.org/show_bug.cgi?id=29160

        Adopt the new WebCore::CredentialStorage in WebKit/Mac.

        * Misc/WebDownload.mm:
        (-[WebDownloadInternal download:didReceiveAuthenticationChallenge:]):
        * Plugins/WebBaseNetscapePluginView.mm:
        (WebKit::getAuthenticationInfo):

2009-09-12  Mark Rowe  <mrowe@apple.com>

        Reviewed by Anders Carlsson.

        Fix <rdar://problem/7090444> Crashes in-[WebBaseNetscapePluginView stop] handling NSWindowWillCloseNotification.

        It's not valid to call -addWindowObservers when the view is not in a window, but this can happen when -start
        initializes a plug-in and the plug-in removes itself from the document during initialization.  -viewDidMoveToWindow
        calls -start and then calls -addWindowObservers without ensuring that the view is still in a window.

        If -[WebBaseNetscapePluginView addWindowObservers] is incorrectly called when the view is not in a window, it will
        observe NSWindowWillCloseNotification on all windows.  This unexpected observer registration is not balanced by an
        unregistration so the notification can be delivered after the view is deallocated, causing the crash seen in
        <rdar://problem/7090444>.

        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView start]): Only call -updateAndSetWindow if we still have a current window.
        (-[WebBaseNetscapePluginView viewDidMoveToWindow]): Remove unnecessary calls to -restartTimers and -addWindowObservers
        from -[WebBaseNetscapePluginView viewDidMoveToWindow].  They are already called from within -start with the extra benefit
        of ensuring that the view is still in a window when they are called.

2009-09-11  Mark Rowe  <mrowe@apple.com>

        Reviewed by Jon Honeycutt.

        Fix <rdar://problem/7145242> Crashes inside WTF::HashTable below NetscapePluginInstanceProxy::disconnectStream

        * Plugins/Hosted/HostedNetscapePluginStream.mm:
        (WebKit::HostedNetscapePluginStream::cancelLoad): Canceling the load can result in calling through to disconnectStream.
        If the plug-in instance holds the last reference to the plug-in stream this will result in the stream being deallocated.
        This leads to HostedNetscapePluginStream::cancelLoad's call to disconnectStream being passed a deallocated stream object.
        Since the stream was already disconnected by the call to cancel there's no need to call disconnectStream a second time.

2009-09-11  Eric Seidel  <eric@webkit.org>

        No review, rolling out r48229.
        http://trac.webkit.org/changeset/48229

        * WebView/WebFrame.mm:
        (-[WebFrame _dragSourceMovedTo:]):

2009-09-10  Mark Rowe  <mrowe@apple.com>

        Rubber-stamped by Sam Weinig.

        Update JavaScriptCore and WebKit's FeatureDefines.xcconfig so that they are in sync with WebCore as they need to be.

        * Configurations/FeatureDefines.xcconfig:

2009-09-09  Jens Alfke  <snej@chromium.org>

        Reviewed by Eric Seidel.

        Initialize DataTransfer's effectAllowed and dropEffect properties correctly
        according to HTML5 spec (sec. 7.9.2-7.9.3).
        https://bugs.webkit.org/show_bug.cgi?id=26700

        * WebView/WebFrame.mm:
        (-[WebFrame _dragSourceMovedTo:]):
            Pass current drag operation (if known) to EventHandler::dragSourceMovedTo().

2009-09-09  Dave Hyatt  <hyatt@apple.com>

        Reviewed by Adam Roben.

        https://bugs.webkit.org/show_bug.cgi?id=29102, add support for user stylesheet injection.  This is similar
        to user script injection but allows for user stylesheets to be added.  The stylesheets are applied immediately
        to all Frames in the PageGroup.

        Added userscripts/simple-stylesheet.html test case.

        * WebView/WebView.mm:
        (+[WebView _addUserStyleSheetToGroup:source:url:worldID:patterns:]):
        * WebView/WebViewPrivate.h:

2009-09-07  Steve Block  <steveblock@google.com>

        Reviewed by Adam Barth.

        Adds a mock Geolocation service. This will be used to provide predictable behavior of the
        Geolocation API for use in LayoutTests. Later changes will integrate the the mock
        Geolocation service with DumpRenderTree.
        https://bugs.webkit.org/show_bug.cgi?id=28264

        * WebCoreSupport/WebGeolocationMockPrivate.h: Added.
        * WebCoreSupport/WebGeolocationMock.mm: Added.
        (+[WebGeolocationMock setError:code:]): Added. Used by DumpRender tree to configure the mock Geolocation service.
        (+[WebGeolocationMock setPosition:latitude:longitude:accuracy:]): Added. Used by DumpRender tree to configure the mock Geolocation service.
        * WebKit.exp: Modified. Exports WebGeolocationMock.

2009-09-07  Drew Wilson  <atwilson@google.com>

        Reviewed by David Levin.

        Enable SHARED_WORKERS by default.
        https://bugs.webkit.org/show_bug.cgi?id=28959

        * Configurations/FeatureDefines.xcconfig:

2009-09-06  Cameron McCormack  <cam@mcc.id.au>

        Reviewed by Eric Seidel.

        Drop <definition-src> support
        https://bugs.webkit.org/show_bug.cgi?id=28991

        * MigrateHeaders.make: Remove reference to ObjC definition-src
        binding class.

2009-09-04  Mark Mentovai  <mark@chromium.org>

        Reviewed by Dave Hyatt.

        https://bugs.webkit.org/show_bug.cgi?id=28614

        Account for scrollbar state changes that occur during layout.

        * WebView/WebDynamicScrollBarsView.mm:
        (-[WebDynamicScrollBarsView updateScrollers]):

        Perform a layout prior to checking whether the scrollbar modes are
        off, on, or automatic.  The modes may change during layout.

        * WebView/WebFrameView.mm:
        (-[WebFrameView _install]):

        Eliminate duplicated (and incorrect) scrollbar mode tracking between
        FrameView and ScrollView.

2009-09-03  Dave Hyatt  <hyatt@apple.com>

        Reviewed by Adam Roben.

        https://bugs.webkit.org/show_bug.cgi?id=28890, make simple user script injection work.
        
        This patch adds new API for adding and removing user scripts from page groups.  User scripts
        are bundled together in isolated worlds (you can have multiple scripts together in the same
        world).

        Added userscripts/ directory for holding new tests (along with a simple test of script injection).

        * WebView/WebView.mm:
        (+[WebView _addUserScriptToGroup:source:url:worldID:patterns:injectionTime:]):
        (+[WebView _removeUserContentFromGroup:worldID:]):
        (+[WebView _removeAllUserContentFromGroup:]):
        * WebView/WebViewPrivate.h:

2009-09-04  Adam Barth  <abarth@webkit.org>

        Reviewed by Eric Seidel.

        https://bugs.webkit.org/show_bug.cgi?id=24696

        Plumb mixed content notifications to WebFrameLoadDelegatePrivate.

        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::didDisplayInsecureContent):
        (WebFrameLoaderClient::didRunInsecureContent):
        * WebView/WebDelegateImplementationCaching.h:
        * WebView/WebFrameLoadDelegatePrivate.h: Added.

2009-09-03  Adam Barth  <abarth@webkit.org>

        Unreviewed build fix.

        Change notImplemented() to a FIXME.

        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::didDisplayInsecureContent):
        (WebFrameLoaderClient::didRunInsecureContent):

2009-09-03  Adam Barth  <abarth@webkit.org>

        Reviewed by eric@webkit.org.

        https://bugs.webkit.org/show_bug.cgi?id=24696

        Plumb mixed content notifications to WebFrameLoadDelegatePrivate.

        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::didDisplayInsecureContent):
        (WebFrameLoaderClient::didRunInsecureContent):
        * WebView/WebDelegateImplementationCaching.h:
        * WebView/WebFrameLoadDelegatePrivate.h: Added.

2009-09-03  Adam Barth  <abarth@webkit.org>

        Reviewed by Eric Seidel.

        https://bugs.webkit.org/show_bug.cgi?id=24696

        Stub implementations of mixed content methods of FrameLoaderClient. 

        * WebCoreSupport/WebFrameLoaderClient.h:
        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::didDisplayInsecureContent):
        (WebFrameLoaderClient::didRunInsecureContent):

2009-09-02  Brady Eidson  <beidson@apple.com>

        Reviewed by Darin Adler.

        More partial work towards "Page Cache should support pages with Frames"
        https://bugs.webkit.org/show_bug.cgi?id=13631

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _topHTMLView]): Rework the ASSERT in this method to reflect the
          reality of calling this method for pages currently in the PageCache.

2009-08-31  Dimitri Glazkov  <dglazkov@chromium.org>

    Reverting http://trac.webkit.org/changeset/47904, because it caused
    layout test failure.

2009-08-31  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=28852
        Rename KURL single argument constructor to avoid confusion

        * WebView/WebScriptDebugger.mm: (toNSURL): Adapt to the change.

2009-08-31  Mark Mentovai  <mark@chromium.org>

        Reviewed by Dave Hyatt.

        https://bugs.webkit.org/show_bug.cgi?id=28614

        Perform a layout prior to checking whether the scrollbar modes are
        off, on, or automatic.  The modes may change during layout.

        * WebView/WebDynamicScrollBarsView.mm:
        (-[WebDynamicScrollBarsView updateScrollers]):

2009-08-28  Chris Fleizach  <cfleizach@apple.com>

        Reviewed by John Sullivan.

        update-webkit-localizable-strings script can no longer complete
        https://bugs.webkit.org/show_bug.cgi?id=28792

        * WebCoreSupport/WebViewFactory.mm:
        (-[WebViewFactory AXARIAContentGroupText:]):

2009-08-28  Gustavo Noronha Silva  <gustavo.noronha@collabora.co.uk>

        Reviewed by Holger Freyther.

        https://bugs.webkit.org/show_bug.cgi?id=25889
        [GTK] scrollbar policy for main frame is not implementable

        Add empty implementation for new ChromeClient method.

        * WebCoreSupport/WebChromeClient.h:
        (WebChromeClient::scrollbarsModeDidChange):

2009-08-25  Eric Carlson  <eric.carlson@apple.com>

        Reviewed by Oliver Hunt.

        <video> and <audio> controller should be accessible
        https://bugs.webkit.org/show_bug.cgi?id=28081

        * WebCoreSupport/WebViewFactory.mm:
        (-[WebViewFactory localizedMediaControlElementString:]):
        (-[WebViewFactory localizedMediaControlElementHelpText:]):
        (-[WebViewFactory localizedMediaTimeDescription:]):
            New.

2009-08-24  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by NOBODY (build fix)

        Turn off ENABLE_3D_CANVAS in the xconfig files.

        * Configurations/FeatureDefines.xcconfig:

2009-08-22  Adam Barth  <abarth@webkit.org>

        Revert 47684.  We're going to do this later once clients have had a
        chance to opt into the setting they like.

        * Misc/WebKitVersionChecks.h:
        * WebView/WebPreferences.mm:
        (+[WebPreferences initialize]):

2009-08-22  Adam Barth  <abarth@webkit.org>

        Reviewed by Eric Seidel.

        Don't let local files access web URLs
        https://bugs.webkit.org/show_bug.cgi?id=28480

        * Misc/WebKitVersionChecks.m:
        * WebView/WebPreferences.mm:
        (+[WebPreferences initialize]):

2009-08-21  Anders Carlsson  <andersca@apple.com>

        Reviewed by Darin Adler.

        <rdar://problem/7162480>
        Sometimes WebKit does not layout correctly when a WebView is embedded in an HICocoaView
        
        Add a null check for the current context when reflectScrolledClipView: is called from outside a 
        draw operation.
        
        * WebView/WebDynamicScrollBarsView.mm:
        (-[WebDynamicScrollBarsView reflectScrolledClipView:]):

2009-08-20  Chris Fleizach  <cfleizach@apple.com>

        Reviewed by Darin Adler.

        Enable various "grouping" ARIA roles
        https://bugs.webkit.org/show_bug.cgi?id=28486

        * WebCoreSupport/WebViewFactory.mm:
        (-[WebViewFactory AXARIAContentGroupText:]):

2009-08-19  Mark Rowe  <mrowe@apple.com>

        Reviewed by Dan Bernstein.

        Fix <http://webkit.org/b/28484> Plug-in-related leaks seen on the build bot

        When the plug-in data is being loaded manually there is a reference cycle between the
        NetscapePluginInstanceProxy and the HostedNetscapePluginStream.  We need to explicitly
        break the reference cycle in NetscapePluginInstanceProxy::cleanup so that both objects
        will be destroyed.

        Take the opportunity to add RefCountedLeakCounter support to HostedNetscapePluginStream
        and NetscapePluginInstanceProxy to simplify tracking down leaks of these objects in the future.

        * Plugins/Hosted/HostedNetscapePluginStream.h:
        * Plugins/Hosted/HostedNetscapePluginStream.mm:
        (WebKit::HostedNetscapePluginStream::HostedNetscapePluginStream):
        (WebKit::HostedNetscapePluginStream::~HostedNetscapePluginStream):
        * Plugins/Hosted/NetscapePluginInstanceProxy.mm:
        (WebKit::NetscapePluginInstanceProxy::NetscapePluginInstanceProxy):
        (WebKit::NetscapePluginInstanceProxy::~NetscapePluginInstanceProxy):
        (WebKit::NetscapePluginInstanceProxy::cleanup): Clear m_manualStream to break the reference
        cycle.

2009-08-19  Aaron Boodman  <aa@chromium.org>

        Reviewed by David Levin.

        https://bugs.webkit.org/show_bug.cgi?id=24853: Provide a way for WebKit clients to
        specify a more granular policy for cross-origin XHR access.

        * WebView/WebView.mm: Add SPI to manipulate origin access whitelists.
        (+[WebView _whiteListAccessFromOrigin:destinationProtocol:destinationHost:allowDestinationSubdomains:]): Ditto.
        (+[WebView _resetOriginAccessWhiteLists]): Ditto.
        * WebView/WebViewPrivate.h: Ditto.

2009-08-18  Anders Carlsson  <andersca@apple.com>

        Reviewed by Adele Peterson.

        Mac specific part of
        
        <rdar://problem/7135588> HTMLMediaElement should ask WebPolicyLoadDelegate before loading resource

        * WebCoreSupport/WebFrameLoaderClient.h:
        * WebCoreSupport/WebFrameLoaderClient.mm:
        Implement shouldLoadMediaElementURL by asking the policy delegate.
        
        * WebView/WebPolicyDelegatePrivate.h:
        Add new delegate method, remove some unused cruft.

2009-08-18  Drew Wilson  <atwilson@google.com>

        Reviewed by Eric Seidel.

        Need to extend DumpRenderTree to expose number of worker threads.
        https://bugs.webkit.org/show_bug.cgi?id=28292

        * WebKit.exp:
        Exported WebWorkersPrivate so DumpRenderTree can access it.
        * Workers/WebWorkersPrivate.h: Added.
        * Workers/WebWorkersPrivate.mm: Added.
        (+[WebWorkersPrivate workerThreadCount]):
        Added WebWorkersPrivate::workerThreadCount() API for DumpRenderTree.

2009-08-17  Darin Adler  <darin@apple.com>

        Reviewed by Sam Weinig.

        Use a HashMap instead of a list of if statements for the command
        name exception map.

        * WebView/WebHTMLView.mm:
        (createSelectorExceptionMap): Added.
        (commandNameForSelector): Use createSelectorExceptionMap.

2009-08-16  David Kilzer  <ddkilzer@apple.com>

        <http://webkit.org/b/28366> WebHTMLViewInternal.h: add @class CALayer declaration

        Reviewed by Simon Fraser.

        Without WebKitPrefix.h, the missing @class CALayer declaration
        causes a compile-time error.

        * WebView/WebHTMLViewInternal.h: Added @class CALayer
        declaration with USE(ACCELERATED_COMPOSITING).

2009-08-16  David Kilzer  <ddkilzer@apple.com>

        <http://webkit.org/b/28355> Replace MAX()/MIN() macros with type-safe std::max()/min() templates

        Reviewed by Dan Bernstein.

        * Plugins/WebBaseNetscapePluginStream.mm: Added using std::min
        statement.
        (WebNetscapePluginStream::deliverData): Changed MIN() to min().
        Changed C-style cast to a static_cast.
        * Plugins/WebNetscapePluginView.mm: Added using std::min
        statement.
        (-[WebNetscapePluginView _postURL:target:len:buf:file:notifyData:sendNotification:allowHeaders:]):
        Changed MIN() to min().  Changed C-style cast to a static_cast.
        * WebView/WebHTMLView.mm: Added using std::max statement.
        (-[WebHTMLView _dragImageForURL:withLabel:]): Changed MAX() to
        max().
        (-[WebHTMLView _scaleFactorForPrintOperation:]): Ditto.
        * WebView/WebTextCompletionController.mm: Added using std::max
        and using std::min statements.
        (-[WebTextCompletionController _placePopupWindow:]): Changed
        type of maxWidth variable from float to CGFloat to prevent a
        type mismatch on x86_64.  Changed MAX() to max() and MIN() to
        min().  Added static_cast for a constant value since CGFloat is
        defined as a float on i386 and as a double on x86_64.

2009-08-15  Adam Bergkvist  <adam.bergkvist@ericsson.com>

        Reviewed by Sam Weinig.

        Added ENABLE_EVENTSOURCE flag.
        https://bugs.webkit.org/show_bug.cgi?id=14997

        * Configurations/FeatureDefines.xcconfig:

2009-08-14  Mark Rowe  <mrowe@apple.com>

        Build fix.

        * Plugins/Hosted/NetscapePluginInstanceProxy.mm:
        (WebKit::NetscapePluginInstanceProxy::enumerate):  Add the necessary .get() calls.

2009-08-14  Brady Eidson  <beidson@apple.com>

        Reviewed by Anders Carlsson.

        <rdar://problem/7091546> - Assertion failure in plugins/return-error-from-new-stream-doesnt-invoke-destroy-stream.html 
        on 64-bit SnowLeopard

        * Plugins/Hosted/HostedNetscapePluginStream.mm:
        (WebKit::HostedNetscapePluginStream::cancelLoad): Since this might be called while the FrameLoader is switching DocumentLoaders
          during the brief moment where there is no activeDocumentLoader(), accept and handle a validly null DocumentLoader.

2009-08-14  Mark Rowe  <mrowe@apple.com>

        Reviewed by Brady Eidson.

        Fix leaks of NSNumber and NSMutableArray objects seen during layout tests.

        * Plugins/Hosted/NetscapePluginInstanceProxy.mm:
        (WebKit::NetscapePluginInstanceProxy::enumerate): Don't leak an NSMutableArray that we allocate.

2009-08-14  Mark Rowe  <mrowe@apple.com>

        Reviewed by Anders Carlsson.

        Fix leaks of HostedNetscapePluginStream and NetscapePlugInStreamLoader objects seen during layout tests.

        * Plugins/Hosted/HostedNetscapePluginStream.mm:
        (WebKit::HostedNetscapePluginStream::didFail): Disconnect the stream from the plug-in instance proxy
        when the load fails.

2009-08-13  Darin Adler  <darin@apple.com>

        * Plugins/Hosted/NetscapePluginInstanceProxy.mm: Updated includes.
        * WebView/WebScriptDebugger.mm: Ditto.

2009-08-12  Mark Rowe  <mrowe@apple.com>

        Reviewed by Kevin Decker.

        <rdar://problem/6017913> Replace use of HISearchWindowShow in -[WebView _searchWithSpotlightFromMenu].

        * WebView/WebView.mm:
        (-[WebView _searchWithSpotlightFromMenu:]): Use -[NSWorkspace showSearchResultsForQueryString:] post-Leopard.

2009-08-12  Greg Bolsinga  <bolsinga@apple.com>

        Reviewed by Eric Seidel.

        Add delegate methods about focus and blur and state change
        https://bugs.webkit.org/show_bug.cgi?id=27153
        
        Have ObjC delegate methods match C++ method names in the ChromeClient.

        * WebCoreSupport/WebChromeClient.mm:
        (WebChromeClient::formDidFocus):
        (WebChromeClient::formDidBlur):
        * WebView/WebUIDelegatePrivate.h:

2009-08-11  John Gregg  <johnnyg@google.com>

        Reviewed by Maciej Stachowiak.

        Desktop Notifications API
        https://bugs.webkit.org/show_bug.cgi?id=25643

        Adds ENABLE_NOTIFICATION flag.

        * Configurations/FeatureDefines.xcconfig:

2009-08-11  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        Remove dead declarations.
        
        * WebView/WebViewInternal.h:

2009-08-11  Dmitry Titov  <dimich@chromium.org>

        Reviewed by Adam Roben.

        Originally implemented by Glenn Wilson <gwilson@chromium.org>.

        Added new methods for overriding default WebPreference values
        and for resetting preferences to their defaults.
        See https://bugs.webkit.org/show_bug.cgi?id=20534

        * WebView/WebPreferences.mm:
        (-[WebPreferences _setPreferenceForTestWithValue:withKey:]): added.
        * WebView/WebPreferencesPrivate.h: same.

2009-08-09  Nikolas Zimmermann  <nikolas.zimmermann@torchmobile.com>

        Reviewed by George Staikos.

        [WML] Deck access control is completly broken
        https://bugs.webkit.org/show_bug.cgi?id=27721

        Synchronize WebFrameLoadType with FrameLoadType enum. Append 'WebFrameLoadTypeBackWMLDeckNotAccessible'.

        * WebView/WebFramePrivate.h:

2009-08-07  Simon Fraser  <simon.fraser@apple.com>

        Fix the build on 10.6.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView attachRootLayer:]):

2009-08-07  Simon Fraser  <simon.fraser@apple.com>

        Fix a stylistic nit related to the location of the *, which, for some
        ridiculous reason, WebKit style dictates to be different between Objective-C and C++.
        
        * WebView/WebDynamicScrollBarsView.mm:
        (-[WebDynamicScrollBarsView reflectScrolledClipView:]):

2009-08-07  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Dan Bernstein.

        Work around an issue on Leopard where composited layers are misplaced and squished when the page
        gets over 4096px tall.
        https://bugs.webkit.org/show_bug.cgi?id=27272
        <rdar://problem/7067892> [Leopard] Composisted layers are misplaced and squished on on long pages
        <rdar://problem/7068252> [Leopard] When switching to a tab with HW layers, they fade in

        * WebView/WebDynamicScrollBarsView.mm:
        (-[WebDynamicScrollBarsView reflectScrolledClipView:]):
        Call -_updateLayerHostingViewPosition after scrolling.
        
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _frameOrBoundsChanged]):
        Call -_updateLayerHostingViewPosition after the view changes size.

        (-[WebHTMLView attachRootLayer:]):
        Turn off default animations, to avoid animations of sublayer transform, and fading-in
        when tab switching.
        
        * WebView/WebHTMLViewInternal.h:
        (-[WebHTMLView _updateLayerHostingViewPosition]):
        New method that constrains the height of the layer-hosting view to a max height
        of 4096px, and compensates for the height restriction by placing the layer-hosting
        view at the top of the visible part of the WebHTMLView, and adjusting the position
        of the hosted layers via sublayer transform.

2009-08-07  Anders Carlsson  <andersca@apple.com>

        Fix Tiger build.
        
        * WebView/WebRenderNode.mm:
        (-[WebRenderNode _initWithCoreFrame:]):

2009-08-07  Anders Carlsson  <andersca@apple.com>

        Reviewed by Timothy Hatcher and Sam Weinig.

        Change WebRenderNode to take a WebFrame instead of a WebFrameView.
        
        * WebView/WebRenderNode.h:
        * WebView/WebRenderNode.mm:
        (-[WebRenderNode _initWithName:position:rect:coreFrame:children:]):
        (copyRenderNode):
        (-[WebRenderNode _initWithCoreFrame:]):
        (-[WebRenderNode initWithWebFrame:]):

2009-08-06  Anders Carlsson  <andersca@apple.com>

        Reviewed by Darin Adler and Dan Bernstein.

        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::hasHTMLView):
        Always return true when we're in viewless mode.

2009-08-06  Anders Carlsson  <andersca@apple.com>

        Remove WebGraphicsExtras.h include.
        
        * Plugins/WebNetscapePluginView.mm:

2009-08-06  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        Remove WebGraphicsExtras, it is no longer used.

        * Misc/WebGraphicsExtras.c: Removed.
        * Misc/WebGraphicsExtras.h: Removed.

2009-08-06  Chris Marrin  <cmarrin@apple.com>

        Reviewed by David Hyatt.

        Added ENABLE_3D_CANVAS flag to build, default to off

        * Configurations/FeatureDefines.xcconfig:

2009-08-04  Michael Nordman  <michaeln@google.com>

        Reviewed by Alexey Proskuryakov.

        https://bugs.webkit.org/show_bug.cgi?id=27821

        Mods to keep up with ApplicationCacheHost refactoring.

        * WebView/WebDataSource.mm:
        (-[WebDataSource _transferApplicationCache:]):

2009-07-30  Darin Adler  <darin@apple.com>

        Reviewed by David Levin.

        Use checked casts for render tree
        https://bugs.webkit.org/show_bug.cgi?id=23522

        * Misc/WebNSAttributedStringExtras.mm:
        (fileWrapperForElement):
        * Misc/WebNSPasteboardExtras.mm:
        (imageFromElement):
        (-[NSPasteboard _web_declareAndWriteDragImageForElement:URL:title:archive:source:]):
        * WebView/WebFrame.mm:
        (-[WebFrame _computePageRectsWithPrintWidthScaleFactor:printHeight:]):
        (-[WebFrame _accessibilityTree]):
        * WebView/WebRenderNode.mm:
        (copyRenderNode):
        Use checked casts.

2009-07-31  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Anders Carlsson.
        
        Accelerated animations stutter on pages with lots of animations and 3d transforms
        https://bugs.webkit.org/show_bug.cgi?id=27884
        
        This patch changes the strategy for synchronizing painting view the view,
        and compositing layer updates. Previously the strategy was to disable screen
        updates between the time we updated the layer tree, and painted the view. That
        left screen updates disabled for too long (hundreds of milliseconds) in some
        cases, causing animation stutter.
        
        The new strategy is to batch up changes to the CA layer tree, and commit them
        all at once just before painting happens (referred to as a "sync" in the code).
        GraphicsLayerCA now keeps a bitmask of changed properties, and then migrates
        the values stored in GraphicsLayer into the CA layer tree at commit time.
        
        Compositing layers are then synced in FrameView::paintContents(). However, not
        all style/layout changes will result in painting; to deal with style changes that
        touch only compositing properties, we set up a runloop observer that takes care
        of comitting layer changes when no painting happens.

        * WebCoreSupport/WebChromeClient.h:
        * WebCoreSupport/WebChromeClient.mm:
        (WebChromeClient::scheduleCompositingLayerSync):
        scheduleViewUpdate() renamed to syncCompositingStateRecursive()
        
        * WebView/WebView.mm:
        (-[WebView _close]):
        (-[WebView _clearLayerSyncLoopObserver]):
        "viewUpdateRunLoopObserver" is now "layerSyncLoopObserver".

        (-[WebView _syncCompositingChanges]):
        Helper method that calls syncCompositingStateRecursive() on the FrameView.
        
        (layerSyncRunLoopObserverCallBack):
        (-[WebView _scheduleCompositingLayerSync]):
        This is all about layer sycning now. Also, the run loop observer is repeating,
        because it has to keep firing until syncCompositingStateRecursive() says that it
        has completed.
        
        * WebView/WebViewData.h:
        "viewUpdateRunLoopObserver" is now "layerSyncLoopObserver".

        * WebView/WebViewInternal.h:
        _scheduleViewUpdate is now _scheduleCompositingLayerSync

2009-07-30  Michael Nordman  <michaeln@google.com>

        Reviewed by Darin Fisher.

        https://bugs.webkit.org/show_bug.cgi?id=27821

        Mods to keep up with ApplicationCacheHost refactoring.

        * WebView/WebDataSource.mm:
        (-[WebDataSource _transferApplicationCache:]):

2009-07-29  David Kilzer  <ddkilzer@apple.com>

        <http://webkit.org/b/27788> Don't export WebPluginController.h as a private header

        Reviewed by Mark Rowe.

        * Plugins/WebPluginController.h: Changed #import of
        WebPluginContainerCheck.h to use a framework-style include in
        case other platforms wish to export WebPluginController.h as a
        private header.

2009-07-29  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Darin Adler.

        Added foundation work to allow a testing infrastructure for the Web
        Inspector.

        * WebCoreSupport/WebInspectorClient.h:
        * WebCoreSupport/WebInspectorClient.mm:
        (WebInspectorClient::inspectorWindowObjectCleared): Send the delegate
        callback.
        * WebView/WebDelegateImplementationCaching.h:
        * WebView/WebView.mm:
        (-[WebView _cacheFrameLoadDelegateImplementations]):
        * WebView/WebViewPrivate.h: The delegate SPI.

2009-07-27  Mark Rowe  <mrowe@apple.com>

        Reviewed by Darin Adler.

        <rdar://problem/7091036> REGRESSION: Microsoft Messenger crashes during file send/receive due to use of WebKit on non-main thread

        In some situations Microsoft Messenger can attempt to manipulate the DOM from a secondary thread while
        updating its file transfer progress bar.  This results in corruption of WebCore data structures that is
        quickly followed by a crash.  We can work around this by having -[WebFrame DOMDocument] return nil when
        called from a secondary thread by Microsoft Messenger, which has the effect of turning its attempts at
        DOM manipulation in to no-ops.

        * WebView/WebFrame.mm:
        (needsMicrosoftMessengerDOMDocumentWorkaround):
        (-[WebFrame DOMDocument]):

2009-07-27  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=27735
        Give a helpful name to JSLock constructor argument

        * Misc/WebCoreStatistics.mm:
        (+[WebCoreStatistics javaScriptObjectsCount]):
        (+[WebCoreStatistics javaScriptGlobalObjectsCount]):
        (+[WebCoreStatistics javaScriptProtectedObjectsCount]):
        (+[WebCoreStatistics javaScriptProtectedGlobalObjectsCount]):
        (+[WebCoreStatistics javaScriptProtectedObjectTypeCounts]):
        (+[WebCoreStatistics shouldPrintExceptions]):
        (+[WebCoreStatistics setShouldPrintExceptions:]):
        (+[WebCoreStatistics memoryStatistics]):
        (+[WebCoreStatistics javaScriptReferencedObjectsCount]):
        * Plugins/Hosted/NetscapePluginInstanceProxy.mm:
        (WebKit::NetscapePluginInstanceProxy::evaluate):
        (WebKit::NetscapePluginInstanceProxy::invoke):
        (WebKit::NetscapePluginInstanceProxy::invokeDefault):
        (WebKit::NetscapePluginInstanceProxy::construct):
        (WebKit::NetscapePluginInstanceProxy::getProperty):
        (WebKit::NetscapePluginInstanceProxy::setProperty):
        (WebKit::NetscapePluginInstanceProxy::removeProperty):
        (WebKit::NetscapePluginInstanceProxy::hasMethod):
        (WebKit::NetscapePluginInstanceProxy::enumerate):
        (WebKit::NetscapePluginInstanceProxy::addValueToArray):
        * Plugins/WebBaseNetscapePluginStream.mm:
        (WebNetscapePluginStream::wantsAllStreams):
        * Plugins/WebNetscapePluginView.mm:
        (-[WebNetscapePluginView sendEvent:isDrawRect:]):
        (-[WebNetscapePluginView setWindowIfNecessary]):
        (-[WebNetscapePluginView createPluginScriptableObject]):
        (-[WebNetscapePluginView evaluateJavaScriptPluginRequest:]):
        (-[WebNetscapePluginView webFrame:didFinishLoadWithReason:]):
        (-[WebNetscapePluginView loadPluginRequest:]):
        (-[WebNetscapePluginView _printedPluginBitmap]):
        * Plugins/WebPluginController.mm:
        (+[WebPluginController plugInViewWithArguments:fromPluginPackage:]):
        (-[WebPluginController startAllPlugins]):
        (-[WebPluginController stopAllPlugins]):
        (-[WebPluginController addPlugin:]):
        (-[WebPluginController destroyPlugin:]):
        (-[WebPluginController destroyAllPlugins]):
        * WebView/WebFrame.mm:
        (-[WebFrame _stringByEvaluatingJavaScriptFromString:forceUserGesture:]):
        * WebView/WebScriptDebugDelegate.mm:
        (-[WebScriptCallFrame scopeChain]):
        (-[WebScriptCallFrame evaluateWebScript:]):
        * WebView/WebView.mm:
        (-[WebView aeDescByEvaluatingJavaScriptFromString:]):

2009-07-24  Darin Adler  <darin@apple.com>

        Reviewed by Mark Rowe.

        REGRESSION (r46298): Exception after clicking on Bookmarks button in the Bookmarks Bar
        https://bugs.webkit.org/show_bug.cgi?id=27667

        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::transitionToCommittedForNewPage): Moved the code to set the
        title here. This is late enough that both the view and representation exist.

        * WebView/WebDataSource.mm:
        (-[WebDataSource _makeRepresentation]): Removed the code to set the title from here.
        It's a bit too early.

2009-07-24  Andrei Popescu  <andreip@google.com>

        Reviewed by Anders Carlsson.

        ApplicationCache should have size limit
        https://bugs.webkit.org/show_bug.cgi?id=22700

        Adds the WebApplicationCache class that is
        used by the DumpRenderTree test application to
        configure the Application Cache maximum size.

        * WebCoreSupport/WebApplicationCache.h: Added.
        * WebCoreSupport/WebApplicationCache.mm: Added.
        * WebCoreSupport/WebChromeClient.h:
        * WebCoreSupport/WebChromeClient.mm:
        (WebChromeClient::reachedMaxAppCacheSize):
        Adds empty implementation of the reachedMaxAppCacheSize callback.
        * WebKit.exp:

2009-07-23  Darin Adler  <darin@apple.com>

        * WebView/WebDataSource.mm:
        (-[WebDataSource _makeRepresentation]): Landed a comment I forgot last time.

2009-07-23  Darin Adler  <darin@apple.com>

        Reviewed by Brady Eidson.

        URL appears in back/forward button menu instead of title for items with custom representation
        https://bugs.webkit.org/show_bug.cgi?id=27586
        rdar://problem/5060337

        The problem is that DocumentLoader expects to store a title, but for custom representations
        it is never passed to the document loader.

        * WebView/WebDataSource.mm:
        (-[WebDataSource _makeRepresentation]): Added a call to DocumentLoader::setTitle.
        Works as long as the title does not change during the document's lifetime, which
        is good enough for the simple cases in Safari.

2009-07-20  Darin Adler  <darin@apple.com>

        Reviewed by Dan Bernstein.

        REGRESSION (r39185): Safari adds ".jpeg" extension to images that already have ".JPG" extension
        https://bugs.webkit.org/show_bug.cgi?id=27472

        * WebView/WebHTMLView.mm:
        (matchesExtensionOrEquivalent): Changed category method into a C function.
        Made it require the leading dot when checking for the extension and do it
        in a non-case-sensitive way.
        (-[WebHTMLView namesOfPromisedFilesDroppedAtDestination:]): Changed to call
        the function.

2009-07-21  Roland Steiner  <rolandsteiner@google.com>

        Reviewed by David Levin.

        Add ENABLE_RUBY to list of build options
        https://bugs.webkit.org/show_bug.cgi?id=27324

        * Configurations/FeatureDefines.xcconfig: Added flag ENABLE_RUBY.

2009-07-17  Brian Weinstein  <bweinstein@apple.com>

        Reviewed by Adam Roben.

        Fix of <rdar://problem/5712795> Win: Cannot change the height of the docked Web Inspector (14272)
        https://bugs.webkit.org/show_bug.cgi?id=14272
        
        Removed size calculation code from [WebInspectorWindowController setInitialAttachedHeight] into
        InspectorController.cpp to make it cross platform, and use InspectorController to store the 
        user's preferred size for an attached window, instead of NSUserDefaults.

        * WebCoreSupport/WebInspectorClient.mm:
        (-[WebInspectorWindowController showWindow:]):
        (-[WebInspectorWindowController setAttachedWindowHeight:]):

2009-07-16  Fumitoshi Ukai  <ukai@chromium.org>

        Reviewed by David Levin.

        Add --web-sockets flag and ENABLE_WEB_SOCKETS define.
        https://bugs.webkit.org/show_bug.cgi?id=27206
        
        Add ENABLE_WEB_SOCKETS

        * Configurations/FeatureDefines.xcconfig: add ENABLE_WEB_SOCKETS

2009-07-16  Xiaomei Ji  <xji@chromium.org>

        Reviewed by Darin Adler.

        Fix tooltip does not get its directionality from its element's directionality.
        https://bugs.webkit.org/show_bug.cgi?id=24187

        Per mitz's suggestion in comment #6, while getting the plain-text 
        title, we also get the directionality of the title. How to handle 
        the directionality is up to clients. Clients could ignore it, 
        or use attribute or unicode control characters to display the title
        as what they want.

        * Misc/WebElementDictionary.mm:
        (-[WebElementDictionary _spellingToolTip]): Change spellingToolTip caller due to signature change.
        (-[WebElementDictionary _title]): Change title caller due to signature change.
        * WebCoreSupport/WebChromeClient.h: Add directionality as 2nd parameter to setToolTip().
        * WebCoreSupport/WebChromeClient.mm:
        (WebChromeClient::setToolTip): Add directionality as 2nd parameter to setToopTip() (without handling it yet).

2009-07-15  Darin Adler  <darin@apple.com>

        Reviewed by Sam Weinig.

        Renamed parseURL to deprecatedParseURL.

        * DOM/WebDOMOperations.mm:
        (-[DOMDocument URLWithAttributeString:]): Renamed.
        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::createPlugin): Renamed.

2009-07-15  Brady Eidson  <beidson@apple.com>

        Reviewed by Dan Bernstein.

        https://bugs.webkit.org/show_bug.cgi?id=27304
        WebKit should provide usage and eligibility information about the page cache.

        * Misc/WebCoreStatistics.h:
        * Misc/WebCoreStatistics.mm:
        (+[WebCoreStatistics numberCachedPages]):
        (+[WebCoreStatistics numberCachedFrames]):
        (+[WebCoreStatistics numberAutoreleasedPages]):
        * WebKit.exp:

        * WebView/WebFrame.mm:
        (-[WebFrame _cacheabilityDictionary]): Returns a dictionary with all the data about
          why the frame is not cacheable. If the frame *is* cacheable, the dictionary is
          empty.
        * WebView/WebFramePrivate.h:

2009-07-13  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Dan Bernstein, Adam Roben.

        "Unrecognized selector" console log when the Safari 4 Welcome page navigates to Top Sites.
        <rdar://problem/6994893

        attachRootGraphicsLayer() should not assume that the frameView's documentView
        is a WebHTMLView.
        
        * WebCoreSupport/WebChromeClient.mm:
        (WebChromeClient::attachRootGraphicsLayer):

2009-07-13  Anders Carlsson  <andersca@apple.com>

        Reviewed by Darin Adler and Kevin Decker.

        <rdar://problem/7053687> Core Animation plug-ins continue to grow larger and larger when opening new tabs (32 bit-only)

        * Plugins/Hosted/WebHostedNetscapePluginView.mm:
        (-[WebHostedNetscapePluginView setLayer:]):
        Add a FIXME.
        
        * Plugins/WebNetscapePluginView.mm:
        (-[WebNetscapePluginView setLayer:]):
        Make sure to set the size of the layer before changing the autoresizing mask so it won't grow everytime it's inserted
        into the layer tree.

2009-07-13  Greg Bolsinga  <bolsinga@apple.com>

        Reviewed by Simon Fraser.

        Correct these delegate methods' declarations by adding parameter names.

        * WebView/WebUIDelegatePrivate.h:

2009-07-13  Drew Wilson  <atwilson@google.com>

        Reviewed by David Levin.

        Add ENABLE(SHARED_WORKERS) flag and define SharedWorker APIs
        https://bugs.webkit.org/show_bug.cgi?id=26932

        Added ENABLE(SHARED_WORKERS) flag (disabled by default).

        * Configurations/FeatureDefines.xcconfig:

2009-07-12  Keishi Hattori  <casey.hattori@gmail.com>

        Reviewed by Timothy Hatcher.

        Refactor ConsoleMessage to add MessageType attribute.
        https://bugs.webkit.org/show_bug.cgi?id=20625

        * WebCoreSupport/WebChromeClient.h:
        * WebCoreSupport/WebChromeClient.mm:
        (WebChromeClient::addMessageToConsole):

2009-07-11  Simon Fraser  <simon.fraser@apple.com>

        Enable support for accelerated compositing and 3d transforms on Leopard.
        <https://bugs.webkit.org/show_bug.cgi?id=20166>
        <rdar://problem/6120614>

        Reviewed by Oliver Hunt.

        * Configurations/FeatureDefines.xcconfig:

2009-07-10  David Kilzer  <ddkilzer@apple.com>

        Bug 27007: Build fixes when ICONDATABASE is disabled

        <https://bugs.webkit.org/show_bug.cgi?id=27007>

        Reviewed by Sam Weinig.

        * Misc/WebIconDatabase.mm:
        (defaultClient): Return 0 if ICONDATABASE is disabled.
        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::dispatchDidReceiveIcon): Commented out
        the body of the method if ICONDATABASE is disabled.
        (WebFrameLoaderClient::registerForIconNotification): Ditto.
        * WebCoreSupport/WebIconDatabaseClient.mm: Added #if
        ENABLE(ICONDATABASE)/#endif guard to source.
        * WebView/WebView.mm:
        (-[WebView setFrameLoadDelegate:]): Wrapped code that starts the
        icon database machinery in #if ENABLE(ICONDATABASE)/#endif.
        (-[WebView _registerForIconNotification:]): Wrapped method in
        #if ENABLE(ICONDATABASE)/#endif guard.
        (-[WebView _dispatchDidReceiveIconFromWebFrame:]): Ditto.
        * WebView/WebViewInternal.h: Wrapped methods in #if
        ENABLE(ICONDATABASE)/#endif guard.
        (-[WebView _registerForIconNotification:]):
        (-[WebView _dispatchDidReceiveIconFromWebFrame:]):

2009-07-10  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by John Sullivan.

        Flashing as hardware layers are created and destroyed in some content
        <rdar://problem/7032246>
        
        There's a window of time between the end of one runloop cycle, after CA layers changes
        have been committed, and the window display at the start of the next cycle when 
        CA may push updates to the screen before AppKit has drawn the view contents. If
        we know that we need to do drawing synchronization (which we do when content moves
        between a layer and the view), then we need to call -disableScreenUpdatesUntilFlush
        from the existing runloop observer that is set up when layers need repainting to
        ensure that layer updates don't reach the screen before view-based painting does.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView drawRect:]):
        Tweak the comments
        
        * WebView/WebView.mm:
        (viewUpdateRunLoopObserverCallBack):
        (-[WebView _scheduleViewUpdate]):
        Add a big comment to explain the timing of things.
        Call -disableScreenUpdatesUntilFlush when the view _needsOneShotDrawingSynchronization.

 2009-07-09  Brian Weinstein  <bweinstein@apple.com>
 
         Reviewed by Tim Hatcher.
2009-07-10  Adam Barth  <abarth@webkit.org>

        Reviewed by Sam Weinig with the power of Grayskull.

        Enable XSSAuditor by default.

        * WebView/WebPreferences.mm:
        (+[WebPreferences initialize]):

2009-07-10  Greg Bolsinga  <bolsinga@apple.com>

        Reviewed by Antti Koivisto.

        Add delegate methods about focus and blur and state change
        https://bugs.webkit.org/show_bug.cgi?id=27153

        Call the appropriate private delegate methods from the ChromeClient.
        
        * WebCoreSupport/WebChromeClient.h:
        * WebCoreSupport/WebChromeClient.mm:
        (WebChromeClient::formStateDidChange):
        (WebChromeClient::formDidFocus):
        (WebChromeClient::formDidBlur):
        * WebView/WebUIDelegatePrivate.h:

2009-07-09  Brian Weinstein  <bweinstein@apple.com>

        Reviewed by Tim Hatcher.

        https://bugs.webkit.org/show_bug.cgi?id=27141
        
        Updated WebInspectorClient to use Web Inspector Preferences to remember whether or not it should be 
        docked or a free window instead of NSUserDefaults it used to have.

        * WebCoreSupport/WebInspectorClient.mm:
        (-[WebInspectorWindowController init]):
        (-[WebInspectorWindowController showWindow:]):
        (-[WebInspectorWindowController attach]):
        (-[WebInspectorWindowController detach]):

2009-07-09  Drew Wilson  <atwilson@google.com>

        Reviewed by Alexey Proskuryakov.

        https://bugs.webkit.org/show_bug.cgi?id=26903

        Turned on CHANNEL_MESSAGING by default because the MessageChannel API
        can now be implemented for Web Workers and is reasonably stable.

        * Configurations/FeatureDefines.xcconfig:

2009-07-09  Darin Adler  <darin@apple.com>

        Reviewed by Adele Peterson and Dan Bernstein.

        <rdar://problem/7024972> Cannot set font to Helvetica Neue Light in Mail compose window

        No regression test because this only affects the font panel.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _addToStyle:fontA:fontB:]): Fix code that detects whether the font would
        survive a round trip by using the weight corresponding to "bold" or "normal" rather than
        the actual weight number.

2009-07-09  Beth Dakin and Jon Honeycutt <bdakin@apple.com>

        Reviewed by Dave Hyatt.

        Make Widget RefCounted to fix:

        <rdar://problem/7038831> REGRESSION (TOT): In Mail, a crash occurs 
        at WebCore::Widget::afterMouseDown() after clicking To Do's close 
        box
        <rdar://problem/6978804> WER #16: Repro Access Violation in 
        WebCore::PluginView::bindingInstance (1310178023)
        -and-
        <rdar://problem/6991251> WER #13: Crash in WebKit!
        WebCore::PluginView::performRequest+203 (1311461169) 

        * WebCoreSupport/WebFrameLoaderClient.h:
        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::createPlugin):

2009-07-09  Sam Weinig  <sam@webkit.org>

        Reviewed by Steve Falkenburg.

        Roll out r43848. The quirk is no longer necessary.

        * WebView/WebView.mm:
        (-[WebView WebCore::_userAgentForURL:WebCore::]):

2009-07-09  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Geoff Garen.

        <rdar://problem/6921671> Visit count shouldn't be incremented by redirects.

        * WebCoreSupport/WebFrameLoaderClient.mm: (WebFrameLoaderClient::updateGlobalHistory):
        Do not increase visit count if there is a redirect source. As a result, only pages that were
        explicitly visited by the user (by typing a URL, choosing one from bookmarks, or clicking
        a link) will be counted.

        * History/WebHistory.mm:
        (-[WebHistoryPrivate visitedURL:withTitle:increaseVisitCount:]):
        (-[WebHistory _visitedURL:withTitle:method:wasFailure:increaseVisitCount:]):
        * History/WebHistoryInternal.h:
        * History/WebHistoryItem.mm:
        (-[WebHistoryItem _visitedWithTitle:increaseVisitCount:]):
        * History/WebHistoryItemInternal.h:
        Marshal this new argument all the way down to WebCore.

2009-07-08  Greg Bolsinga  <bolsinga@apple.com>

        Reviewed by Darin Adler.

        Add -[WebView _isProcessingUserGesture]
        https://bugs.webkit.org/show_bug.cgi?id=27084

        Add -_isProcessingUserGesture that calls into WebCore::FrameLoader::isProcessingUserGesture()
        so that WebView code can determine if a user gesture is in progress.

        * WebView/WebView.mm:
        (-[WebView _isProcessingUserGesture]):
        * WebView/WebViewPrivate.h:

2009-07-07  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        - Fix <rdar://problem/6544693>.
        
        For Flash, don't cache which methods or fields in an object are missing, since they can
        be added at any time.
        
        * Plugins/Hosted/NetscapePluginHostManager.mm:
        (WebKit::NetscapePluginHostManager::hostForPackage):
        * Plugins/Hosted/NetscapePluginHostProxy.h:
        (WebKit::NetscapePluginHostProxy::shouldCacheMissingPropertiesAndMethods):
        * Plugins/Hosted/NetscapePluginHostProxy.mm:
        (WebKit::NetscapePluginHostProxy::NetscapePluginHostProxy):
        * Plugins/Hosted/ProxyInstance.mm:
        (WebKit::ProxyInstance::methodsNamed):
        (WebKit::ProxyInstance::fieldNamed):

2009-07-06  David Kilzer  <ddkilzer@apple.com>

        Bug 27006: Build fix when MAC_JAVA_BRIDGE is disabled

        <https://bugs.webkit.org/show_bug.cgi?id=27006>

        Reviewed by Darin Adler.

        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::createJavaAppletWidget): Wrap contents of
        the method in #if ENABLE(MAC_JAVA_BRIDGE)/#endif and return 0
        when this feature is disabled.

2009-07-06  David Kilzer  <ddkilzer@apple.com>

        Bug 27005: Build fixes when NETSCAPE_PLUGIN_API is disabled

        <https://bugs.webkit.org/show_bug.cgi?id=27005>

        Reviewed by Geoff Garen.

        * Plugins/WebPluginController.mm:
        (-[WebPluginController destroyPlugin:]): Wrap call to
        ScriptController::cleanupScriptObjectsForPlugin() in
        #if ENABLE(NETSCAPE_PLUGIN_API)/#endif macro.
        (-[WebPluginController destroyAllPlugins]): Ditto.
        * Plugins/WebPluginDatabase.mm:
        (-[WebPluginDatabase removePluginInstanceViewsFor:]): Wrap
        WebBaseNetscapePluginView class checks in
        #if ENABLE(NETSCAPE_PLUGIN_API)/#endif macro.
        (-[WebPluginDatabase destroyAllPluginInstanceViews]): Ditto.

2009-07-06  David Kilzer  <ddkilzer@apple.com>

        BUILD FIX: Use ENABLE(NETSCAPE_PLUGIN_API) instead of USE(PLUGIN_HOST_PROCESS)

        In r45579, #if/#endif macros for USE(PLUGIN_HOST_PROCESS) were
        used, but ENABLE(NETSCAPE_PLUGIN_API) should have been used
        instead.

        * Plugins/WebNetscapeContainerCheckContextInfo.h:
        * Plugins/WebNetscapeContainerCheckContextInfo.mm:
        * Plugins/WebNetscapeContainerCheckPrivate.mm:

2009-07-06  David Kilzer  <ddkilzer@apple.com>

        Bug 27004: Build fix for ENABLE(PLUGIN_PROXY_FOR_VIDEO) after r42618

        <https://bugs.webkit.org/show_bug.cgi?id=27004>

        Reviewed by Geoff Garen.

        * Plugins/WebPluginController.mm:
        (mediaProxyClient): Use core() method to convert from
        DOMElement to WebCore::Element.

2009-07-06  David Kilzer  <ddkilzer@apple.com>

        Bug 27003: Build fix when USE(PLUGIN_HOST_PROCESS) is disabled

        <https://bugs.webkit.org/show_bug.cgi?id=27003>

        Reviewed by Geoff Garen.

        * Plugins/WebNetscapeContainerCheckContextInfo.h: Added #if
        USE(PLUGIN_HOST_PROCESS)/#endif guards.
        * Plugins/WebNetscapeContainerCheckContextInfo.mm: Ditto.
        * Plugins/WebNetscapeContainerCheckPrivate.mm: Ditto.

2009-07-06  Anders Carlsson  <andersca@apple.com>

        Reviewed by Adele Peterson.

        Initialize wkIsLatchingWheelEvent.
        
        * WebCoreSupport/WebSystemInterface.m:
        (InitWebCoreSystemInterface):

2009-07-03  Dan Bernstein  <mitz@apple.com>

        Reviewed by Simon Fraser.

        - fix <rdar://problem/6964278> REGRESSION (r42118): Scrolling redraw
          problem in FileMaker Pro

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _recursiveDisplayRectIfNeededIgnoringOpacity:isVisibleRect:rectIsVisibleRectForView:topView:]):
        Perform layout if needed, even on Mac OS X versions that have
        -viewWillDraw. This prevents attempts to draw without layout in case
        -viewWillDraw was not called due to NSView issues or the client
        did something during the display operation that re-invalidated the
        layout.

2009-07-02  Anders Carlsson  <andersca@apple.com>

        Reviewed by Dan Bernstein.

        <rdar://problem/6978783> 
        Software-rendered plug-in does not update correctly when inside a hardware layer
        
        Replace calls to setNeedsDisplay: and setNeedsDisplayInRect: with a call to the new method
        invalidatePluginContentRect:. This new method will ask WebCore to do the repainting, taking
        transforms into account.
        
        * Plugins/Hosted/NetscapePluginInstanceProxy.mm:
        (WebKit::NetscapePluginInstanceProxy::invalidateRect):
        * Plugins/Hosted/WebHostedNetscapePluginView.mm:
        (-[WebHostedNetscapePluginView pluginHostDied]):
        * Plugins/WebBaseNetscapePluginView.h:
        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView windowBecameKey:]):
        (-[WebBaseNetscapePluginView windowResignedKey:]):
        (-[WebBaseNetscapePluginView preferencesHaveChanged:]):
        (-[WebBaseNetscapePluginView invalidatePluginContentRect:]):
        * Plugins/WebNetscapePluginView.mm:
        (-[WebNetscapePluginView invalidateRect:]):
        (-[WebNetscapePluginView invalidateRegion:]):
        (-[WebNetscapePluginView forceRedraw]):

2009-07-02  Adam Roben  <aroben@apple.com>

        Fix warnings from update-webkit-localizable-strings

        Rubber-stamped by Eric Carlson.

        * WebCoreSupport/WebViewFactory.mm:
        (-[WebViewFactory mediaElementLoadingStateText]):
        (-[WebViewFactory mediaElementLiveBroadcastStateText]):
        Changed the localization comments to match the comments in the Windows
        version of this file, to avoid warnings about different comments for
        the same localized string.

2009-07-02  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Dan Bernstein.
        
        Compositing-related preference methods are not public API; should move to WebPreferencesPrivate.h
        <rdar://problem/7027363>

        Move accelerated-compositing pref to WebPreferencesPrivate.h

        * WebView/WebPreferences.h:
        * WebView/WebPreferences.mm:
        (-[WebPreferences acceleratedCompositingEnabled]):
        (-[WebPreferences setAcceleratedCompositingEnabled:]):
        * WebView/WebPreferencesPrivate.h:

2009-07-02  Pierre d'Herbemont  <pdherbemont@apple.com>

        Reviewed by Simon Fraser.

        <rdar://problem/6518119>

        Add localized strings for media controller status messages.

        * WebCoreSupport/WebViewFactory.mm: Add new localized text.
        (-[WebViewFactory mediaElementLoadingStateText]):
        (-[WebViewFactory mediaElementLiveBroadcastStateText]):

2009-07-01  Brady Eidson  <beidson@apple.com>

        Reviewed by Sam Weinig.

        Add a preference/setting to toggle whether content sniffing is enabled for file URLs.

        * WebView/WebPreferenceKeysPrivate.h:

        * WebView/WebPreferences.mm:
        (+[WebPreferences initialize]):
        (-[WebPreferences localFileContentSniffingEnabled]):
        (-[WebPreferences setLocalFileContentSniffingEnabled:]):
        * WebView/WebPreferencesPrivate.h:

        * WebView/WebView.mm:
        (-[WebView _preferencesChangedNotification:]):

2009-07-01  David Hyatt  <hyatt@apple.com>

        Reviewed by Tim Hatcher.

        <rdar://problem/6998524> REGRESSION (r44474): Form text field has focus ring, looks focused,
        even though the field is not actually focused for keyboard input
        
        Add the concept of whether or not the Page is focused by adding a boolean to the focusController.  This allows the
        focused frame and focused node to both be cached and changed programmatically without causing errors when the Page doesn't
        have focus.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView becomeFirstResponder]):
        (-[WebHTMLView resignFirstResponder]):

2009-06-30  Adele Peterson  <adele@apple.com>

        Reviewed by Dan Bernstein.

        Fix for <rdar://problem/7014389> REGRESSION(4-TOT): Hyperlinks have no tooltips in Mail unless you first click in the message body

        Updated these new methods (added as part of the viewless WebKit effort) that call through to WebHTMLView to use _selectedOrMainFrame, 
        instead of just selectedFrame.  When the selection changes, I don't think there is a situation where there's no selected frame, but
        it seems better to keep these two uses the same, since if there is a case, this will be more like the old behavior, before there was
        a version of _selectionChanged in WebView. 

        * WebView/WebView.mm:
        (-[WebView _setToolTip:]):
        (-[WebView _selectionChanged]):

2009-06-30  Mark Rowe  <mrowe@apple.com>

        Reviewed by Timothy Hatcher.

        <rdar://problem/7006959> 'Save as…’ does not work in Mail

        * WebView/WebFrameView.mm:
        (-[WebFrameView initWithFrame:]): Call _needMailThreadWorkaroundIfCalledOffMainThread rather than
        needMailThreadWorkaround, as the latter is intended to be used at the point which a workaround would
        be applied and thus contains a main thread check.  Since -initWithFrame: is called on the main thread,
        this was causing us to not switch from exception-throwing to logging for the thread violation behavior.

2009-06-30  Dan Bernstein  <mitz@apple.com>

        Reviewed by Dave Hyatt.

        - fix <rdar://problem/6946611> REGRESSION (r30673): Shade10:" D_Snap
          to Grid" window is clipping

        * Misc/WebKitVersionChecks.h: Added
            WEBKIT_FIRST_VERSION_WITHOUT_SHADE10_QUIRK
        * WebView/WebView.mm:
        (-[WebView _needsLinkElementTextCSSQuirk]): Added. Returns YES if the
            client app is a version of Shade 10 earlier than 10.6 and it was
            linked against a version of WebKit earlier than 531.2.
        (-[WebView _preferencesChangedNotification:]): Added a call to
            Settings::setTreatsAnyTextCSSLinkAsStylesheet().

2009-06-29  Eric Carlson  <eric.carlson@apple.com>

        Reviewed by Simon Fraser.

        <rdar://problem/7014813> Ask media engine if a movie is streamed or downloaded.

        * WebCoreSupport/WebSystemInterface.m:
        (InitWebCoreSystemInterface):
            Add QTMovieGetType.

2009-06-29  David Hyatt  <hyatt@apple.com>

        Reviewed by Adam Roben.

        Put datagrid behind an #ifdef.

        * Configurations/FeatureDefines.xcconfig:

2009-06-26  John Sullivan  <sullivan@apple.com>

        Added support for disabling Stop Speaking when there is no speaking to stop.
        Also fixed Stop Speaking so that it works (formerly it would throw an exception, and
        selecting it from the menu would perform a web search instead (!)).

        Reviewed by Tim Hatcher.

        * WebCoreSupport/WebContextMenuClient.h:
        declare isSpeaking()
        
        * WebCoreSupport/WebContextMenuClient.mm:
        (WebContextMenuClient::isSpeaking):
        implement by calling through to NSApplication
        (WebContextMenuClient::stopSpeaking):
        fixed implementation by correcting the signature of the NSApplication method

2009-06-26  Chris Marrin  <cmarrin@apple.com>

        Reviewed by Simon Fraser  <simon.fraser@apple.com>.

        Additional fix for https://bugs.webkit.org/show_bug.cgi?id=26651

        The flag should always default to true to avoid it getting set
        to false in a build with accelerated compositing turned off
        and then disabling accelerated compositing when subsequently
        running a build with it turned on.

        * WebView/WebPreferences.mm:
        (+[WebPreferences initialize]):

2009-06-26  Brady Eidson  <beidson@apple.com>

        Fix SnowLeopard build.

        * Plugins/Hosted/HostedNetscapePluginStream.mm:
        (WebKit::HostedNetscapePluginStream::didReceiveResponse):

2009-06-26  Brady Eidson  <beidson@apple.com>

        Reviewed by Sam Weinig

        <rdar://problem/6961578> REGRESSION (r43511): Opening .fdf files from Acrobat Professional fails

        Replace all usage of the now obsolete [NSURLResponse _webcore_MIMEType].

        * Plugins/WebBaseNetscapePluginStream.mm:
        (WebNetscapePluginStream::didReceiveResponse):
        * Plugins/WebNetscapePluginView.mm:
        (-[WebNetscapePluginView pluginView:receivedData:]):
        * Plugins/WebPluginController.mm:
        (-[WebPluginController pluginView:receivedResponse:]):
        * WebView/WebDataSource.mm:
        (-[WebDataSource _responseMIMEType]):
        * WebView/WebResource.mm:
        (-[WebResource _initWithData:URL:response:]):

2009-06-26  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Sam Weinig.

        <rdar://problem/6651201> Update lookalike character list.

        * Misc/WebNSURLExtras.mm: (isLookalikeCharacter): Added more characters to the list.

2009-06-25  Anders Carlsson  <andersca@apple.com>

        Reviewed by Oliver Hunt.

        <rdar://problem/6989017> 
        REGRESSION (SnowLeopard): RealPlayer content replays when opening a new tab or switching back to the RealPlayer tab
        
        If a plug-in fails in NPP_New, we would try to recreate it whenever the preferences for a web view would change. 
        
        Fix this by setting a flag when we fail to instantiate the plug-in, so we only try once.
        
        * Plugins/WebBaseNetscapePluginView.h:
        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView start]):

2009-06-25  Chris Marrin  <cmarrin@apple.com>

        Reviewed by Simon Fraser  <simon.fraser@apple.com>.

        https://bugs.webkit.org/show_bug.cgi?id=26651
        
        Preference is named "WebKitAcceleratedCompositingEnabled"
        and is a boolean value. When false, prevents compositing layers from
        being created, which prevents hardware animation from running.
        Also forces video to do software rendering. Added a cache for
        the flag in RenderLayerCompositing and made it all work
        on-the-fly when the flag is changed while a page is loaded.

        * WebView/WebPreferenceKeysPrivate.h:
        * WebView/WebPreferences.h:
        * WebView/WebPreferences.mm:
        (+[WebPreferences initialize]):
        (-[WebPreferences acceleratedCompositingEnabled]):
        (-[WebPreferences setAcceleratedCompositingEnabled:]):
        * WebView/WebView.mm:
        (-[WebView _preferencesChangedNotification:]):

2009-06-24  Dan Bernstein  <mitz@apple.com>

        Reviewed by Anders Carlsson.

        Fix the most recently seen kind of crash in <rdar://problem/5983224>

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView adjustPageHeightNew:top:bottom:limit:]): Null-check the
        Frame.

2009-06-24  Jeff Johnson  <opendarwin@lapcatsoftware.com>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=26638 WebKitErrors.m: _initWithPluginErrorCode: does not set localizedDescription

        Add localized descriptions for plugin errors.
        The localized strings already existed but were unused; now NSLocalizedDescriptionKey is added to the NSError userInfo.

        * Misc/WebKitErrors.m:
        (-[NSError _initWithPluginErrorCode:contentURL:pluginPageURL:pluginName:MIMEType:]):

2009-06-23  Brady Eidson  <beidson@apple.com>

        Reviewed by Darin Adler.

        <rdar://problem/6950660> REGRESSION: iSale 5.5.3 crashes after I click a template to load

        Due to some subtle WebKit changes - presumably some delegate callback behavior - a latent bug in 
        iSale was uncovered where they aren't properly retaining their FrameLoadDelegate, and we ended up
        calling back to a dealloc'ed object.

        * WebView/WebView.mm:
        (-[WebView _needsAdobeFrameReloadingQuirk]): Use more intelligent C++-style initialization.
        (-[WebView _needsKeyboardEventDisambiguationQuirks]): Ditto.
        (-[WebView _needsFrameLoadDelegateRetainQuirk]): YES for iSale versions under 5.6
        (-[WebView dealloc]): Release the delegate if the quirk is in effect.
        (-[WebView setFrameLoadDelegate:]): Retain the new delegate if the quirk is in effect.

2009-06-23  Anders Carlsson  <andersca@apple.com>

        Reviewed by Darin Adler.

        - Fix <rdar://problem/6965672>
        
        Defer calls to WKPCInvalidateRect, so we don't try to invalidate while waiting for a reply, since
        that is too early.
        
        * Plugins/Hosted/NetscapePluginHostProxy.h:
        (WebKit::NetscapePluginHostProxy::isProcessingRequests):
        * Plugins/Hosted/NetscapePluginHostProxy.mm:
        (WebKit::NetscapePluginHostProxy::NetscapePluginHostProxy):
        (WebKit::NetscapePluginHostProxy::processRequests):
        (WKPCInvalidateRect):

2009-06-22  Timothy Hatcher  <timothy@apple.com>

        Add Mail on Tiger and Leopard to the list of applications that need the WebView init thread workaround.

        <rdar://problem/6929524> Console shows WebKit Threading Violations from Mail

        Reviewed by Anders Carlsson.

        * WebView/WebView.mm:
        (clientNeedsWebViewInitThreadWorkaround): Return true for com.apple.Mail.

2009-06-22  Dan Bernstein  <mitz@apple.com>

        Reviewed by Anders Carlsson.

        - speculative fix for <rdar://problem/6889082>
          Crash at -[WebHTMLView(WebPrivate) _updateMouseoverWithEvent:]

        The crash seems to happen because lastHitView points to a deleted
        object. Since -close calls -_clearLastHitViewIfSelf, I speculate that
        lastHitView has been set to an already-closed view.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView hitTest:]): Return nil if the view is closed.

2009-06-22  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by John Sullivan.

        <rdar://problem/6956606> REGRESSION (S4Beta -> Final): After the password is input,
        Japanese can't be input.

        * WebView/WebHTMLView.mm: (-[WebHTMLView _updateSelectionForInputManager]): Removed an
        unnecessary check - the function has an early return for null frame.

2009-06-22  Dan Bernstein  <mitz@apple.com>

        Reviewed by Dave Hyatt.

        - fix <rdar://problem/6990938> REGRESSION (r42787): After showing and
          hiding the Find banner, the WebHTMLView's height is not restored

        * WebView/WebFrameView.mm:
        (-[WebFrameView setFrameSize:]): Mark the FrameView for layout when the
        WebFrameView's size changes.
        * WebView/WebView.mm:
        (-[WebView setFrameSize:]): Left the resize logic here, but only for
        the single view model.

2009-06-20  Darin Adler  <darin@apple.com>

        Reviewed by Sam Weinig.

        <rdar://problem/6964221> Need more processing of pluginspage.

        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::createPlugin): Check protocolInHTTPFamily.

2009-06-18  Adam Barth  <abarth@webkit.org>

        Reviewed by Sam Weinig.

        https://bugs.webkit.org/show_bug.cgi?id=26199

        Added preference to enable the XSSAuditor.

        * WebView/WebPreferenceKeysPrivate.h:
        * WebView/WebPreferences.mm:
        (+[WebPreferences initialize]):
        (-[WebPreferences isXSSAuditorEnabled]):
        (-[WebPreferences setXSSAuditorEnabled:]):
        * WebView/WebPreferencesPrivate.h:
        * WebView/WebView.mm:
        (-[WebView _preferencesChangedNotification:]):

2009-06-18  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        <rdar://problem/6926859>
        NPN_ConvertPoint doesn't give the right value when converting to/from NPCoordinateSpaceFlippedScreen
        
        When inverting Y, use the height of the first screen instead of the screen the window is on.
        
        * Plugins/Hosted/NetscapePluginInstanceProxy.mm:
        (WebKit::NetscapePluginInstanceProxy::windowFrameChanged):
        (WebKit::NetscapePluginInstanceProxy::mouseEvent):
        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView convertFromX:andY:space:toX:andY:space:]):

2009-06-16  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Dan Bernstein

        <rdar://problem/6976766> Control-click on pages with accelerated compositing
        content does not work.
        
        Part deux. #ifdef the use of _private->layerHostingView with 
        USE(ACCELERATED_COMPOSITING)

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView hitTest:]):

2009-06-16  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Dan Bernstein

        <rdar://problem/6976766> Control-click on pages with accelerated compositing
        content does not work.
        
        Remove the WebLayerHostingView subclass of NSView, with its attempts to
        forward events to the WebHTMLView, and just fix -[WebHTMLView hitTest:]
        to ignore the layerHostingView.
        
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView hitTest:]):
        (-[WebHTMLView attachRootLayer:]):

2009-06-15  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Mark Rowe.

        <rdar://problem/6974857>
        
        Define ENABLE_3D_RENDERING when building on 10.6, and move ENABLE_3D_RENDERING
        switch from config.h to wtf/Platform.h.

        * Configurations/FeatureDefines.xcconfig:
        * WebKitPrefix.h:

2009-06-15  Anders Carlsson  <andersca@apple.com>

        Reviewed by Dan Bernstein.

        <rdar://problem/6967569>
        CrashTracer: 15 crashes in Safari at com.apple.WebKit • WebKit::NetscapePluginHostManager::didCreateWindow + 85
        
        Make sure to remove the entry from the plug-in host map so we won't end up with an entry that has a null value.
        
        * Plugins/Hosted/NetscapePluginHostManager.mm:
        (WebKit::NetscapePluginHostManager::hostForPackage):

2009-06-15  Dan Bernstein  <mitz@apple.com>

        Reviewed by Tim Hatcher.

        - make the source code font in the Web Inspector match Mac defaults

        * WebCoreSupport/WebInspectorClient.mm:
        (-[WebInspectorWindowController init]): Set the default monospace font
        to 11px Menlo, except on Leopard and Tiger where it is 10px Monaco.

2009-06-09  Justin Garcia  <justin.garcia@apple.com>

        Reviewed by Eric Seidel.  Landed by Adam Barth.

        https://bugs.webkit.org/show_bug.cgi?id=26281

        REGRESSION: Copying from TextEdit/OmniGraffle and pasting into editable
        region loses images
        
        Prefer RTFD (RTF with inline images) over RTF.  In
        http://trac.webkit.org/changeset/19745 I accidently reversed their
        order.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _documentFragmentFromPasteboard:inContext:allowPlainText:]): 

2009-06-13  Adam Barth  <abarth@webkit.org>

        Reviewed by Darin Fisher.

        https://bugs.webkit.org/show_bug.cgi?id=24492

        Move registerURLSchemeAsLocal from FrameLoader to SecurityOrigin

        * WebView/WebView.mm:
        (+[WebView registerURLSchemeAsLocal:]):

2009-06-12  Peter Kasting  <pkasting@google.com>

        Reviewed by Eric Seidel.

        * ChangeLog-2007-10-14: Change pseudonym "Don Gibson" to me (was used while Google Chrome was not public); update my email address.

2009-06-08  Dan Bernstein  <mitz@apple.com>

        Rubber-stamped by Mark Rowe.

        - gave Objective-C++ files the .mm extension

        * Carbon/HIWebView.m: Removed.
        * Carbon/HIWebView.mm: Copied from WebKit/mac/Carbon/HIWebView.m.
        * Misc/WebKitNSStringExtras.m: Removed.
        * Misc/WebKitNSStringExtras.mm: Copied from WebKit/mac/Misc/WebKitNSStringExtras.m.
        * Misc/WebStringTruncator.m: Removed.
        * Misc/WebStringTruncator.mm: Copied from WebKit/mac/Misc/WebStringTruncator.m.
        * WebInspector/WebNodeHighlight.m: Removed.
        * WebInspector/WebNodeHighlight.mm: Copied from WebKit/mac/WebInspector/WebNodeHighlight.m.
        * WebInspector/WebNodeHighlightView.m: Removed.
        * WebInspector/WebNodeHighlightView.mm: Copied from WebKit/mac/WebInspector/WebNodeHighlightView.m.
        * WebView/WebDynamicScrollBarsView.m: Removed.
        * WebView/WebDynamicScrollBarsView.mm: Copied from WebKit/mac/WebView/WebDynamicScrollBarsView.m.

2009-06-05  David Hyatt  <hyatt@apple.com>

        Reviewed by Mark Rowe.

        https://bugs.webkit.org/show_bug.cgi?id=26220

        Update a WebView's active state when it moves to a different window.

        * WebView/WebView.mm:
        (-[WebView viewDidMoveToWindow]):

2009-06-04  Sam Weinig  <sam@webkit.org>

        Reviewed by Alice Liu.

        Move WebView internal data into WebViewData.h/mm.

        * WebView/WebDelegateImplementationCaching.mm:
        * WebView/WebView.mm:
        * WebView/WebViewData.h: Copied from mac/WebView/WebViewInternal.h.
        * WebView/WebViewData.mm: Copied from mac/WebView/WebViewInternal.mm.
        * WebView/WebViewInternal.h:
        * WebView/WebViewInternal.mm: Removed.

2009-06-04  David Hyatt  <hyatt@apple.com>

        Reviewed by Sam Weinig.

        Remove _updateFocusedStateForFrame, since it's actually not even necessary now that I made
        setFocusedFrame get called explicitly from become/ResignFirstResponder.  setFocusedFrame does
        the work of focusing the selection already.

        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::transitionToCommittedForNewPage):
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView becomeFirstResponder]):
        (-[WebHTMLView resignFirstResponder]):
        * WebView/WebView.mm:
        * WebView/WebViewInternal.h:

2009-06-04  Dan Bernstein  <mitz@apple.com>

        - build fix

        * WebView/WebViewInternal.mm:

2009-06-03  David Hyatt  <hyatt@apple.com>

        Reviewed by Sam Weinig.

        Reworking of focus and active state updating for WebHTMLViews so that it actually works instead of reporting wrong answers.

        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::transitionToCommittedForNewPage):
        WebHTMLViews become first responders before they are able to reach their Frames/Pages.  This happens because the NSClipView
        becomes first responder when the WebHTMLView gets destroyed, and then we transfer the responder state back to the new WebHTMLView
        when it is first connected.  Once we have transitioned to a new page and have the Frame/Page available, go ahead and explicitly
        focus the frame in WebCore and update our focused state.  This change allows us to remove the updateFocusedActive timer and the
        code from viewDidMoveToWindow.
        
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView close]):
        (-[WebHTMLView addWindowObservers]):
        (-[WebHTMLView viewWillMoveToWindow:]):
        (-[WebHTMLView viewDidMoveToWindow]):
        (-[WebHTMLView _removeWindowObservers]):
        Remove all the updateFocusedActiveState timer code, since it no longer exists.

        (-[WebHTMLView windowDidBecomeKey:]):
        (-[WebHTMLView windowDidResignKey:]):
        Active state updating is no longer done by WebHTMLViews.   It is handled by the WebView instead.
    
        (-[WebHTMLView becomeFirstResponder]):
        (-[WebHTMLView resignFirstResponder]):
        Reworking of WebHTMLView's code for gaining/losing responder status.  No longer update active state here, since the active state
        can never change just because of responder changes.  Make sure that the focused frame gets updated properly (and most importantly
        actually cleared when a WebHTMLView resigns responder status).

        * WebView/WebHTMLViewInternal.h:
        * WebView/WebHTMLViewPrivate.h:
        State updating for focused and active states has been made independent.

        * WebView/WebView.mm:
        (-[WebView _updateActiveState]):
        WebView now handles updating of active state in _updateActiveState.  It is now purely based off whether the window is key and nothing
        else.

        (-[WebView addWindowObserversForWindow:]):
        (-[WebView removeWindowObservers]):
        Start listening for the window becoming/losing key even in the usesDocumentViews case.

        (-[WebView _updateFocusedStateForFrame:]):
        Focused state updating is split into its own method now and called when WebHTMLViews gain and lose responder status.

        (-[WebView _windowDidBecomeKey:]):
        (-[WebView _windowDidResignKey:]):
        Make sure to call _updateActiveState as the window gains/loses key.

        (-[WebView _windowWillOrderOnScreen:]):
        Run this code now that WebHTMLView no longer does it.

        * WebView/WebViewInternal.h:
        * WebView/WebViewPrivate.h:
        Updating for the split of focused and active state updating into separate methods.

2009-06-04  Mark Rowe  <mrowe@apple.com>

        Speculative Tiger build fix.

        * WebView/WebDelegateImplementationCaching.h:

2009-06-03  Sam Weinig  <sam@webkit.org>

        Reviewed by Mark Rowe.

        Move delegate implementation caching logic into its own files.

        * WebView/WebDelegateImplementationCaching.h: Copied from mac/WebView/WebViewInternal.h.
        * WebView/WebDelegateImplementationCaching.mm: Copied from mac/WebView/WebView.mm.
        (WebViewGetResourceLoadDelegateImplementations):
        (WebViewGetFrameLoadDelegateImplementations):
        (WebViewGetScriptDebugDelegateImplementations):
        * WebView/WebView.mm:
        * WebView/WebViewInternal.h:

2009-06-03  Sam Weinig  <sam@webkit.org>

        Reviewed by Mark Rowe.

        Move WebViewPrivate structure to WebViewInternal.h/mm.

        * WebView/WebView.mm:
        * WebView/WebViewInternal.h:
        * WebView/WebViewInternal.mm: Added.
        (+[WebViewPrivate initialize]):
        (-[WebViewPrivate init]):
        (-[WebViewPrivate dealloc]):
        (-[WebViewPrivate finalize]):

2009-06-03  Sam Weinig  <sam@webkit.org>

        Reviewed by Darin Adler.

        Small cleanup in WebView.
        - Move global data initialization to WebView's initialization method.
        - Move _clearViewUpdateRunLoopObserver from WebViewPrivate to WebView (FileInternal)

        * WebView/WebView.mm:
        (-[WebViewPrivate init]): Remove global initializers.
        (-[WebViewPrivate dealloc]): Cleanup whitespace.
        (-[WebViewPrivate finalize]): Ditto.
        (-[WebView _close]): Call [self _clearViewUpdateRunLoopObserver] instead of
        [_private _clearViewUpdateRunLoopObserver]
        (+[WebView initialize]): Move global initializers here.
        (-[WebView _clearViewUpdateRunLoopObserver]): Moved from WebViewPrivate.
        (viewUpdateRunLoopObserverCallBack): Call [self _clearViewUpdateRunLoopObserver]
        instead of [_private _clearViewUpdateRunLoopObserver]

2009-06-03  Dan Bernstein  <mitz@apple.com>

        Reviewed by Anders Carlsson.

        - WebKit part of eliminating WebCoreTextRenderer

        * Misc/WebKitNSStringExtras.m:
        (webkit_CGCeiling): Added.
        (-[NSString _web_drawAtPoint:font:textColor:]): Replaced the malloc()ed
            string buffer with a Vector. Moved code from
            WebCoreDrawTextAtPoint() to here.
        (-[NSString _web_drawDoubledAtPoint:withTopColor:bottomColor:font:]):
        (-[NSString _web_widthWithFont:]): Replaced the malloc()ed string buffer
            with a Vector. Moved code from WebCoreTextFloatWidth() to here.
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _addToStyle:fontA:fontB:]): Replaced call to
            WebCoreFindFont() with use of
            +[WebFontCache fontWithFamily:traits:weight:size:].
        * WebView/WebView.mm:
        (+[WebView _setAlwaysUsesComplexTextCodePath:]): Changed to call
            Font::setCodePath() directly.
        (+[WebView _setShouldUseFontSmoothing:]): Changed to call
            Font::setShouldUseSmoothing().
        (+[WebView _shouldUseFontSmoothing]): Changed to call 
            Font::shouldUseSmoothing().

2009-06-03  Dan Bernstein  <mitz@apple.com>

        Rubber-stamped by Mark Rowe.

        - remove a private method that was used only by Safari 3.0.

        * WebView/WebView.mm: Removed +_minimumRequiredSafariBuildNumber.
        * WebView/WebViewPrivate.h: Ditto.

2009-06-03  Dan Bernstein  <mitz@apple.com>

        - build fix

        * WebView/WebHTMLView.mm:

2009-06-03  Dan Bernstein  <mitz@apple.com>

        Reviewed by Anders Carlsson.

        - build fix

        * WebView/WebHTMLView.mm:
        * WebView/WebView.mm:

2009-06-02  Darin Adler  <darin@apple.com>

        Reviewed by David Hyatt.

        Bug 26112: viewless WebKit -- make events work
        https://bugs.webkit.org/show_bug.cgi?id=26112

        One change here is to make the -[WebFrame frameView] function assert if ever called
        in viewless mode, and fix many callers that would trip that assertion.

        A major change is to put some methods and data in WebView that are currently in
        WebHTMLView, used only in viewless mode. A next step will be to use the WebView
        methods whenever possible, even when not in the viewless mode.

        Also fix FrameView to do normal reference counting instead of a strange model with
        an explicit deref near creation time.

        * WebCoreSupport/WebChromeClient.mm:
        (WebChromeClient::scrollRectIntoView): Add code to start in the appropriate place
        when dealing with viewless mode. This gets triggered when visiting the Google home page.
        (WebChromeClient::setToolTip): Changed to call WebView instead of WebHTMLView.
        (WebChromeClient::print): Changed to use a new selector that doesn't require a
        WebFrameView if present. Also don't even try to use the old selector in viewless mode.

        * WebCoreSupport/WebEditorClient.mm:
        (WebEditorClient::respondToChangedSelection): Changed to call WebView instead of WebHTMLView.

        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::transitionToCommittedForNewPage): Added more code paths for
        viewless mode to skip things we can't do in that mode, with appropriate FIXME.
        Use Frame::create and RefPtr and eliminate the strange reference counting of FrameView.

        * WebView/WebDataSource.mm:
        (-[WebDataSource _receivedData:]): Added a _usesDocumentViews guard around code that's
        specific to document views.

        * WebView/WebFrame.mm:
        (-[WebFrame _updateBackgroundAndUpdatesWhileOffscreen]): Added a _usesDocumentViews
        guard around code that's specific to document views.
        (-[WebFrame _hasSelection]): Added an implementation for viewless mode.
        (-[WebFrame _clearSelection]): Assert we're not in viewless mode; it doesn't really
        make sense to clear the selection in only one frame in viewless mode. Later we can
        decide what to do.
        (-[WebFrame _dragSourceMovedTo:]): Assert we're not in viewless mode; the dragging
        code for viewless mode shouldn't have to involve the WebFrame object at all.
        (-[WebFrame _dragSourceEndedAt:operation:]): Ditto.
        (-[WebFrame frameView]): Assert we're not in viewless mode. This assertion fires
        often, but it's a great pointer to code that needs to be changed.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView hitTest:]): Tweaked a comment.
        (-[WebHTMLView _updateMouseoverWithEvent:]): Fixed a bug where the fake event for
        moving the mouse out of the old view ended up overwriting the event for moving
        the mouse within the new view.
        (-[WebHTMLView mouseDown:]): Got rid of explicit conversion of event to
        PlatformMouseEvent in call to sendContextMenuEvent; that's no longer possible
        without passing another argument, and it's now handled in EventHandler.

        * WebView/WebTextCompletionController.h: Copied from WebKit/mac/WebView/WebHTMLView.mm.
        Removed everything except for the WebTextCompletionController class.
        * WebView/WebTextCompletionController.mm: Copied from WebKit/mac/WebView/WebHTMLView.mm.
        Ditto.

        * WebView/WebUIDelegatePrivate.h: Added webView:printFrame: method.

        * WebView/WebView.mm: Moved includes and fields in from WebHTMLView.
        (-[WebView _usesDocumentViews]): Updated for name change from useDocumentViews
        to usesDocumentViews.
        (-[WebView _commonInitializationWithFrameName:groupName:usesDocumentViews:]): Ditto.
        (-[WebView drawSingleRect:]): Ditto.
        (-[WebView isFlipped]): Ditto.
        (-[WebView setFrameSize:]): Ditto. Also changed to use _mainCoreFrame method.
        (-[WebView _viewWillDrawInternal]): Ditto.
        (-[WebView viewWillDraw]): Ditto.
        (-[WebView drawRect:]): Ditto.
        (-[WebView _close]): Added code to nil out the lastMouseoverView global.
        (-[WebView _dashboardRegions]): Use _mainCoreFrame.
        (-[WebView setProhibitsMainFrameScrolling:]): Ditto.
        (-[WebView _setInViewSourceMode:]): Ditto.
        (-[WebView _inViewSourceMode]): Ditto.
        (-[WebView _attachScriptDebuggerToAllFrames]): Ditto.
        (-[WebView _detachScriptDebuggerFromAllFrames]): Ditto.
        (-[WebView textIteratorForRect:]): Ditto.
        (-[WebView _executeCoreCommandByName:value:]): Ditto.
        (-[WebView addWindowObserversForWindow:]): Ditto.
        (-[WebView removeWindowObservers]): Ditto.
        (-[WebView _updateFocusedAndActiveState]): Ditto.
        (-[WebView _updateFocusedAndActiveStateForFrame:]): Turned into a class method.
        Added code to handle the viewless case without calling frameView.
        (-[WebView _windowDidBecomeKey:]): Updated for name change from useDocumentViews
        to usesDocumentViews.
        (-[WebView _windowDidResignKey:]): Ditto.
        (-[WebView _windowWillOrderOnScreen:]): Ditto.
        (-[WebView mainFrame]): Tweaked.
        (-[WebView selectedFrame]): Added a conditional to avoid trying to get at the
        frame view in viewless case.
        (-[WebView _setZoomMultiplier:isTextOnly:]): Use _mainCoreFrame.
        (-[WebView setCustomTextEncodingName:]): Ditto.
        (-[WebView windowScriptObject]): Ditto.
        (-[WebView setHostWindow:]): Ditto. Also put some code that's needed only for
        document views inside _private->usesDocumentViews.
        (-[WebView _hitTest:dragTypes:]): Tweaked.
        (-[WebView acceptsFirstResponder]): Added case for viewless mode along with a
        FIXME, since it's not complete.
        (-[WebView becomeFirstResponder]): Ditto.
        (-[WebView _webcore_effectiveFirstResponder]): Put the body of this inside
        a usesDocumentView check, because we don't need the first responder forwarding
        in viewless mode.
        (-[WebView setNextKeyView:]): Ditto.
        (-[WebView mouseDown:]): Added. Copied from WebHTMLView. FIXME in here suggests
        that we make WebHTMLView share this one soon, which I think is practical.
        (-[WebView mouseUp:]): Ditto.
        (-[WebView setHoverFeedbackSuspended:]): Added a code path for viewless mode.
        (-[WebView shouldClose]): Use _mainCoreFrame.
        (-[WebView aeDescByEvaluatingJavaScriptFromString:]): Ditto.
        (-[WebView setEditable:]): Ditto.
        (-[WebView _frameViewAtWindowPoint:]): Added an assertion that we're not in
        viewless mode since this method makes no sense in that mode.
        (-[WebView _setMouseDownEvent:]): Added. Copied from WebHTMLView. I plan to
        eliminate the one in WebHTMLView soon.
        (-[WebView _cancelUpdateMouseoverTimer]): Ditto.
        (-[WebView _stopAutoscrollTimer]): Ditto.
        (+[WebView _updateMouseoverWithEvent:]): Ditto.
        (-[WebView _updateMouseoverWithFakeEvent]): Ditto.
        (-[WebView _setToolTip:]): Added. Calls through to the WebHTMLView version.
        (-[WebView _selectionChanged]): Ditto.
        (-[WebView _mainCoreFrame]): Added.
        (-[WebView _needsOneShotDrawingSynchronization]): Moved into the WebInternal
        category.
        (-[WebView _setNeedsOneShotDrawingSynchronization:]): Ditto.
        (-[WebView _startedAcceleratedCompositingForFrame:]): Ditto.
        (-[WebView _stoppedAcceleratedCompositingForFrame:]): Ditto.
        (viewUpdateRunLoopObserverCallBack): Ditto.
        (-[WebView _scheduleViewUpdate]): Ditto.

        * WebView/WebViewInternal.h: Made most of the file not compile at all when
        included from non-C++ source files, elminating some excess declarations and
        typedefs. Moved more methods into the real internal category. Added new
        methods _setMouseDownEvent, _cancelUpdateMouseoverTimer, _stopAutoscrollTimer,
        _updateMouseoverWithFakeEvent, _selectionChanged, and _setToolTip:.

2009-06-02  Mark Rowe  <mrowe@apple.com>

        Reviewed by Anders Carlsson.

        Remove workaround that was added to address <rdar://problem/5488678> as it no longer affects our Tiger builds.

        * Configurations/Base.xcconfig:

2009-06-01  Darin Adler  <darin@apple.com>

        * WebView/WebTextCompletionController.mm: Fix Tiger build by adding import
        of WebTypesInternal.h.

2009-06-01  Darin Adler  <darin@apple.com>

        Reviewed by Maciej Stachowiak.

        Bug 26113: break WebTextCompletionController out into its own source file
        https://bugs.webkit.org/show_bug.cgi?id=26113

        * WebView/WebHTMLView.mm:
        (-[WebHTMLViewPrivate dealloc]): Updated for new name.
        (-[WebHTMLViewPrivate clear]): Ditto.
        (-[WebHTMLView _frameOrBoundsChanged]): Ditto.
        (-[WebHTMLView menuForEvent:]): Ditto.
        (-[WebHTMLView windowDidResignKey:]): Ditto.
        (-[WebHTMLView windowWillClose:]): Ditto.
        (-[WebHTMLView mouseDown:]): Ditto.
        (-[WebHTMLView resignFirstResponder]): Ditto.
        (-[WebHTMLView keyDown:]): Ditto.
        (-[WebHTMLView complete:]): Ditto. Also pass WebView to init method.
        (-[WebHTMLView _interceptEditingKeyEvent:shouldSaveCommand:]): Ditto.

        * WebView/WebTextCompletionController.h: Copied from mac/WebView/WebHTMLView.mm.
        * WebView/WebTextCompletionController.mm: Copied from mac/WebView/WebHTMLView.mm.
        Changed initializer to pass in a spearate WebView and WebHTMLView, to smooth the
        way for handling viewless mode properly in the future.

2009-05-30  David Kilzer  <ddkilzer@apple.com>

        Add JSLock to -[WebScriptCallFrame scopeChain]

        Reviewed by Darin Adler.

        In Debug builds of WebKit, Dashcode launching MobileSafari could
        cause the ASSERT(JSLock::lockCount() > 0) assertion to fire in
        JSC::Heap::heapAllocate() because the JSLock wasn't taken.

        * WebView/WebScriptDebugDelegate.mm:
        (-[WebScriptCallFrame scopeChain]): Take JSLock before calling
        into JavaScriptCore.

2009-05-28  Mark Rowe  <mrowe@apple.com>

        Rubber-stamped by Dan Bernstein.

        Build fix.  Move off a deprecated NSFileManager method.

        * Misc/WebNSFileManagerExtras.h:
        * Misc/WebNSFileManagerExtras.m:
        (-[NSFileManager destinationOfSymbolicLinkAtPath:error:]): Implement a new-in-Leopard method for Tiger to use.
        (-[NSFileManager attributesOfItemAtPath:error:]): Ditto.
        * Plugins/WebNetscapePluginPackage.mm:
        (-[WebNetscapePluginPackage _initWithPath:]): Use the new non-deprecated methods.

2009-05-28  Dirk Schulze  <krit@webkit.org>

        Reviewed by Nikolas Zimmermann.

        Added new build flag --filters. More details in WebCore/ChangeLog.

        * Configurations/FeatureDefines.xcconfig:

2009-05-27  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=26009
        <rdar://problem/6925656> REGRESSION (r43973): Problems While Working With OpenVanilla

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _updateSelectionForInputManager]): Don't call updateWindows if the selection
        is None. This routinely happens during editing, and it doesn't mean that we left an editable
        area (in which case the selection changes to a non-editable one).

2009-05-26  Sam Weinig  <sam@webkit.org>

        Reviewed by Brady Eidson.

        Fix for <rdar://problem/6916371>
        iWeb 'Announce' button does nothing after publishing to MobileMe

        Add linked-on-or-after check to allow older WebKit apps to use the
        old behavior of sniffing everything (including file: urls)

        * Misc/WebKitVersionChecks.h:
        * WebView/WebView.mm:
        (-[WebView _commonInitializationWithFrameName:groupName:usesDocumentViews:]):

2009-05-26  Stephanie Lewis  <slewis@apple.com>

        Reviewed by Ada Chan and Oliver Hunt.

        Remove WebView observers in during fast teardown.
        <rdar://problem/6922619> REGRESSION (Tiger-only?): After restoring windows from the previous session, a crash occurs while attempting to quit Safari

        * WebView/WebView.mm:
        (-[WebView _closeWithFastTeardown]):

2009-05-26  Anders Carlsson  <andersca@apple.com>

        Reviewed by Dan Bernstein.

        <rdar://problem/6901751> 
        REGRESSION (r35515): Tiger crash painting the selection on registration page of car2go.com

        Remove WKCGContextIsSafeToClip.

        * WebCoreSupport/WebSystemInterface.m:
        (InitWebCoreSystemInterface):

2009-05-26  Dan Bernstein  <mitz@apple.com>

        Reviewed by Darin Adler.

        - fix <rdar://problem/6922371> REGRESSION (r43973): Can't type first
          character with an umlaut, circumflex, or accent in Mail or in a wiki

        * WebView/WebHTMLView.mm:
        (isTextInput): Moved here.
        (isInPasswordField): Moved here.
        (-[WebHTMLView becomeFirstResponder]): Update the exposeInputContext
        flag and let NSApplication update the input manager with the new input
        context if necessary.
        (-[WebHTMLView _updateSelectionForInputManager]): Changed to use the
        NSApp global instead of +[NSApplication sharedApplication].

2009-05-26  Mark Rowe  <mrowe@apple.com>

        Fix the Tiger build.

        * Misc/WebNSObjectExtras.mm:
        (-[NSInvocation _webkit_invokeAndHandleException:]): Rename the local variable so that
        it doesn't conflict with a member variable on Tiger.

2009-05-26  Darin Adler  <darin@apple.com>

        Reviewed by Mark Rowe.

        <rdar://problem/6921835> REGRESSION (r44115): Crash in Leopard Mail viewing message

        Fix case where we autorelease an object on the main thread that we are returning
        to another thread when using our _webkit_invokeOnMainThread method.

        * Misc/WebNSObjectExtras.mm:
        (returnTypeIsObject): Added.
        (-[WebMainThreadInvoker forwardInvocation:]): Autorelease the object on the calling
        thread, balancing a retain done on the main thread.
        (-[NSInvocation _webkit_invokeAndHandleException:]): Retain the object on the main
        thread.

2009-05-26  David Hyatt  <hyatt@apple.com>

        Back out the workaround for Mail crashing.  Darin is working on the real fix.

        * Misc/WebNSObjectExtras.mm:
        (-[WebMainThreadInvoker forwardInvocation:]):

2009-05-26  David Hyatt  <hyatt@apple.com>

        Reviewed by Darin Adler.

        Fix for https://bugs.webkit.org/show_bug.cgi?id=25969.

        Stop using notifications for boundsChanged, since the notifications are being sent too late.
        Since subviews get resized before parents do, the notification comes in telling the WebHTMLView
        that its size has changed *before* we've done setNeedsLayout in the WebView size change callback.

        Become more like the Windows platform and just do the bounds changed immediately as our size is
        being altered by subclassing setFrameSize in WebView.

        Also patch WebDynamicScrollbarsView to detect the case where neither axis is really spilling out
        past the viewport, so that in shrinking situations we figure out that we don't need scrollbars
        any more.

        * WebView/WebDynamicScrollBarsView.m:
        (-[WebDynamicScrollBarsView updateScrollers]):
        * WebView/WebView.mm:
        (-[WebView _boundsChangedToNewSize:]):
        (-[WebView setFrameSize:]):
        (-[WebView viewWillMoveToWindow:]):
        (-[WebView viewDidMoveToWindow]):

2009-05-25  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        - WebKit side of <rdar://problem/6914001>.

        * Plugins/Hosted/NetscapePluginHostManager.h:
        * Plugins/Hosted/NetscapePluginHostManager.mm:
        (WebKit::NetscapePluginHostManager::didCreateWindow):
        Iterate over all plug-in hosts. If one is in full-screen mode, make sure to activate the
        WebKit app instead.
        
        * Plugins/Hosted/NetscapePluginHostProxy.h:
        (WebKit::NetscapePluginHostProxy::isMenuBarVisible):
        Add getter.
        
        * Plugins/Hosted/NetscapePluginHostProxy.mm:
        (WKPCEvaluate):
        Add allowPopups flag.
        
        * Plugins/Hosted/NetscapePluginInstanceProxy.h:
        * Plugins/Hosted/NetscapePluginInstanceProxy.mm:
        (WebKit::NetscapePluginInstanceProxy::PluginRequest::PluginRequest):
        (WebKit::NetscapePluginInstanceProxy::PluginRequest::allowPopups):
        (WebKit::NetscapePluginInstanceProxy::loadURL):
        (WebKit::NetscapePluginInstanceProxy::evaluateJavaScript):
        (WebKit::NetscapePluginInstanceProxy::loadRequest):
        (WebKit::NetscapePluginInstanceProxy::evaluate):
        Use "allowPopups" instead of "userGesture".
        
        * Plugins/Hosted/WebKitPluginClient.defs:
        Add allowPopups argument to Evaluate.
        
        * Plugins/Hosted/WebKitPluginHostTypes.h:
        Use "allowPopups" instead of "userGesture".

        * WebCoreSupport/WebChromeClient.mm:
        (WebChromeClient::createWindow):
        Call didCreateWindow here.
        
        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::dispatchCreatePage):
        Ditto.

2009-05-25  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        - Fix <rdar://problem/6915849>.
        
        Release the placeholder window after -[NSApplication runModalForWindow] returns.
        
        * Plugins/Hosted/NetscapePluginHostProxy.mm:
        (WebKit::NetscapePluginHostProxy::beginModal):
        (WebKit::NetscapePluginHostProxy::endModal):

2009-05-24  Dan Bernstein  <mitz@apple.com>

        - revert an accidental change from r43964.

        * WebView/WebView.mm:
        (+[WebView _setShouldUseFontSmoothing:]):

2009-05-24  Darin Adler  <darin@apple.com>

        Reviewed by Dan Bernstein and Tim Hatcher.

        <rdar://problem/6913045> New console message spewed by automator CLI after installing JetstreamLeo40B21a

        * Misc/WebNSObjectExtras.mm:
        (-[WebMainThreadInvoker initWithTarget:]): Tweaked argument name.
        (-[WebMainThreadInvoker forwardInvocation:]): Removed call to retainArguments.
        This was unneeded and in the case of a newly created but not yet fully initialized
        NSView object it caused the abovementioned bug.
        (-[WebMainThreadInvoker handleException:]): Tweaked argument name. Added assertion.
        (-[NSInvocation _webkit_invokeAndHandleException:]): Tweaked name of local variable
        that holds the exception.

2009-05-23  David Kilzer  <ddkilzer@apple.com>

        Part 2 of 2: Bug 25495: Implement PassOwnPtr and replace uses of std::auto_ptr

        <https://bugs.webkit.org/show_bug.cgi?id=25495>

        Reviewed by Oliver Hunt.

        * History/WebHistory.mm:
        (-[WebHistory _visitedURL:withTitle:method:wasFailure:]): Return
        0 instead of an empty auto_ptr<>.
        * History/WebHistoryItem.mm:
        (-[WebHistoryItem initFromDictionaryRepresentation:]): Use
        OwnPtr<> instead of auto_ptr<> for stack variable.
        * WebCoreSupport/WebChromeClient.h:
        (WebChromeClient::createHTMLParserQuirks): Return a PassOwnPtr<>
        instead of a raw HTMLParserQuirks pointer.

2009-05-23  David Kilzer  <ddkilzer@apple.com>

        Part 1 of 2: Bug 25495: Implement PassOwnPtr and replace uses of std::auto_ptr

        <https://bugs.webkit.org/show_bug.cgi?id=25495>

        Reviewed by Oliver Hunt.

        * ForwardingHeaders/wtf/OwnPtrCommon.h: Added.
        * ForwardingHeaders/wtf/PassOwnPtr.h: Added.

2009-05-22  Darin Adler  <darin@apple.com>

        Reviewed by Dan Bernstein.

        - Fix <rdar://problem/6913765> REGRESSION (r42331-r42334): Extra scroll
          bars appearing on Welcome panels of iLife '09 apps

        * WebView/WebView.mm:
        (needsUnwantedScrollBarWorkaround): Added. Checks if this is a panel
        where scroll bars are unwanted. For safety, limited to only Apple applications. 
        (-[WebView viewDidMoveToWindow]): If the workaround is needed, disallow
        scrolling the main frame. This prevents scroll bars from appearing.

2009-05-22  Adam Barth  <abarth@webkit.org>

        Reviewed by Maciej Stachowiak.

        https://bugs.webkit.org/show_bug.cgi?id=25955

        Remove the policyBaseURL parameter from setCookie.  This parameter is
        redudant with the document parameter.

        * Plugins/Hosted/NetscapePluginInstanceProxy.mm:
        (WebKit::NetscapePluginInstanceProxy::setCookies):
        * Plugins/WebNetscapePluginView.mm:
        (-[WebNetscapePluginView setVariable:forURL:value:length:]):

2009-05-21  Darin Fisher  <darin@chromium.org>

        Fix-up coding style.

        * WebCoreSupport/WebEditorClient.mm:
        (WebEditorClient::getAutoCorrectSuggestionForMisspelledWord):

2009-05-20  Siddhartha Chattopadhyaya  <sidchat@google.com>

        Reviewed by Justin Garcia.
        
        Add automatic spell correction support in WebKit

        https://bugs.webkit.org/show_bug.cgi?id=24953

        * WebCoreSupport/WebEditorClient.h:
        * WebCoreSupport/WebEditorClient.mm:
        (WebEditorClient::getAutoCorrectSuggestionForMisspelledWord):

2009-05-21  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin Adler.

        <rdar://problem/6907542> REGRESSION (r43143): Hang in RenderLineBoxList::dirtyLinesFromChangedChild
        when clicking link to load Flash animation (http://www.roambi.com)

        * WebCoreSupport/WebEditorClient.mm: (WebEditorClient::respondToChangedSelection):
        Don't call -[NSApplication updateWindows] here, WebHTMLView can take care of this.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView inputContext]): Use a precomputed boolean stored in WebHTMLViewPrivate, as
        calling isTextInput() is not always safe.
        (-[WebHTMLView textStorage]): Ditto.
        (-[WebHTMLView _updateSelectionForInputManager]): Update _private->exposeInputContext when
        selection changes, and let AppKit update its cache if necessary.

2009-05-21  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin Adler.

        <rdar://problem/5579292> REGRESSION (2-3): "Default default" encoding for Korean changed
        from Korean (Windows, DOS) to Korean (ISO 2022-KR), which breaks some sites

        * WebView/WebPreferences.mm:
       (+[WebPreferences _setInitialDefaultTextEncodingToSystemEncoding]): Update the existing fix
       for the changed result of CFStringConvertEncodingToIANACharSetName().

2009-05-21  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin Adler.

        <rdar://problem/6883758> REGRESSION (r43143): First character typed with input method does
        not go into inline hole (seen with Chinese & Kotoeri on top Chinese website www.baidu.com)

        * WebCoreSupport/WebEditorClient.mm: (WebEditorClient::respondToChangedSelection):
        Call -[NSApplication updateWindows] to make AppKit re-fetch the input context when selection
        changes. Since we use SelectionController to check whether the view is editable, it is
        important not to re-fetch the context too early, e.g. from a focus changed notification.

2009-05-21  Eric Seidel  <eric@webkit.org>

        Reviewed by Alexey Proskuryakov.

        Rename DragController::dragOperation() to sourceDragOperation() for clarity

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView draggingSourceOperationMaskForLocal:]):

2009-05-21  Dan Bernstein  <mitz@apple.com>

        Reviewed by Anders Carlsson.

        - WebKit part of <rdar://problem/6901751> REGRESSION (r35515): Tiger
          crash painting the selection on registration page of car2go.com

        * WebCoreSupport/WebSystemInterface.m:
        (InitWebCoreSystemInterface): Added CGContextIsSafeToClip.

2009-05-20  Stephanie Lewis  <slewis@apple.com>

        Update the order files.  <rdar://problem/6881750> Generate new order files.

        * WebKit.order:

2009-05-20  Brady Eidson  <beidson@apple.com>

        Reviewed by Darin Adler.

        <rdar://problem/6905336> REGRESSION: "Clear History" does not save empty history to disk

        * History/WebHistory.mm:
        (-[WebHistoryPrivate data]): If there are no entries, return an empty NSData instead of nil.

2009-05-20  Anders Carlsson  <andersca@apple.com>

        Reviewed by Darin Adler and Kevin Decker.

        WebKit side of <rdar://problem/6895072>
        
        Pass the localization as a launch property.
        
        * Plugins/Hosted/NetscapePluginHostManager.mm:
        (WebKit::NetscapePluginHostManager::spawnPluginHost):

2009-05-20  Dan Bernstein  <mitz@apple.com>

        - fix the build after r43918

        * WebCoreSupport/WebChromeClient.h:
        (WebChromeClient::setCursor):

2009-05-20  Darin Adler  <darin@apple.com>

        Reviewed by John Sullivan.

        <rdar://problem/4023899> Shift-Tab skips key views in toolbar in Safari, although Tab
        iterates through them properly

        * WebView/WebView.mm:
        (-[WebView previousValidKeyView]): Work around a bug in -[NSView previousValidKeyView].

2009-05-19  Timothy Hatcher  <timothy@apple.com>

        Add a new private API method that will dispatch pending loads that have been scheduled
        because of recent DOM additions or style changes.

        <rdar://problem/6889218> REGRESSION: Some iChat transcript resources are not
        loaded because willSendRequest doesn't happen immediately

        Reviewed by Antti Koivisto.

        * WebView/WebView.mm:
        (-[WebView _dispatchPendingLoadRequests]): Call Loader::servePendingRequests().
        * WebView/WebViewPrivate.h: Added _dispatchPendingLoadRequests.

2009-05-18  Sam Weinig  <sam@webkit.org>

        <rdar://problem/6899044> Can't see Apple ad on nytimes.com unless I spoof the user agent
        
        Add user agent hack for pointroll.com.

        Reviewed by Steve Falkenburg.

        * WebView/WebView.mm:
        (-[WebView WebCore::_userAgentForURL:WebCore::]):

2009-05-16  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig and Dan Bernstein.

        Fix <rdar://problem/6889644>
        
        * Plugins/Hosted/NetscapePluginHostManager.mm:
        (WebKit::NetscapePluginHostManager::spawnPluginHost):

2009-05-16  Dan Bernstein  <mitz@apple.com>

        - revert an accidental change from r43802.

        * WebInspector/WebInspector.mm:

2009-05-16  Anders Carlsson  <andersca@apple.com>

        Reviewed by Dan Bernstein.

        <rdar://problem/6895347> Mouse wheeling in the QuickTime plug-in (incorrectly) scrolls the page
        
        Fix logic. The plug-in returns true if it handled the event.
        
        * Plugins/WebNetscapePluginView.mm:
        (-[WebNetscapePluginView sendEvent:isDrawRect:]):

2009-05-16  Dan Bernstein  <mitz@apple.com>

        Reviewed by Alexey Proskuryakov.

        - fix <rdar://problem/6873305> Two distinct characters are not displayed
          correctly with 2 of the font selections from the stickies widget

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _plainTextFromPasteboard:]): Return precomposed text.
        This is consistent with
        -_documentFragmentFromPasteboard:forType:inContext:subresources:.

2009-05-15  Anders Carlsson  <andersca@apple.com>

        Reviewed by Dan Bernstein.

        Fix <rdar://problem/6875398>.
        
        * Plugins/Hosted/NetscapePluginHostManager.mm:
        (WebKit::NetscapePluginHostManager::instantiatePlugin):
        If we failed to instantiate the plug-in, call cleanup() so that any streams created by the plug-in from its
        NPP_New callback are destroyed.
        
        * Plugins/Hosted/NetscapePluginInstanceProxy.h:
        Make cleanup() public.

2009-05-15  Darin Adler  <darin@apple.com>

        Reviewed by Anders Carlsson.

        <rdar://problem/6889823> hash table iterator used after hash table modified in
        ProxyInstance::fieldNamed() when viewing movie trailer

        * Plugins/Hosted/ProxyInstance.mm:
        (WebKit::ProxyInstance::methodsNamed): Move add call after the waitForReply call.
        Anders says that by the time we return someone else might have done the same add
        for us.
        (WebKit::ProxyInstance::fieldNamed): Ditto.

2009-05-15  Anders Carlsson  <andersca@apple.com>

        Reviewed by Darin Adler.

        <rdar://problem/6892055> 
        Replace WKN_GetLocation with WKN_ResolveURL (WKN_GetLocation was confusing and did not take the base URL into account)
        
        * Plugins/Hosted/NetscapePluginHostProxy.mm:
        (WKPCResolveURL):
        New MIG callback.
        
        * Plugins/Hosted/NetscapePluginInstanceProxy.h:
        * Plugins/Hosted/NetscapePluginInstanceProxy.mm:
        (WebKit::NetscapePluginInstanceProxy::resolveURL):
        Use FrameLoader::complete URL here.
        
        * Plugins/Hosted/WebKitPluginClient.defs:
        Add new MIG definition.
        
        * Plugins/WebBaseNetscapePluginView.h:
        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView resolvedURLStringForURL:target:]):        
        * Plugins/WebNetscapeContainerCheckPrivate.h:
        * Plugins/WebNetscapeContainerCheckPrivate.mm:
        (browserContainerCheckFuncs):
        * Plugins/WebNetscapePluginView.h:
        * Plugins/WebNetscapePluginView.mm:
        (-[WebNetscapePluginView resolveURL:forTarget:]):
        * Plugins/npapi.mm:
        (WKN_ResolveURL):

2009-05-15  Dan Bernstein  <mitz@apple.com>

        Reviewed by Darin Adler.

        - fix <rdar://problem/6892052> WebTextIterator should not “emit
          characters between all visible positions”

        * WebView/WebTextIterator.mm:
        (-[WebTextIterator initWithRange:]): Changed to construct a TextIterator
        with emitCharactersBetweenAllVisiblePositions set to false.

2009-05-15  Mark Rowe  <mrowe@apple.com>

        Reviewed by Dave Kilzer.

        Look for libWebKitSystemInterface.a in a more reasonable location.

        * Configurations/DebugRelease.xcconfig:

2009-05-14  David Hyatt  <hyatt@apple.com>

        Reviewed by Tim Hatcher.

        Fix for <rdar://problem/6886217> REGRESSION (S4 beta-ToT): Adium chat window contents no longer resize.

        Technically this is a bug in Adium.  It appears that Adium has subclassed the WebView and implemented
        viewDidMoveToWindow in its subclass improperly.  It doesn't call up to the base class WebView like it
        should and so our boundsChanged notification never gets added.

        Reduce the dependence on viewDidMoveToWindow by moving the registration of observers into
        viewWillMoveToWindow instead.

        * WebView/WebView.mm:
        (-[WebView addSizeObserversForWindow:]):
        (-[WebView removeWindowObservers]):
        (-[WebView addWindowObserversForWindow:]):
        (-[WebView viewWillMoveToWindow:]):
        (-[WebView viewDidMoveToWindow]):
        (-[WebView viewDidMoveToSuperview]):

2009-05-14  David Levin  <levin@chromium.org>

        Reviewed by Eric Seidel.

        https://bugs.webkit.org/show_bug.cgi?id=24704

        Allow the local cache directory to be set using a defaults key.

        * Misc/WebKitNSStringExtras.h:
        * Misc/WebKitNSStringExtras.m:
        (+[NSString _webkit_localCacheDirectoryWithBundleIdentifier:]):
        * WebKit.exp:

2009-05-14  Darin Adler  <darin@apple.com>

        Reviewed by Adam Roben.

        <rdar://problem/6879999> Automator actions that use WebKit on a background thread fail when run outside of Automator

        * WebView/WebView.mm:
        (clientNeedsWebViewInitThreadWorkaround): Added. Contains new broader rule.
        (needsWebViewInitThreadWorkaround): Changed to call clientNeedsWebViewInitThreadWorkaround.

2009-05-14  Darin Adler  <darin@apple.com>

        Reviewed by John Sullivan.

        Bug 24049: Second right-click crashes safari when alert invoked
        https://bugs.webkit.org/show_bug.cgi?id=24049
        rdar://problem/6878977

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView rightMouseUp:]): Added a retain/autorelease of the event.
        (-[WebHTMLView menuForEvent:]): Ditto. Also cleaned up the logic here and
        eliminated some use of pointers that might be invalid after calling through
        to WebCore.
        (-[WebHTMLView scrollWheel:]): Ditto.
        (-[WebHTMLView acceptsFirstMouse:]): Ditto.
        (-[WebHTMLView shouldDelayWindowOrderingForEvent:]): Ditto.
        (-[WebHTMLView mouseDown:]): Ditto.
        (-[WebHTMLView mouseDragged:]): Ditto.
        (-[WebHTMLView mouseUp:]): Ditto.
        (-[WebHTMLView keyDown:]): Ditto.
        (-[WebHTMLView keyUp:]): Ditto.
        (-[WebHTMLView flagsChanged:]): Ditto.
        (-[WebHTMLView performKeyEquivalent:]): Ditto.

2009-05-14  Mark Rowe  <mrowe@apple.com>

        Rubber-stamped by Darin Adler.

        <rdar://problem/6681868> When building with Xcode 3.1.3 should be using gcc 4.2

        The meaning of XCODE_VERSION_ACTUAL is more sensible in newer versions of Xcode.
        Update our logic to select the compiler version to use the more appropriate XCODE_VERSION_MINOR
        if the version of Xcode supports it, and fall back to XCODE_VERSION_ACTUAL if not.

        * Configurations/Base.xcconfig:

2009-05-13  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        WebKit side of <rdar://problem/6884476>.
        
        * Plugins/Hosted/NetscapePluginHostProxy.mm:
        (WKPCGetLocation):
        Forward this to the plug-in instance proxy.
        
        * Plugins/Hosted/NetscapePluginInstanceProxy.h:
        * Plugins/Hosted/NetscapePluginInstanceProxy.mm:
        (WebKit::NetscapePluginInstanceProxy::getLocation):
        Ask the plug-in view for the location.
        
        * Plugins/Hosted/WebKitPluginClient.defs:
        Add MIG definition.
        
        * Plugins/WebBaseNetscapePluginView.h:
        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView locationStringForTarget:]):
        Return the URL for a given frame.
        
        * Plugins/WebNetscapeContainerCheckPrivate.h:
        Bump version. Add new declaration to the vtable.
        
        * Plugins/WebNetscapeContainerCheckPrivate.mm:
        (browserContainerCheckFuncs):
        Add new declaration to the vtable.
        
        * Plugins/WebNetscapePluginView.h:
        * Plugins/WebNetscapePluginView.mm:
        (-[WebNetscapePluginView locationForTarget:]):
        Call the base class method.
        
        * Plugins/npapi.mm:
        (WKN_GetLocation):
        Forward this to the plug-in view.

2009-05-13  Douglas R. Davidson  <ddavidso@apple.com>

        Reviewed by Darin Adler.

        <rdar://problem/6871587> Smart Copy/Paste setting should persist as continuous
        spell checking setting does

        * WebView/WebPreferenceKeysPrivate.h: Added WebSmartInsertDeleteEnabled.

        * WebView/WebView.mm:
        (-[WebViewPrivate init]): Initialize based on WebSmartInsertDeleteEnabled
        default.
        (-[WebView _commonInitializationWithFrameName:groupName:usesDocumentViews:]):
        Removed code that initialized here.
        (-[WebView setSmartInsertDeleteEnabled:]): Set default here was with
        continuous spell checking setting.

2009-05-13  Darin Adler  <darin@apple.com>

        Revert the parser arena change. It was a slowdown, not a speedup.
        Better luck next time (I'll break it up into pieces).

2009-05-13  Darin Adler  <darin@apple.com>

        Reviewed by Cameron Zwarich.

        Bug 25674: syntax tree nodes should use arena allocation
        https://bugs.webkit.org/show_bug.cgi?id=25674

        * Plugins/Hosted/NetscapePluginInstanceProxy.mm: Updated includes.
        New ones needed due to reducing includes of JSDOMBinding.h.
        * WebView/WebScriptDebugger.mm: Ditto.

2009-05-13  Douglas R. Davidson  <ddavidso@apple.com>

        Reviewed by Darin Adler.

        <rdar://problem/6879145>
        Generate a contextual menu item allowing autocorrections to
        easily be changed back.  Refrain from re-correcting items
        that have already been autocorrected once.

        * WebCoreSupport/WebViewFactory.mm:
        (-[WebViewFactory contextMenuItemTagChangeBack:]):
        * WebView/WebUIDelegatePrivate.h:

2009-05-12  Anders Carlsson  <andersca@apple.com>

        Reviewed by Dan Bernstein.

        Fix <rdar://problem/6878105>.
        
        When instantiating the QT plug-in under Dashboard, force "kiosk mode". 
        
        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView initWithFrame:pluginPackage:URL:baseURL:MIMEType:attributeKeys:attributeValues:loadManually:element:WebCore::]):

2009-05-12  Dan Bernstein  <mitz@apple.com>

        Reviewed by Darin Adler.

        - declare a forgotten method

        * DOM/WebDOMOperationsPrivate.h: Declare -[DOMNode markupString] in the
        WebDOMNodeOperationsPendingPublic category.

2009-05-10  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Dan Bernstein.

        <rdar://problem/6870383> Have to enter credentials twice when downloading from a protected page

        * Misc/WebDownload.m: Removed.
        * Misc/WebDownload.mm: Copied from WebKit/mac/Misc/WebDownload.m.
        (-[WebDownloadInternal download:didReceiveAuthenticationChallenge:]): Try to use
        credentials from WebCore storage.

2009-05-08  Nikolas Zimmermann  <nikolas.zimmermann@torchmobile.com>

        Not reviewed. Fix clean builds, forgot to land name() -> formControlName() rename patch in WebKit. Only landed the WebCore side.

        * WebView/WebHTMLRepresentation.mm:
        (-[WebHTMLRepresentation elementWithName:inForm:]):

2009-05-08  Anders Carlsson  <andersca@apple.com>

        Reviewed by Kevin Decker.

        - Fix <rdar://problem/6866712>.

        Instead of just caching whether a plug-in object _has_ a field or method, also add an entry to the cache
        if it _doesn't_ have a certain field or method. This way we have to make fewer calls to the plug-in host.
        
        * Plugins/Hosted/ProxyInstance.mm:
        (WebKit::ProxyInstance::methodsNamed):
        (WebKit::ProxyInstance::fieldNamed):

2009-05-08  Douglas R. Davidson  <ddavidso@apple.com>

        Reviewed by Darin Adler.

        Fixes for <rdar://problem/6852771>.
        Disable text checking menu items if view is not editable.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView validateUserInterfaceItemWithoutDelegate:]):
        (-[WebHTMLView smartInsertDeleteEnabled]):
        (-[WebHTMLView setSmartInsertDeleteEnabled:]):
        (-[WebHTMLView toggleSmartInsertDelete:]):
        * WebView/WebHTMLViewInternal.h:

2009-05-08  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Maciej Stachowiak.

        <rdar://problem/6868773> NPN_GetAuthenticationInfo does not work with non-permanent credentials

        * Plugins/WebBaseNetscapePluginView.mm: (WebKit::getAuthenticationInfo): Ask WebCore for
        credentials first (but also ask NSURLCredentialStorage, because WebCore won't know about
        permanent credentials).

2009-05-05  Ben Murdoch  <benm@google.com>

        Reviewed by Eric Seidel.
        
        Add #if ENABLE(DATABASE) guards around database code so toggling ENABLE_DATABASE off does not break builds.
        https://bugs.webkit.org/show_bug.cgi?id=24776

        * Storage/WebDatabaseManager.mm:
        * Storage/WebDatabaseManagerInternal.h:
        * Storage/WebDatabaseManagerPrivate.h:
        * Storage/WebDatabaseTrackerClient.h:
        * Storage/WebDatabaseTrackerClient.mm:
        * Storage/WebSecurityOrigin.mm:
        (-[WebSecurityOrigin usage]):
        (-[WebSecurityOrigin quota]):
        (-[WebSecurityOrigin setQuota:]):
        * Storage/WebSecurityOriginPrivate.h:
        * WebCoreSupport/WebChromeClient.h:
        * WebCoreSupport/WebChromeClient.mm:
        * WebView/WebView.mm:
        (-[WebView _commonInitializationWithFrameName:groupName:usesDocumentViews:]):

2009-05-04  Anders Carlsson  <andersca@apple.com>

        Reviewed by Kevin Decker.

        Fix <rdar://problem/6797644>.
        
        Make sure to send a reply even when an instance proxy can't be found.
        
        * Plugins/Hosted/NetscapePluginHostProxy.mm:
        (WKPCEvaluate):
        (WKPCInvoke):
        (WKPCInvokeDefault):
        (WKPCGetProperty):
        (WKPCHasProperty):
        (WKPCHasMethod):
        (WKPCEnumerate):

2009-05-04  Darin Adler  <darin@apple.com>

        Reviewed by Eric Seidel.

        Bug 24924: remove Document.h include of Attr.h and HTMLCollection.h,
        and NamedMappedAttrMap.h include of MappedAttribute.h
        https://bugs.webkit.org/show_bug.cgi?id=24924

        * WebView/WebFrame.mm: Added include of CSSMutableStyleDeclaration.h
        and ScriptValue.h.

2009-05-02  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Sam Weinig.

        Simplified null-ish JSValues.
        
        Replaced calls to noValue() with calls to JSValue() (which is what
        noValue() returned). Removed noValue().
        
        Removed "JSValue()" initialiazers, since default construction happens...
        by default.

        * WebView/WebScriptDebugDelegate.mm:
        (-[WebScriptCallFrame evaluateWebScript:]):

2009-05-02  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Dan Bernstein.

        <rdar://problem/6741615> REGRESSION (r38629): Shortcut "Flag/Junk" in MobileMe does not work
        when Kotoeri is used.

        * WebView/WebHTMLView.mm: (-[WebHTMLView inputContext]): Return a nil input context when
        focus is not in editable content.

2009-05-01  Geoffrey Garen  <ggaren@apple.com>

        Rubber Stamped by Sam Weinig.
        
        Renamed JSValuePtr => JSValue.

        * Plugins/Hosted/NetscapePluginInstanceProxy.h:
        * Plugins/Hosted/NetscapePluginInstanceProxy.mm:
        (WebKit::NetscapePluginInstanceProxy::evaluate):
        (WebKit::NetscapePluginInstanceProxy::invoke):
        (WebKit::NetscapePluginInstanceProxy::invokeDefault):
        (WebKit::NetscapePluginInstanceProxy::construct):
        (WebKit::NetscapePluginInstanceProxy::getProperty):
        (WebKit::NetscapePluginInstanceProxy::setProperty):
        (WebKit::NetscapePluginInstanceProxy::hasMethod):
        (WebKit::NetscapePluginInstanceProxy::addValueToArray):
        (WebKit::NetscapePluginInstanceProxy::marshalValue):
        (WebKit::NetscapePluginInstanceProxy::demarshalValueFromArray):
        (WebKit::NetscapePluginInstanceProxy::demarshalValue):
        (WebKit::NetscapePluginInstanceProxy::demarshalValues):
        * Plugins/Hosted/ProxyInstance.h:
        * Plugins/Hosted/ProxyInstance.mm:
        (WebKit::ProxyField::valueFromInstance):
        (WebKit::ProxyField::setValueToInstance):
        (WebKit::ProxyInstance::invoke):
        (WebKit::ProxyInstance::invokeMethod):
        (WebKit::ProxyInstance::invokeDefaultMethod):
        (WebKit::ProxyInstance::invokeConstruct):
        (WebKit::ProxyInstance::defaultValue):
        (WebKit::ProxyInstance::stringValue):
        (WebKit::ProxyInstance::numberValue):
        (WebKit::ProxyInstance::booleanValue):
        (WebKit::ProxyInstance::valueOf):
        (WebKit::ProxyInstance::fieldValue):
        (WebKit::ProxyInstance::setFieldValue):
        * WebView/WebFrame.mm:
        (-[WebFrame _stringByEvaluatingJavaScriptFromString:forceUserGesture:]):
        * WebView/WebScriptDebugDelegate.mm:
        (-[WebScriptCallFrame _convertValueToObjcValue:]):
        (-[WebScriptCallFrame exception]):
        (-[WebScriptCallFrame evaluateWebScript:]):
        * WebView/WebView.mm:
        (aeDescFromJSValue):
        (-[WebView aeDescByEvaluatingJavaScriptFromString:]):

2009-05-01  Pavel Feldman  <pfeldman@chromium.org>

        Reviewed by Timothy Hatcher.

        Add a FrameLoaderClient callback for the ResourceRetrievedByXMLHttpRequest.

        https://bugs.webkit.org/show_bug.cgi?id=25347

        * WebCoreSupport/WebFrameLoaderClient.h:
        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::dispatchDidLoadResourceByXMLHttpRequest):

2009-04-30  David Kilzer  <ddkilzer@apple.com>

        Provide a mechanism to create a quirks delegate for HTMLParser

        Reviewed by David Hyatt.

        * WebCoreSupport/WebChromeClient.h:
        (WebChromeClient::createHTMLParserQuirks): Added.  The default
        implementation of this factory method returns 0.

2009-04-30  Dimitri Glazkov  <dglazkov@chromium.org>

        Reviewed by Timothy Hatcher.

        https://bugs.webkit.org/show_bug.cgi?id=25470
        Extend the cover of ENABLE_JAVASCRIPT_DEBUGGER to profiler.

        * Configurations/FeatureDefines.xcconfig: Added ENABLE_JAVASCRIPT_DEBUGGER define.

2009-04-30  Kevin Decker  <kdecker@apple.com>

        Reviewed by Anders Carlson.

        <rdar://problem/6823049>
        
        Fix an issue where some plug-ins would cause the application icon to constantly bounce
        up and down in the Dock.
        
        * Plugins/Hosted/NetscapePluginHostProxy.h: Change m_placeholderWindow ivar to be
        a subclass of NSWindow, WebPlaceholderModalWindow.
        * Plugins/Hosted/NetscapePluginHostProxy.mm:  Added WebPlaceholderModalWindow NSWindow subclass.
        (-[WebPlaceholderModalWindow _wantsUserAttention]): Prevent NSApp from calling requestUserAttention:
         when the window is shown modally, even if the app is inactive.
        (WebKit::NetscapePluginHostProxy::beginModal): NSWindow -> WebPlaceholderModalWindow.

2009-04-30  Pavel Feldman  <pfeldman@chromium.org>

        Reviewed by Dimitri Glazkov.

        https://bugs.webkit.org/show_bug.cgi?id=25342
        Add MessageSource and MessageLevel parameters to the ChromeClient::addMessageToConsole.

        * WebCoreSupport/WebChromeClient.h:
        * WebCoreSupport/WebChromeClient.mm:
        (WebChromeClient::addMessageToConsole):

2009-04-29  Mark Rowe  <mrowe@apple.com>

        More build fixing after r43037.

        * Plugins/Hosted/NetscapePluginInstanceProxy.h:
        * Plugins/Hosted/NetscapePluginInstanceProxy.mm:
        (WebKit::NetscapePluginInstanceProxy::invoke):
        (WebKit::NetscapePluginInstanceProxy::invokeDefault):
        (WebKit::NetscapePluginInstanceProxy::construct):
        (WebKit::NetscapePluginInstanceProxy::demarshalValues):

2009-04-29  Dan Bernstein  <mitz@apple.com>

        Reviewed by Simon Fraser.

        - WebKit part of <rdar://problem/6609509> Select All and then Delete
          should put Mail editing back into the same state as a new message

        * WebView/WebView.mm:
        (-[WebView _selectionIsCaret]): Added.
        (-[WebView _selectionIsAll]): Added. Returns whether the selection
        encompasses the entire document.
        * WebView/WebViewPrivate.h:

2009-04-29  Douglas Davidson  <ddavidso@apple.com>

        Reviewed by Justin Garcia.
        
        <rdar://problem/6836921> Mail exhibits issues with text checking, e.g. menu items not always validated correctly

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView validateUserInterfaceItemWithoutDelegate:]):
        (-[WebHTMLView orderFrontSubstitutionsPanel:]):
        * WebView/WebView.mm:
        (-[WebView validateUserInterfaceItemWithoutDelegate:]):

2009-04-29  David Hyatt  <hyatt@apple.com>

        Reviewed by Dan Bernstein.

        Fix a bug in the bounds checking for setNeedsLayout dirtying when a WebView's size changes.  The superview
        of the WebView was being incorrectly checked instead of the WebView itself.

        * WebView/WebView.mm:
        (-[WebView _boundsChanged]):

2009-04-29  Kevin Decker  <kdecker@apple.com>

        Reviewed by Anders Carlson.

        Allow WKN_CheckIfAllowedToLoadURL() to take an optional void* context parameter.
        
        * Plugins/WebNetscapeContainerCheckContextInfo.h:
        * Plugins/WebNetscapeContainerCheckContextInfo.mm:
        (-[WebNetscapeContainerCheckContextInfo initWithCheckRequestID:callbackFunc:context:]):
        (-[WebNetscapeContainerCheckContextInfo callback]):
        (-[WebNetscapeContainerCheckContextInfo context]):
        * Plugins/WebNetscapeContainerCheckPrivate.h:
        * Plugins/WebNetscapeContainerCheckPrivate.mm:
        (browserContainerCheckFuncs):
        * Plugins/WebNetscapePluginView.h:
        * Plugins/WebNetscapePluginView.mm:
        (-[WebNetscapePluginView checkIfAllowedToLoadURL:frame:callbackFunc:context:]):
        (-[WebNetscapePluginView _containerCheckResult:contextInfo:]):
        * Plugins/npapi.mm:
        (WKN_CheckIfAllowedToLoadURL):

2009-04-29  David Hyatt  <hyatt@apple.com>

        Reviewed by John Sullivan.

        Fix for <rdar://problem/6835573>, Find Banner turns invisible when WebView is resized.  Make sure
        not to resize the interior views of a WebView in response to its bounds changing when not using
        viewless WebKit.  Auto-resizing rules were already in place to handle size adjustments for us.
        Just mark as needing layout and do nothing else.

        This does mean viewless WebKit is broken with the Find Banner, and that will likely require a
        Safari change (using a new API that will enable clients to define the edges of the content area as offsets
        from the sides of the WebView).

        * WebView/WebView.mm:
        (-[WebView _boundsChanged]):

2009-04-28  Geoffrey Garen  <ggaren@apple.com>

        Rubber stamped by Beth Dakin.
        
        Removed scaffolding supporting dynamically converting between 32bit and
        64bit value representations. 

        * Plugins/Hosted/NetscapePluginInstanceProxy.mm:
        (WebKit::NetscapePluginInstanceProxy::marshalValues):

2009-04-28  Anders Carlsson  <andersca@apple.com>

        Reviewed by Kevin Decker and Darin Adler.

        Fix <rdar://problem/6836132>.
        
        * Plugins/Hosted/NetscapePluginHostProxy.mm:
        (WKPCCheckIfAllowedToLoadURL):
        Call the instance proxy.
        
        (WKPCCancelCheckIfAllowedToLoadURL):
        Ditto.
        
        * Plugins/Hosted/NetscapePluginInstanceProxy.h:
        * Plugins/Hosted/NetscapePluginInstanceProxy.mm:
        (WebKit::NetscapePluginInstanceProxy::NetscapePluginInstanceProxy):
        Initialize the check ID counter.
        
        (WebKit::NetscapePluginInstanceProxy::checkIfAllowedToLoadURL):
        Create a WebPluginContainerCheck, add it to the map, and start it.
        
        (WebKit::NetscapePluginInstanceProxy::cancelCheckIfAllowedToLoadURL):
        Remove the check from the map.
        
        (WebKit::NetscapePluginInstanceProxy::checkIfAllowedToLoadURLResult):
        Call the WKPH MIG callback.
        
        * Plugins/Hosted/WebHostedNetscapePluginView.h:
        * Plugins/Hosted/WebHostedNetscapePluginView.mm:
        (-[WebHostedNetscapePluginView _webPluginContainerCancelCheckIfAllowedToLoadRequest:]):
        Call the instance proxy.
        
        (-[WebHostedNetscapePluginView _containerCheckResult:contextInfo:]):
        Ditto.
        
        * Plugins/Hosted/WebKitPluginClient.defs:
        * Plugins/Hosted/WebKitPluginHost.defs:
        Add MIG declarations.

2009-04-28  Dan Bernstein  <mitz@apple.com>

        Reviewed by John Sullivan.

        - fix <rdar://problem/6786360> Make PDF an insertable pasteboard type

        * WebCoreSupport/WebPasteboardHelper.mm:
        (WebPasteboardHelper::insertablePasteboardTypes):
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _documentFragmentFromPasteboard:inContext:allowPlainText:]):
        (+[WebHTMLView _insertablePasteboardTypes]):
        (-[WebHTMLView _documentFragmentFromPasteboard:forType:inContext:subresources:]):

2009-04-27  Douglas R. Davidson  <ddavidso@apple.com>

        Add the various switches and context menu items needed for
        <rdar://problem/6724106> WebViews need to implement text checking
        and adopt updatePanels in place of old SPI _updateGrammar.

        Reviewed by Justin Garcia.

        * WebCoreSupport/WebContextMenuClient.mm:
        (fixMenusReceivedFromOldClients):
        * WebCoreSupport/WebEditorClient.h:
        * WebCoreSupport/WebEditorClient.mm:
        (WebEditorClient::uppercaseWord):
        (WebEditorClient::lowercaseWord):
        (WebEditorClient::capitalizeWord):
        (WebEditorClient::showSubstitutionsPanel):
        (WebEditorClient::substitutionsPanelIsShowing):
        (WebEditorClient::toggleSmartInsertDelete):
        (WebEditorClient::isAutomaticQuoteSubstitutionEnabled):
        (WebEditorClient::toggleAutomaticQuoteSubstitution):
        (WebEditorClient::isAutomaticLinkDetectionEnabled):
        (WebEditorClient::toggleAutomaticLinkDetection):
        (WebEditorClient::isAutomaticDashSubstitutionEnabled):
        (WebEditorClient::toggleAutomaticDashSubstitution):
        (WebEditorClient::isAutomaticTextReplacementEnabled):
        (WebEditorClient::toggleAutomaticTextReplacement):
        (WebEditorClient::isAutomaticSpellingCorrectionEnabled):
        (WebEditorClient::toggleAutomaticSpellingCorrection):
        (WebEditorClient::checkTextOfParagraph):
        * WebCoreSupport/WebViewFactory.mm:
        (-[WebViewFactory contextMenuItemTagShowColors]):
        (-[WebViewFactory contextMenuItemTagCorrectSpellingAutomatically]):
        (-[WebViewFactory contextMenuItemTagSubstitutionsMenu]):
        (-[WebViewFactory contextMenuItemTagShowSubstitutions:]):
        (-[WebViewFactory contextMenuItemTagSmartCopyPaste]):
        (-[WebViewFactory contextMenuItemTagSmartQuotes]):
        (-[WebViewFactory contextMenuItemTagSmartDashes]):
        (-[WebViewFactory contextMenuItemTagSmartLinks]):
        (-[WebViewFactory contextMenuItemTagTextReplacement]):
        (-[WebViewFactory contextMenuItemTagTransformationsMenu]):
        (-[WebViewFactory contextMenuItemTagMakeUpperCase]):
        (-[WebViewFactory contextMenuItemTagMakeLowerCase]):
        (-[WebViewFactory contextMenuItemTagCapitalize]):
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView validateUserInterfaceItemWithoutDelegate:]):
        (-[WebHTMLView isAutomaticQuoteSubstitutionEnabled]):
        (-[WebHTMLView setAutomaticQuoteSubstitutionEnabled:]):
        (-[WebHTMLView toggleAutomaticQuoteSubstitution:]):
        (-[WebHTMLView isAutomaticLinkDetectionEnabled]):
        (-[WebHTMLView setAutomaticLinkDetectionEnabled:]):
        (-[WebHTMLView toggleAutomaticLinkDetection:]):
        (-[WebHTMLView isAutomaticDashSubstitutionEnabled]):
        (-[WebHTMLView setAutomaticDashSubstitutionEnabled:]):
        (-[WebHTMLView toggleAutomaticDashSubstitution:]):
        (-[WebHTMLView isAutomaticTextReplacementEnabled]):
        (-[WebHTMLView setAutomaticTextReplacementEnabled:]):
        (-[WebHTMLView toggleAutomaticTextReplacement:]):
        (-[WebHTMLView isAutomaticSpellingCorrectionEnabled]):
        (-[WebHTMLView setAutomaticSpellingCorrectionEnabled:]):
        (-[WebHTMLView toggleAutomaticSpellingCorrection:]):
        * WebView/WebHTMLViewInternal.h:
        * WebView/WebPreferenceKeysPrivate.h:
        * WebView/WebUIDelegatePrivate.h:
        * WebView/WebView.mm:
        (-[WebViewPrivate init]):
        (-[WebView validateUserInterfaceItemWithoutDelegate:]):
        (-[WebView setGrammarCheckingEnabled:]):
        (-[WebView isAutomaticQuoteSubstitutionEnabled]):
        (-[WebView isAutomaticLinkDetectionEnabled]):
        (-[WebView isAutomaticDashSubstitutionEnabled]):
        (-[WebView isAutomaticTextReplacementEnabled]):
        (-[WebView isAutomaticSpellingCorrectionEnabled]):
        (-[WebView setAutomaticQuoteSubstitutionEnabled:]):
        (-[WebView toggleAutomaticQuoteSubstitution:]):
        (-[WebView setAutomaticLinkDetectionEnabled:]):
        (-[WebView toggleAutomaticLinkDetection:]):
        (-[WebView setAutomaticDashSubstitutionEnabled:]):
        (-[WebView toggleAutomaticDashSubstitution:]):
        (-[WebView setAutomaticTextReplacementEnabled:]):
        (-[WebView toggleAutomaticTextReplacement:]):
        (-[WebView setAutomaticSpellingCorrectionEnabled:]):
        (-[WebView toggleAutomaticSpellingCorrection:]):
        * WebView/WebViewPrivate.h:

2009-04-27  David Kilzer  <ddkilzer@apple.com>

        Consolidate runtime application checks for Apple Mail and Safari

        Reviewed by Mark Rowe and Darin Adler.

        * WebCoreSupport/WebContextMenuClient.mm:
        (isAppleMail): Removed.
        (fixMenusToSendToOldClients): Switched to use
        applicationIsAppleMail().
        * WebView/WebFrame.mm:
        (-[WebFrame reload]): Switched to use applicationIsSafari().
        * WebView/WebPDFView.mm:
        (-[WebPDFView menuForEvent:]): Ditto.
        * WebView/WebResource.mm:
        (+[WebResource _needMailThreadWorkaroundIfCalledOffMainThread]):
        Switched to use applicationIsAppleMail().
        * WebView/WebView.mm:
        (runningLeopardMail): Ditto.
        (runningTigerMail): Ditto.
        (-[WebView _needsKeyboardEventDisambiguationQuirks]): Switched
        to use applicationIsSafari().

2009-04-27  Kevin Decker  <kdecker@apple.com>

        Fix the Tiger build.
        
        * Plugins/WebNetscapePluginView.mm: The base class of WebNetscapePluginView.mm, WebBaseNetscapePluginView, already implemented 
        the two methods below. But the Tiger compiler didn't know that. 
        (-[WebNetscapePluginView webView]): 
        (-[WebNetscapePluginView webFrame]):

2009-04-27  Kevin Decker  <kdecker@apple.com>

        Reviewed by Anders Carlsson.

        <rdar://problem/6352982>
        
        * Plugins/WebBaseNetscapePluginView.mm: Removed checkIfAllowedToLoadURL:frame:callbackFunc, cancelCheckIfAllowedToLoadURL, and 
        _webPluginContainerCancelCheckIfAllowedToLoadRequest from the base class. These methods now exist in the subclass WebNetscapePluginView.
        
        Added WebNetscapeContainerCheckContextInfo, which is used as a "contextInfo" object in 
        -[WebNetscapePluginView checkIfAllowedToLoadURL:frame:callbackFunc:]
        * Plugins/WebNetscapeContainerCheckContextInfo.h: Added.
        * Plugins/WebNetscapeContainerCheckContextInfo.mm: Added.
        (-[WebNetscapeContainerCheckContextInfo initWithCheckRequestID:callbackFunc:]): Added desiginated initializer.
        (-[WebNetscapeContainerCheckContextInfo checkRequestID]): Added. Returns the checkRequestID.
        (-[WebNetscapeContainerCheckContextInfo callback]): Added. Returns the callback.
        
        * Plugins/WebNetscapePluginView.h: Added two new ivars: _containerChecksInProgress and _currentContainerCheckRequestID.
        * Plugins/WebNetscapePluginView.mm: #import both WebPluginContainerCheck.h and WebNetscapeContainerCheckContextInfo.h
        
        (-[WebNetscapePluginView checkIfAllowedToLoadURL:frame:callbackFunc:]): Added. This is the implementation of WKN_CheckIfAllowedToLoadURL.
        Here, we increment the request ID and start the container check.
        
        (-[WebNetscapePluginView _containerCheckResult:contextInfo:]): Added. This is a callback method for WebPluginContainerCheck.
        It's where we actually call into the plug-in and provide the allow-or-deny result.
    
        (-[WebNetscapePluginView cancelCheckIfAllowedToLoadURL:]): Added. This is the implementation of WKN_CancelCheckIfAllowedToLoadURL. 
        Here we lookup the check, cancel it, and remove it from _containerChecksInProgress.
        
        (-[WebNetscapePluginView _webPluginContainerCancelCheckIfAllowedToLoadRequest:]): Added. WebPluginContainerCheck automatically calls
        this method after invoking our _containerCheckResult: selector. It works this way because calling -[WebPluginContainerCheck cancel] allows
        it to do it's teardown process.
        
        (-[WebNetscapePluginView fini]): Release _containerChecksInProgress ivar.
        
        * Plugins/WebPluginContainerCheck.h: Removed initWithRequest: method from header; no client was using this method directly.
        * Plugins/WebPluginContainerCheck.mm: 
        (+[WebPluginContainerCheck checkWithRequest:target:resultObject:selector:controller:contextInfo:]): Added optional contextInfo parameter.
        (-[WebPluginContainerCheck _continueWithPolicy:]): If there's a contextInfo object, pass it as a parameter to resultSelector.
        (-[WebPluginContainerCheck cancel]): Release _contextInfo ivar.
        (-[WebPluginContainerCheck contextInfo]): Added new method. Returns the contextInfo object, if one so exists.
        * Plugins/WebPluginController.mm:
        (-[WebPluginController _webPluginContainerCheckIfAllowedToLoadRequest:inFrame:resultObject:selector:]): Pass nil for contextInfo. WebKit-style
        plug-ins do not need additional context information.

2009-04-25  Brady Eidson  <beidson@apple.com>

        Reviewed by Sam Weinig

        Some *obvious* style cleanup in my last patch.

        * History/WebBackForwardList.mm:
        (bumperCarBackForwardHackNeeded):

2009-04-25  Brady Eidson  <beidson@apple.com>

        Reviewed by Oliver Hunt

        <rdar://problem/6817607> BumperCar 2.2 crashes going back (invalid WebHistoryItem)

        BumperCar was holding a pointer to a WebHistoryItem they never retain, then later
        tried to go to it.  In some cases it would be dealloc'ed first.
        When WebHistoryItems were pure Objective-C they probably got away with this more often.
        With the WebCore/Obj-C mixed WebHistoryItems it's more likely to crash.

        * History/WebBackForwardList.mm:
        (bumperCarBackForwardHackNeeded):
        (-[WebBackForwardList backListWithLimit:]):  If this is BumperCar, hang on to the
          NSArray of WebHistoryItems until the next time this method is called.
        (-[WebBackForwardList forwardListWithLimit:]):  Ditto.

        * Misc/WebKitVersionChecks.h: Added WEBKIT_FIRST_VERSION_WITHOUT_BUMPERCAR_BACK_FORWARD_QUIRK.

2009-04-24  Anders Carlsson  <andersca@apple.com>

        Reviewed by Darin Adler.

        Fix <rdar://problem/6761635>.
        
        Make sure to keep an extra reference to the instance proxy in case the plug-in host crashes while
        we're waiting for a reply.
        
        * Plugins/Hosted/NetscapePluginInstanceProxy.mm:
        (WebKit::NetscapePluginInstanceProxy::destroy):

2009-04-24  Brady Eidson  <beidson@apple.com>

        Reviewed by Dan Bernstein

        Currently working on a bug where a WebHistoryItem was being used after being dealloc'ed.
        I added this assertion to help catch the case as soon as it happens instead of random
        issues downstream.  Figured it's worth checking in by itself.

        * History/WebHistoryItem.mm:
        (core): ASSERT that the WebCore::HistoryItem inside this WebHistoryItem is supposed to have
          this WebHistoryItem as a wrapper.

2009-04-23  Beth Dakin  <bdakin@apple.com>

        Reviewed by Darin Adler.

        Fix for <rdar://problem/6333461> REGRESSION (r36864-r36869): 
        Dragging stocks widget scrollbar drags the whole widget

        Look for our new WebCore scrollbars in the WebHTMLView and add 
        proper Dashboard regions for them.

        * WebView/WebView.mm:
        (-[WebView _addScrollerDashboardRegionsForFrameView:dashboardRegions:]):
        (-[WebView _addScrollerDashboardRegions:from:]):

2009-04-23  John Sullivan  <sullivan@apple.com>

        fixed <rdar://problem/6822479> Assertion failure after Reset Safari in new history-writing code

        Reviewed by Oliver Hunt

        * History/WebHistory.mm:
        (-[WebHistoryPrivate data]):
        Return nil immediately if there are no entries; this matches a recent Windows-platform fix.

2009-04-23  Dimitri Glazkov  <dglazkov@chromium.org>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=25313
        Missing scroll bars in GMail.

        * WebView/WebDynamicScrollBarsView.m:
        (-[WebDynamicScrollBarsView updateScrollers]): Added check for the ScrollbarAlwaysOn
            scroll mode.

2009-04-23  Kevin Decker  <kdecker@apple.com>

        * Plugins/WebPluginContainerCheck.h: Fix the Tiger build.

2009-04-23  Anders Carlsson  <andersca@apple.com>

        Reviewed by Geoffrey Garen.

        Fix <rdar://problem/6821992>

        Add a new m_inDestroy member variable. Set it to true when in destroy, and have all NPRuntime functions return false
        when m_inDestroy is true.
        
        * Plugins/Hosted/NetscapePluginInstanceProxy.h:
        * Plugins/Hosted/NetscapePluginInstanceProxy.mm:
        (WebKit::NetscapePluginInstanceProxy::NetscapePluginInstanceProxy):
        (WebKit::NetscapePluginInstanceProxy::destroy):
        (WebKit::NetscapePluginInstanceProxy::invoke):
        (WebKit::NetscapePluginInstanceProxy::invokeDefault):
        (WebKit::NetscapePluginInstanceProxy::construct):
        (WebKit::NetscapePluginInstanceProxy::getProperty):
        (WebKit::NetscapePluginInstanceProxy::setProperty):
        (WebKit::NetscapePluginInstanceProxy::removeProperty):
        (WebKit::NetscapePluginInstanceProxy::hasProperty):
        (WebKit::NetscapePluginInstanceProxy::hasMethod):
        (WebKit::NetscapePluginInstanceProxy::enumerate):

2009-04-23  David Hyatt  <hyatt@apple.com>

        Reviewed by Maciej.

        Fix for <rdar://problem/6789879> REGRESSION (42464): Hitting assertion when loading message in Mail + TOT WebKit
        
        Make the Mac platform the same as all the other platforms.  Instead of (incorrectly) marking a FrameView for layout
        when its underlying document view changes, just mark the outermost frame view for layout when the WebView's size changes.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _frameOrBoundsChanged]):
        (-[WebHTMLView addSuperviewObservers]):
        * WebView/WebView.mm:
        (-[WebView _boundsChanged]):
        (-[WebView removeSizeObservers]):
        (-[WebView addSizeObservers]):

2009-04-23  Kevin Decker  <kdecker@apple.com>

        Reviewed by Tim Hatcher.

        Second part of the fix for <rdar://problem/6352982>

        * Plugins/WebBaseNetscapePluginView.h: Make this class conform to WebPluginContainerCheckController
        * Plugins/WebBaseNetscapePluginView.mm: Likewise.
        (-[WebBaseNetscapePluginView _webPluginContainerCancelCheckIfAllowedToLoadRequest:]): Added skeleton method.
        * Plugins/WebPluginContainerCheck.h: Added protocol for <WebPluginContainerCheckController>
        * Plugins/WebPluginContainerCheck.mm:
        (-[WebPluginContainerCheck initWithRequest:target:resultObject:selector:controller:]):
        * Plugins/WebPluginController.h: Make this class conform to WebPluginContainerCheckController

2009-04-23  Kevin Decker  <kdecker@apple.com>

        Reviewed by Anders Carlsson.
        
        First part of <rdar://problem/6352982>

        * Plugins/WebBaseNetscapePluginView.h: Imported #WebNetscapeContainerCheckPrivate.h; Added two new method:
        checkIfAllowedToLoadURL:url:frame:callbackFunc: and cancelCheckIfAllowedToLoadURL:
        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView checkIfAllowedToLoadURL:frame:callbackFunc:]): Added skeleton method, does nothing interesting
        yet.
        (-[WebBaseNetscapePluginView cancelCheckIfAllowedToLoadURL:]): Likewise.
        * Plugins/WebNetscapeContainerCheckPrivate.h: Added.
        * Plugins/WebNetscapeContainerCheckPrivate.mm: Added.
        (browserContainerCheckFuncs): Added. 
        * Plugins/WebNetscapePluginView.h: Imported #WebNetscapeContainerCheckPrivate.h;
        * Plugins/WebNetscapePluginView.mm: Imported #WebNetscapeContainerCheckPrivate.h; added WKN_CheckIfAllowedToLoadURL
        and WKN_CancelCheckIfAllowedToLoadURL functions.
        (-[WebNetscapePluginView getVariable:value:]): Return vtable for container check functions.
        * Plugins/npapi.mm:
        (WKN_CheckIfAllowedToLoadURL): Added new private function.
        (WKN_CancelCheckIfAllowedToLoadURL): Ditto.

2009-04-22  Oliver Hunt  <oliver@apple.com>

        Reviewed by Darin Adler.

        <rdar://problem/6757346> SAP: Prevent default on mouseDown does not stop iframe from capturing subsequent mouse moves
        
        Make mouseUP forward to the root view as we do for mouseMoves and mouseDragged:.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView mouseUp:]):

2009-04-22  Oliver Hunt  <oliver@apple.com>

        Reviewed by Darin Adler.

        <rdar://problem/6757346> SAP: Prevent default on mouseDown does not stop iframe from capturing subsequent mouse moves
        
        Make mouseDragged forward to the root view as we do for mouseMoves.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView mouseDragged:]):

2009-04-22  Anders Carlsson  <andersca@apple.com>

        Reviewed by Oliver Hunt.

        Fix <rdar://problem/6792694>
        
        When we're trying to instantiate a plug-in and the plug-in host has died, we need to invalidate the
        instance so that it doesn't stick around and do bad things.
        
        * Plugins/Hosted/NetscapePluginHostManager.mm:
        (WebKit::NetscapePluginHostManager::instantiatePlugin):

2009-04-22  Sam Weinig  <sam@webkit.org>

        Rubber-stamped by Darin Adler.

        Fix for <rdar://problem/6816957>
        Turn off Geolocation by default

        * Configurations/FeatureDefines.xcconfig:

2009-04-21  Dan Bernstein  <mitz@apple.com>

        Reviewed by Jon Honeycutt.

        - Mac part of fixing for <rdar://problem/6755137> Action dictionary for
          policy decision is missing keys when full-page zoom is used

        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::actionDictionary): Use absoluteLocation() instead
        of pageX() and pageY(), which are adjusted for zoom.

2009-04-21  Anders Carlsson  <andersca@apple.com>

        Reviewed by Darin Adler and Kevin Decker.

        WebKit side of <rdar://problem/6781642>.
        
        When we call resize with an actual changed size, block until the plug-in host is done.
        
        * Plugins/Hosted/NetscapePluginInstanceProxy.h:
        * Plugins/Hosted/NetscapePluginInstanceProxy.mm:
        (WebKit::NetscapePluginInstanceProxy::resize):
        * Plugins/Hosted/WebHostedNetscapePluginView.h:
        * Plugins/Hosted/WebHostedNetscapePluginView.mm:
        (-[WebHostedNetscapePluginView updateAndSetWindow]):
        * Plugins/Hosted/WebKitPluginHost.defs:

2009-04-17  Timothy Hatcher  <timothy@apple.com>

        Change how sudden termination works with WebView teardown.

        <rdar://problem/6383352&6383379&6383940>

        Reviewed by Darin Adler.

        * WebCoreSupport/WebChromeClient.h: Remove disableSuddenTermination/enableSuddenTermination.
        * WebCoreSupport/WebChromeClient.mm: Ditto.
        * WebView/WebFrame.mm:
        (-[WebFrame _pendingFrameUnloadEventCount]): Ask the DOMWindow.
        * WebView/WebView.mm:
        (+[WebView canCloseAllWebViews]): Call DOMWindow::dispatchAllPendingBeforeUnloadEvents.
        (+[WebView closeAllWebViews]): Call DOMWindow::dispatchAllPendingUnloadEvents and
        call close on all the WebViews.
        (-[WebView _closeWithFastTeardown]): Remove code for unload event dispatch.
        (-[WebView _close]): Correct a comment.
        (+[WebView _applicationWillTerminate]): Call closeAllWebViews.
        * WebView/WebViewPrivate.h: Add canCloseAllWebViews and closeAllWebViews.

2009-04-21  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Mark Rowe.

        Tiger crash fix: Put VM tags in their own header file, and fixed up the
        #ifdefs so they're not used on Tiger.

        * ForwardingHeaders/wtf/VMTags.h: Copied from ForwardingHeaders/wtf/HashTraits.h.

2009-04-17  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        <rdar://problem/6722845>
        In the Cocoa event model, NPWindow's window field should be null
        
        * Plugins/Hosted/NetscapePluginHostProxy.mm:
        (WKPCConvertPoint):
        Get the instance proxy and call it's convertPoint function.
        
        * Plugins/Hosted/NetscapePluginInstanceProxy.h:
        * Plugins/Hosted/NetscapePluginInstanceProxy.mm:
        (WebKit::NetscapePluginInstanceProxy::convertPoint):
        Call convertPoint on the plug-in view.
        
        * Plugins/Hosted/WebKitPluginClient.defs:
        Add PCConvertPoint.
        
        * Plugins/WebBaseNetscapePluginView.h:
        Add a declaration for convertFromX:andY:space:toX:andY:space:.
        
        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView convertFromX:andY:space:toX:andY:space:]):
        Convert a point from one coordinate system to another.
        
        * Plugins/WebNetscapePluginEventHandler.h:
        * Plugins/WebNetscapePluginEventHandlerCarbon.h:
        * Plugins/WebNetscapePluginEventHandlerCarbon.mm:
        (WebNetscapePluginEventHandlerCarbon::drawRect):
        * Plugins/WebNetscapePluginEventHandlerCocoa.h:
        Add CGContextRef to drawRect.

        * Plugins/WebNetscapePluginEventHandlerCocoa.mm:
        (WebNetscapePluginEventHandlerCocoa::drawRect):
        Set the passed in context.
        
        * Plugins/WebNetscapePluginPackage.mm:
        (-[WebNetscapePluginPackage _tryLoad]):
        Add NPN_ConvertPoint to the browserFuncs vtable.
        
        * Plugins/WebNetscapePluginView.mm:
        (-[WebNetscapePluginView saveAndSetNewPortStateForUpdate:]):
        Only set the window for the Carbon event model.
        
        (-[WebNetscapePluginView restorePortState:]):
        It's OK for the window context to be null.
        
        (-[WebNetscapePluginView sendDrawRectEvent:]):
        Pass the CGContextRef to drawRect.

        * Plugins/npapi.mm:
        (NPN_ConvertPoint):
        Call the plug-in view method.

2009-04-20  Sam Weinig  <sam@webkit.org>

        Rubber-stamped by Tim Hatcher.

        Add licenses for xcconfig files.
        
        * Configurations/Base.xcconfig:
        * Configurations/DebugRelease.xcconfig:
        * Configurations/FeatureDefines.xcconfig:
        * Configurations/Version.xcconfig:
        * Configurations/WebKit.xcconfig:

2009-04-20  Anders Carlsson  <andersca@apple.com>

        Reviewed by Dan Bernstein.

        WebKit side of <rdar://problem/6781302>
        
        * Plugins/Hosted/NetscapePluginInstanceProxy.h:
        * Plugins/Hosted/NetscapePluginInstanceProxy.mm:
        (WebKit::NetscapePluginInstanceProxy::keyEvent):
        Pass the event keyChar.
        
        (WebKit::NetscapePluginInstanceProxy::syntheticKeyDownWithCommandModifier):
        Ditto.
        
        (WebKit::NetscapePluginInstanceProxy::flagsChanged):
        Pass a 0 keyChar.
        
        * Plugins/Hosted/WebHostedNetscapePluginView.mm:
        (-[WebHostedNetscapePluginView flagsChanged:]):
        Call NetscapePluginInstanceProxy::flagsChanged.
        
        * Plugins/Hosted/WebKitPluginHost.defs:
        Add a keyChar argument.

2009-04-19  Adele Peterson  <adele@apple.com>

        Reviewed by Darin Adler.

        Fix for <rdar://problem/6804809> REGRESSION: In Mail, Home and End do not scroll message

        If no scrolling occurs, call tryToPerform on the next responder.  Then our WebResponderChainSink
        will correctly detect if no responders handle the selector.

        * WebView/WebFrameView.mm:
        (-[WebFrameView _scrollToBeginningOfDocument]):
        (-[WebFrameView _scrollToEndOfDocument]):
        (-[WebFrameView scrollToBeginningOfDocument:]):
        (-[WebFrameView scrollToEndOfDocument:]):
        (-[WebFrameView scrollLineUp:]):
        (-[WebFrameView scrollLineDown:]):

2009-04-19  David Kilzer  <ddkilzer@apple.com>

        Make FEATURE_DEFINES completely dynamic

        Reviewed by Darin Adler.

        Make FEATURE_DEFINES depend on individual ENABLE_FEATURE_NAME
        variables for each feature, making it possible to remove all
        knowledge of FEATURE_DEFINES from build-webkit.

        * Configurations/FeatureDefines.xcconfig: Extract a variable
        from FEATURE_DEFINES for each feature setting.

2009-04-18  Pierre d'Herbemont  <pdherbemont@apple.com>

        Reviewed by Mark Rowe.

        <rdar://problem/6781295> video.buffered and video.seekable are not
        the same. video.buffered should return only what is buffered and
        not what is seekable

        * WebCoreSupport/WebSystemInterface.m:
        (InitWebCoreSystemInterface): Add wkQTMovieMaxTimeSeekable.

2009-04-18  Pierre d'Herbemont  <pdherbemont@apple.com>

        Reviewed by Adele Peterson.

        <rdar://problem/6747241> work around QTKit no longer reaching
        QTMovieLoadStateComplete

        * WebCoreSupport/WebSystemInterface.m:
        (InitWebCoreSystemInterface): Init the new WKSI exported symbol.

2009-04-17  Anders Carlsson  <andersca@apple.com>

        Reviewed by Dan Bernstein.

        <rdar://problem/6714488>
        REGRESSION (Safari 3-4): Edit menu commands (cut/copy/paste/select all) do not work on Flash content
        
        * Plugins/Hosted/NetscapePluginInstanceProxy.h:
        * Plugins/Hosted/NetscapePluginInstanceProxy.mm:
        (WebKit::NetscapePluginInstanceProxy::syntheticKeyDownWithCommandModifier):
        Send a keyDown event to the plug-in host.
        
        * Plugins/Hosted/WebHostedNetscapePluginView.mm:
        (-[WebHostedNetscapePluginView sendModifierEventWithKeyCode:character:]):
        Call the plug-in instance proxy.
        
        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView sendModifierEventWithKeyCode:character:]):
        Add this. Subclasses are required to override it.
        
        (-[WebBaseNetscapePluginView cut:]):
        (-[WebBaseNetscapePluginView copy:]):
        (-[WebBaseNetscapePluginView paste:]):
        (-[WebBaseNetscapePluginView selectAll:]):
        Call sendModifierEventWithKeyCode.
        
        * Plugins/WebNetscapePluginEventHandler.h:
        Add syntheticKeyDownWithCommandModifier.
        
        * Plugins/WebNetscapePluginEventHandlerCarbon.h:
        * Plugins/WebNetscapePluginEventHandlerCarbon.mm:
        (WebNetscapePluginEventHandlerCarbon::syntheticKeyDownWithCommandModifier):
        Send the synthetic event.
        
        * Plugins/WebNetscapePluginEventHandlerCocoa.h:
        * Plugins/WebNetscapePluginEventHandlerCocoa.mm:
        (WebNetscapePluginEventHandlerCocoa::syntheticKeyDownWithCommandModifier):
        Send the synthetic event.
        
        * Plugins/WebNetscapePluginView.mm:
        (-[WebNetscapePluginView sendModifierEventWithKeyCode:character:]):
        Call the event handler.

2009-04-17  David Kilzer  <ddkilzer@apple.com>

        Simplify FEATURE_DEFINES definition

        Reviewed by Darin Adler.

        This moves FEATURE_DEFINES and its related ENABLE_FEATURE_NAME
        variables to their own FeatureDefines.xcconfig file.  It also
        extracts a new ENABLE_GEOLOCATION variable so that
        FEATURE_DEFINES only needs to be defined once.

        * Configurations/FeatureDefines.xcconfig: Added.
        * Configurations/WebKit.xcconfig: Removed definition of
        ENABLE_SVG_DOM_OBJC_BINDINGS and FEATURE_DEFINES.  Added include
        of FeatureDefines.xcconfig.

2009-04-17  Anders Carlsson  <andersca@apple.com>

        Reviewed by Darin Adler.

        Fix crashes seen in regression tests with hosted plug-ins.

        * Plugins/Hosted/NetscapePluginInstanceProxy.mm:
        (WebKit::NetscapePluginInstanceProxy::cancelStreamLoad): Check the stream for 0,
        not the stream ID.

2009-04-17  Darin Adler  <darin@apple.com>

        Reviewed by Antti Koivisto.

        Bug 25210: don't use ObjC methods to wrap/unwrap DOM objects with ObjC
        https://bugs.webkit.org/show_bug.cgi?id=25210

        * DOM/WebDOMOperations.mm:
        (-[DOMNode markupString]): Use the core function instead of an Objective-C method.
        (-[DOMNode _subresourceURLs]): Ditto.
        (-[DOMDocument _focusableNodes]): Ditto.
        (-[DOMRange webArchive]): Ditto.
        (-[DOMRange markupString]): Ditto.

        * Misc/WebElementDictionary.mm: Added now-needed include since the core and kit
        functions now come from the internal headers from DOM bindings.
        * Misc/WebNSPasteboardExtras.mm: Ditto.
        * Plugins/WebNullPluginView.mm: Ditto.
        * Plugins/WebPluginController.mm: Ditto.
        * WebCoreSupport/WebChromeClient.mm: Ditto.
        * WebCoreSupport/WebInspectorClient.mm: Ditto.
        * WebCoreSupport/WebPasteboardHelper.mm: Ditto.
        * WebView/WebHTMLView.mm: Ditto.

        * WebCoreSupport/WebEditorClient.mm: Made kit function have internal linkage
        since it's only used in this file. Someone had instead added a declaration to
        suppress the warning you would otherwise get. Removed the core function.
        (WebEditorClient::textFieldDidBeginEditing): Added correct type checking.
        Previously the function would check only that something was an HTMLElement,
        but then cast it to HTMLInputElement. Also call kit instead of old wrap method.
        (WebEditorClient::textFieldDidEndEditing): Ditto.
        (WebEditorClient::textDidChangeInTextField): Ditto.
        (WebEditorClient::doTextFieldCommandFromEvent): Ditto.
        (WebEditorClient::textWillBeDeletedInTextField): Ditto.
        (WebEditorClient::textDidChangeInTextArea): Ditto, but for HTMLTextAreaElement.

        * WebView/WebFrame.mm: Removed the core and kit functions here which are no longer
        needed since they're automatically generated now.
        (-[WebFrame _nodesFromList:]): Use kit.
        (-[WebFrame _markupStringFromRange:nodes:]): Use core.
        (-[WebFrame _stringForRange:]): More of the same.
        (-[WebFrame _caretRectAtNode:offset:affinity:]): Ditto.
        (-[WebFrame _firstRectForDOMRange:]): Ditto.
        (-[WebFrame _scrollDOMRangeToVisible:]): Ditto.
        (-[WebFrame _rangeByAlteringCurrentSelection:SelectionController::direction:SelectionController::granularity:]):
        Ditto.
        (-[WebFrame _convertNSRangeToDOMRange:]): Ditto.
        (-[WebFrame _convertDOMRangeToNSRange:]): Ditto.
        (-[WebFrame _markDOMRange]): Ditto.
        (-[WebFrame _smartDeleteRangeForProposedRange:]): Ditto.
        (-[WebFrame _smartInsertForString:replacingRange:beforeString:afterString:]): Ditto.
        (-[WebFrame _documentFragmentWithMarkupString:baseURLString:]): Ditto.
        (-[WebFrame _documentFragmentWithNodesAsParagraphs:]): Ditto.
        (-[WebFrame _replaceSelectionWithNode:selectReplacement:smartReplace:matchStyle:]): Ditto.
        (-[WebFrame _characterRangeAtPoint:]): Ditto.
        (-[WebFrame _typingStyle]): Ditto.
        (-[WebFrame _setTypingStyle:withUndoAction:]): Ditto.
        (-[WebFrame _pauseAnimation:onNode:atTime:]): Ditto.
        (-[WebFrame _pauseTransitionOfProperty:onNode:atTime:]): Ditto.
        (-[WebFrame _replaceSelectionWithFragment:selectReplacement:smartReplace:matchStyle:]): Ditto.

        * WebView/WebFrameInternal.h: Removed the core and kit functions here which are no longer
        needed since they're automatically generated now.

        * WebView/WebHTMLRepresentation.mm:
        (-[WebHTMLRepresentation attributedStringFrom:startOffset:to:endOffset:]): Use core.
        (formElementFromDOMElement): Ditto.
        (inputElementFromDOMElement): Ditto.
        * WebView/WebTextIterator.mm:
        (-[WebTextIterator initWithRange:]): Ditto.
        (-[WebTextIterator currentRange]): Ditto.
        (-[WebTextIterator currentNode]): Ditto.
        * WebView/WebView.mm:
        (-[WebView textIteratorForRect:]): Ditto.
        (-[WebView setSelectedDOMRange:affinity:]): Ditto.

2009-04-17  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        WebKit side of <rdar://problem/6449642>.
        
        * Plugins/Hosted/HostedNetscapePluginStream.h:
        (WebKit::HostedNetscapePluginStream::create):
        New function that creates a stream from a frame loader.
        
        * Plugins/Hosted/HostedNetscapePluginStream.mm:
        (WebKit::HostedNetscapePluginStream::HostedNetscapePluginStream):
        Add the constructor that takes a frame loader.
        
        * Plugins/Hosted/NetscapePluginHostManager.h:
        * Plugins/Hosted/NetscapePluginHostManager.mm:
        (WebKit::NetscapePluginHostManager::instantiatePlugin):
        Pass "fullFrame" to the plug-in host.
        
        * Plugins/Hosted/NetscapePluginHostProxy.mm:
        (WKPCCancelLoadURL):
        Call NetscapePluginInstanceProxy::cancelStreamLoad.
        
        * Plugins/Hosted/NetscapePluginInstanceProxy.h:
        (WebKit::NetscapePluginInstanceProxy::create):
        Pass "fullFrame" to the constructor.
        
        (WebKit::NetscapePluginInstanceProxy::manualStream):
        New getter for the manual stream.
        
        * Plugins/Hosted/NetscapePluginInstanceProxy.mm:
        (WebKit::NetscapePluginInstanceProxy::NetscapePluginInstanceProxy):
        Take the implicit request into account if we have a full frame plug-in.
        
        (WebKit::NetscapePluginInstanceProxy::setManualStream):
        Setter for the manual stream.
        
        (WebKit::NetscapePluginInstanceProxy::cancelStreamLoad):
        Cancel the manual stream if necessary.
        
        * Plugins/Hosted/WebHostedNetscapePluginView.h:
        WebHostedNetscapePluginView now conforms to the WebPluginManualLoader protocol.
        
        * Plugins/Hosted/WebHostedNetscapePluginView.mm:
        (-[WebHostedNetscapePluginView createPlugin]):
        Pass "fullFrame" to instantiatePlugin.
        
        (-[WebHostedNetscapePluginView pluginView:receivedResponse:]):
        (-[WebHostedNetscapePluginView pluginView:receivedData:]):
        (-[WebHostedNetscapePluginView pluginView:receivedError:]):
        (-[WebHostedNetscapePluginView pluginViewFinishedLoading:]):
        Call the equivalent manual stream functions.
        
        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::createPlugin):
        Use a macro for getting the plug-in view type.

2009-04-14  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Dan Bernstein

        https://bugs.webkit.org/show_bug.cgi?id=25157
        
        Move the run loop observer cleanup from -close
        to -_close.

        * WebView/WebView.mm:
        (-[WebView _close]):
        (-[WebView close]):

2009-04-14  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        - Speculative fix for <rdar://problem/6781422> 

        Protect the plug-in instance proxy in case it's deleted while waiting for a reply.

        * Plugins/Hosted/NetscapePluginInstanceProxy.mm:
        (WebKit::NetscapePluginInstanceProxy::wheelEvent):

2009-04-14  Adele Peterson  <adele@apple.com>

        Reviewed by Darin.

        Initialize WebKitSystemInterface in class methods that could get called before a WebView/WebFrame is set up.  This was causing Mail to crash on launch.

        * Misc/WebCache.mm: (+[WebCache initialize]):
        * WebView/WebView.mm: (+[WebView initialize]):

2009-04-13  Kevin Decker  <kdecker@apple.com>

        Reviewed by Darin.

        <rdar://problem/6784955> REGRESSION: closing a tab containing a PDF causes world leaks
        
        Simplify the _trackFirstResponder method by just caching the value instead of retaining
        a Cocoa object.
        
        * WebView/WebPDFView.h: Eliminated trackedFirstResponder object and replaced it with
        a firstResponderIsPDFDocumentView boolean.
        * WebView/WebPDFView.mm: 
        (-[WebPDFView dealloc]): Removed no longer necessary ASSERT.
        (-[WebPDFView viewWillMoveToWindow:]): Removed call to release and nil-out trackedFirstResponder,
        which no longer exists. In the new code all we do now is set firstResponderIsPDFDocumentView to NO.
        (-[WebPDFView _trackFirstResponder]): Rewrote this method to just cache the value instead
        of retaining an object.

2009-04-13  David Hyatt  <hyatt@apple.com>

        Reviewed by Sam Weinig.

        Fix for https://bugs.webkit.org/show_bug.cgi?id=25125.  Rework scrolling so that a layout happens first when
        it's already needed so that the code doesn't end up making bad decisions based off invalid document sizes.

        This patch also eliminates WebHTMLView's separate notion of needing a layout and just consolidates it with
        WebCore's notion of needing layout.

        * WebView/WebDynamicScrollBarsView.m:
        (-[WebDynamicScrollBarsView updateScrollers]):
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _frameOrBoundsChanged]):
        (-[WebHTMLView initWithFrame:]):
        (-[WebHTMLView layoutToMinimumPageWidth:maximumPageWidth:adjustingViewSize:]):
        (-[WebHTMLView setNeedsLayout:]):
        (-[WebHTMLView _layoutIfNeeded]):
        (-[WebHTMLView _needsLayout]):
        * WebView/WebHTMLViewInternal.h:

2009-04-13  Darin Adler  <darin@apple.com>

        * WebView/WebViewPrivate.h: Updated comments.

2009-04-13  Antti Koivisto  <antti@apple.com>

        Reviewed by Darin Adler.
        
        <rdar://problem/6740294> Increase the connection count per host

        * WebCoreSupport/WebSystemInterface.m:
        (InitWebCoreSystemInterface):

2009-04-13  Brady Eidson  <beidson@apple.com>

        Reviewed by Tim Hatcher

        Tweak my last check-in, moving the thread violation check up to the API-level calls so the logging is more
        useful to developers/users.

        * WebView/WebFrame.mm:
        (-[WebFrame _loadData:MIMEType:textEncodingName:baseURL:unreachableURL:]): If not on the main thread, only
          perform the "call on main thead" workaround, as the log/exception raising is now up at the API level.
        (-[WebFrame loadData:MIMEType:textEncodingName:baseURL:]): Perform a thread violation check here so logging
          is more meaningful.
        (-[WebFrame loadHTMLString:baseURL:]): Ditto.
        (-[WebFrame loadAlternateHTMLString:baseURL:forUnreachableURL:]): Ditto.

2009-04-13  Brady Eidson  <beidson@apple.com>

        Reviewed by Kevin Decker

        <rdar://problem/6712063> Garmin WebUpdater crashes

        * WebView/WebFrame.mm:
        (-[WebFrame _loadData:MIMEType:textEncodingName:baseURL:unreachableURL:]):  If not called on the main thread,
          add a ThreadViolationCheckRoundTwo() call to either log or raise an exception.  In the case where it's
          only a log, reschedule the _loadData call to occur on the main thread.

2009-04-10  Dan Bernstein  <mitz@apple.com>

        Reviewed by Jon Honeycutt.

        - fix <rdar://problem/6752340> Light blue-green background in content
          area in Mail

        * WebView/WebView.mm:
        (-[WebView _commonInitializationWithFrameName:groupName:usesDocumentViews:]):
        Use device white, rather than calibrated white, as the default
        background color.

2009-04-10  Darin Adler  <darin@apple.com>

        Reviewed by Brady Eidson.

        <rdar://problem/6773515> crash in push_heap inside WebCore when printing

        The crash was due to manipulating a timer on a different thread than the one it was created on.

        * History/WebHistoryItem.mm:
        (-[WebWindowWatcher windowWillClose:]): Call later on main thread, if called on non-main thread.
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView windowDidBecomeKey:]): Ditto.
        (-[WebHTMLView windowDidResignKey:]): Ditto.
        (-[WebHTMLView windowWillClose:]): Ditto.
        (-[WebHTMLView _updateControlTints]): Added. Factored out the non-thread-safe part of
        our override of _windowChangedKeyState.
        (-[WebHTMLView _windowChangedKeyState]): Call _updateControlTints later on main thread, if
        called on non-main thread.
        * WebView/WebPreferences.mm:
        (-[WebPreferences _postPreferencesChangesNotification]): Call later on main thread, if called
        on non-main thread

2009-04-10  Timothy Hatcher  <timothy@apple.com>

        Remove DOMDocumentPrivate.h now that <rdar://problem/6730996> is fixed.

        Rubber-stamped by Mark Rowe.

        * Misc/DOMDocumentPrivate.h: Removed.

2009-04-10  Pierre d'Herbemont  <pdherbemont@apple.com>

        Reviewed by Adele Peterson.

        <rdar://problem/6646998> Avoid starting QTKitServer if possible
        Add the requires symbol in the WebSystemInterface. It is used by
        WebCore.

        * WebCoreSupport/WebSystemInterface.m:
        (InitWebCoreSystemInterface): Add wkQTIncludeOnlyModernMediaFileTypes.

2009-04-09  Kevin Decker  <kdecker@apple.com>

        Reviewed by Hyatt.

        <rdar://problem/4680397> tearing seen because deferred updates are disabled
        
        * WebView/WebFrameView.mm:
        (-[WebFrameView initWithFrame:]): Don't call WKDisableCGDeferredUpdates on post-Leopard if 
        NSAppKitVersionNumberWithDeferredWindowDisplaySupport is defined.

2009-04-09  John Sullivan  <sullivan@apple.com>

        <rdar://problem/6775682> WebKit's support for SnowLeopard sudden termination for 
        downloads is broken and should be removed

        Reviewed by Darin Adler

        * Misc/WebDownload.m:
        (-[WebDownloadInternal downloadDidBegin:]):
        remove disableSuddenTermination call
        (-[WebDownloadInternal downloadDidFinish:]):
        remove enableSuddenTermination call
        (-[WebDownloadInternal download:didFailWithError:]):
        remove enableSuddenTermination call

2009-04-09  Darin Adler  <darin@apple.com>

        Reviewed by Anders Carlsson and Sam Weinig.

        Part of <rdar://problem/5438063> Saving history containing 100,000 entries causes pauses of 2s while browsing

        Longer term solution is to change the design so Safari doesn't read and write all of history.
        This patch is step one: Do the serializing, which is done on the main thread, much faster.

        * History/WebHistory.mm:
        (-[WebHistoryPrivate data]): Added. Returns the NSData object containing serialized history.
        For creating new SPI so you can get the data in memory instead of on disk. Uses WebHistoryWriter.
        (-[WebHistoryPrivate saveToURL:error:]): Changed to call [self data
        (-[WebHistory _data]): Added.
        (WebHistoryWriter::WebHistoryWriter): Added.
        (WebHistoryWriter::writeHistoryItems): Added.

        * History/WebHistoryPrivate.h: Added a new _data method.

2009-04-09  Mike Thole  <mthole@apple.com>

        Rubber-stamped by Mark Rowe.

        Fix 64-bit build

        * Panels/WebAuthenticationPanel.h:
            Declare the 'separateRealmLabel' IBOutlet as an NSTextField instead of 'id'.
            This fixes a duplicate method warning (setAutoresizingMask: on NSView and CALayer)

2009-04-09  Mike Thole  <mthole@apple.com>

        Reviewed by Ada Chan.

        <rdar://problem/5697111> Basic authentication dialog spoofing vulnerability

        * Panels/WebAuthenticationPanel.h:
            Added IBOutlet for separateRealmLabel
        * Panels/WebAuthenticationPanel.m:
        (-[WebAuthenticationPanel setUpForChallenge:]):
            In the realm case, decide if it is a simple or complex realm name.  A realm name
            is considered complex if it has any whitespace or newline characters.  Present
            alternative text and layout for the complex case, where the realm name isn't inline
            with the rest of the sheet's text.
        
        * Panels/English.lproj/WebAuthenticationPanel.nib/designable.nib:
        * Panels/English.lproj/WebAuthenticationPanel.nib/keyedobjects.nib:
            Updated the nib with a new 'separateRealmLabel' outlet. 
            Updated the File's Owner to correctly be WebAuthenticationPanel.  
            Fixed springs on the sheet's icon to keep it from moving during a resize.

2009-04-09  David Kilzer  <ddkilzer@apple.com>

        Reinstating <rdar://problem/6718589> Option to turn off SVG DOM Objective-C bindings

        Rolled r42345 back in.  The build failure was caused by an
        internal script which had not been updated the same way that
        build-webkit was updated.

        * Configurations/WebKit.xcconfig:
        * DOM/WebDOMOperations.mm:
        * MigrateHeaders.make:

2009-04-09  Alexey Proskuryakov  <ap@webkit.org>

        Reverting <rdar://problem/6718589> Option to turn off SVG DOM Objective-C bindings.
        It broke Mac build, and I don't know how to fix it.

        * Configurations/WebKit.xcconfig:
        * DOM/WebDOMOperations.mm:
        * MigrateHeaders.make:

2009-04-08  David Kilzer  <ddkilzer@apple.com>

        <rdar://problem/6718589> Option to turn off SVG DOM Objective-C bindings

        Reviewed by Darin Adler and Maciej Stachowiak.

        Introduce the ENABLE_SVG_DOM_OBJC_BINDINGS feature define so
        that SVG DOM Objective-C bindings may be optionally disabled.

        * Configurations/WebKit.xcconfig: Added
        ENABLE_SVG_DOM_OBJC_BINDINGS variable and use it in
        FEATURE_DEFINES.
        * DOM/WebDOMOperations.mm: Removed unused header.
        * MigrateHeaders.make: Switched from using ENABLE_SVG to using
        ENABLE_SVG_DOM_OBJC_BINDINGS.

2009-04-08  David Hyatt  <hyatt@apple.com>

        Reviewed by Adam Roben and Darin Adler

        Fix for https://bugs.webkit.org/show_bug.cgi?id=12440, fixed positioned elements end up in
        inconsistent positions.  Rewrite updateScrollers to improve the correctness.

        * WebView/WebDynamicScrollBarsView.h:
        * WebView/WebDynamicScrollBarsView.m:
        (-[WebDynamicScrollBarsView updateScrollers]):

2009-04-07  Anders Carlsson  <andersca@apple.com>

        Fix Tiger build for real this time.

        * Plugins/WebNetscapePluginView.h:
        * Plugins/WebNetscapePluginView.mm:
        (-[WebNetscapePluginView getVariable:forURL:value:length:]):
        (-[WebNetscapePluginView setVariable:forURL:value:length:]):
        (-[WebNetscapePluginView getAuthenticationInfoWithProtocol:host:port:scheme:realm:username:usernameLength:password:passwordLength:]):
        * Plugins/npapi.mm:
        (NPN_GetValueForURL):
        (NPN_SetValueForURL):

2009-04-07  David Hyatt  <hyatt@apple.com>

        Reviewed by Adam Roben

        Mac portion of fix to make DumpRenderTree always produce accurate scrollbar results.  Change
        updateScrollers to call minimumContentsSize when a WebHTMLView is inside the WebDynamicScrollbarsView.

        * WebView/WebDynamicScrollBarsView.m:
        (-[WebDynamicScrollBarsView updateScrollers]):

2009-04-07  Gustavo Noronha Silva  <gustavo.noronha@collabora.co.uk>

        Reviewed by Anders Carlsson.

        Trying to fix Tiger build.

        * Plugins/WebNetscapePluginView.h:
        * Plugins/WebNetscapePluginView.mm:
        (-[WebNetscapePluginView getAuthenticationInfoWithProtocol:host:port:scheme:realm:username:usernameLength:password:passwordLength:]):

2009-04-07  Anders Carlsson  <andersca@apple.com>

        Try to fix the Leopard build once more.
        
        * Plugins/WebBaseNetscapePluginView.h:
        * Plugins/WebBaseNetscapePluginView.mm:
        * Plugins/WebNetscapePluginView.mm:
        (-[WebNetscapePluginView getVariable:forURL:value:length:]):

2009-04-07  Anders Carlsson  <andersca@apple.com>

        ...and try to fix the Leopard build.
        
        * Plugins/npapi.mm:
        (NPN_GetAuthenticationInfo):

2009-04-07  Anders Carlsson  <andersca@apple.com>

        Try to fix the Tiger build.

        * Plugins/WebBaseNetscapePluginView.mm:

2009-04-07  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        <rdar://problem/6667001>
        NPAPI: need NPN_Get/SetValueForURL() and NPN_GetAuthenticationInfo()
        
        * Plugins/Hosted/NetscapePluginHostProxy.mm:
        (WKPCGetCookies):
        (WKPCGetProxy):
        (WKPCSetCookies):
        (WKPCGetAuthenticationInfo):
        New MIG functions to be used by the plug-in host.
        
        * Plugins/Hosted/NetscapePluginInstanceProxy.h:
        * Plugins/Hosted/NetscapePluginInstanceProxy.mm:
        (WebKit::NetscapePluginInstanceProxy::getCookies):
        (WebKit::NetscapePluginInstanceProxy::setCookies):
        (WebKit::NetscapePluginInstanceProxy::getProxy):
        (WebKit::NetscapePluginInstanceProxy::getAuthenticationInfo):
        Implement these.
        
        * Plugins/Hosted/WebKitPluginClient.defs:
        Add callbacks.
        
        * Plugins/WebBaseNetscapePluginView.h:
        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView URLWithCString:]):
        Factor this out of URLWithCString.
        
        (-[WebBaseNetscapePluginView requestWithURLCString:]):
        Call URLWithCString.
        
        (WebKit::proxiesForURL):
        Return a string representation of proxies for a given URL.
        
        (WebKit::getAuthenticationInfo):
        Get the authentication info for a given host/protocol/scheme/realm/port combination.
        
        * Plugins/WebNetscapePluginPackage.mm:
        (-[WebNetscapePluginPackage _tryLoad]):
        Initialize the new vtable functions.
        
        * Plugins/WebNetscapePluginView.h:
        * Plugins/WebNetscapePluginView.mm:
        (-[WebNetscapePluginView getVariable:forURL:value:length:]):
        (-[WebNetscapePluginView setVariable:forURL:value:length:]):
        (-[WebNetscapePluginView getAuthenticationInfoWithProtocol:host:port:scheme:realm:username:usernameLength:password:passwordLength:]):
        Implement these.
        
        * Plugins/npapi.mm:
        (NPN_GetValueForURL):
        (NPN_SetValueForURL):
        (NPN_GetAuthenticationInfo):
        Call the plug-in view functions.

2009-04-03  Kevin Decker  <kdecker@apple.com>

        Reviewed by Anders Carlsson.

        <rdar://problem/6756512>
        
        * Plugins/Hosted/NetscapePluginHostManager.mm:
        (WebKit::NetscapePluginHostManager::spawnPluginHost): Tweaked the visibleName property.

2009-04-03  John Sullivan  <sullivan@apple.com>

        Reviewed by Ada Chan
        
        <rdar://problem/6755838> Removing all icons can delete other items from disk.

        * Misc/WebIconDatabase.mm:
        (importToWebCoreFormat):
        When snooping around in various directories looking for a directory full of Safari-2-style
        icon database information to convert and delete, bail out without doing the delete part if
        we didn't actually find any Safari-2-style icon database information.

2009-04-03  John Sullivan  <sullivan@apple.com>

        fixed <rdar://problem/6355573> [WebView _setCacheModel:] leaks the result of _CFURLCacheCopyCacheDirectory

        Reviewed by Adam Roben

        * WebView/WebView.mm:
        (+[WebView _setCacheModel:]):
        use WebCFAutorelease rather than autorelease on result of method that returns CFStringRef

2009-04-03  Chris Marrin  <cmarrin@apple.com>

        Reviewed by David Hyatt.

        Fixed https://bugs.webkit.org/show_bug.cgi?id=24941

        This fix essentially does a -viewWillDraw call for layout. It adds 
        a CFRunLoopObserver which performs layout just before drawing on the 
        Mac platform. This makes sure layout is complete before rendering and 
        avoids a flash.

        * WebCoreSupport/WebChromeClient.h:
        * WebCoreSupport/WebChromeClient.mm:
        (WebChromeClient::attachRootGraphicsLayer):
        (WebChromeClient::setNeedsOneShotDrawingSynchronization):
        (WebChromeClient::scheduleViewUpdate):
        * WebView/WebView.mm:
        (-[WebViewPrivate _clearViewUpdateRunLoopObserver]):
        (-[WebView _viewWillDrawInternal]):
        (-[WebView viewWillDraw]):
        (-[WebView close]):
        (viewUpdateRunLoopObserverCallBack):
        (-[WebView _scheduleViewUpdate]):
        * WebView/WebViewInternal.h:

2009-04-03  Anders Carlsson  <andersca@apple.com>

        Reviewed by Kevin Decker.

        WebKit side of <rdar://problem/6752953>.
        
        Pass the clip rect to the plug-in host.
        
        * Plugins/Hosted/NetscapePluginInstanceProxy.mm:
        (WebKit::NetscapePluginInstanceProxy::resize):
        * Plugins/Hosted/WebKitPluginHost.defs:

2009-04-02  Mark Rowe  <mrowe@apple.com>

        Reviewed by Dan Bernstein and Timothy Hatcher.

        <rdar://problem/6684745> Crash in -[WebView removeSizeObservers] when loading NIB file

        The implementation of -[NSView initWithCoder:] can result in -viewWillMoveToSuperview:/-viewDidMoveToSuperview: being sent to
        our view before we've had a chance to initialize _private, so we need to ensure it is non-nil before dereferencing it in those
        methods.

        * WebView/WebView.mm:
        (-[WebView removeSizeObservers]): Nil-check _private before dereferencing it.
        (-[WebView addSizeObservers]): Ditto.

2009-04-02  Adele Peterson  <adele@apple.com>

        Reviewed by Darin Adler.

        Add a way to get a list of focusable nodes.

        * DOM/WebDOMOperations.mm:
        (-[DOMDocument _focusableNodes]):
        * DOM/WebDOMOperationsInternal.h: Added.
        * DOM/WebDOMOperationsPrivate.h: Make this a private header.
        Move old methods to WebDOMOperationsInternal.h
        * WebView/WebHTMLView.mm: Use methods from WebDOMOperationsInternal.h

2009-04-01  Darin Adler  <darin@apple.com>

        Reviewed by Geoff Garen.

        Bug 22378: Crash submitting a form when parsing an XHTML document
        https://bugs.webkit.org/show_bug.cgi?id=22378
        rdar://problem/6388377

        * History/WebHistoryItem.mm:
        (-[WebHistoryItem targetItem]): Call targetItem directly instead of callling
        isTargetItem, hasChildren, and recurseToFindTargetItem.

        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::dispatchWillSubmitForm): Updated for the new
        textFieldValues function in FormState.

        * WebView/WebPDFView.mm:
        (-[WebPDFView PDFViewWillClickOnLink:withURL:]): Updated for name and
        argument change of loadFrameRequest.

2009-04-01  Greg Bolsinga  <bolsinga@apple.com>

        Reviewed by Mark Rowe.
        
        https://bugs.webkit.org/show_bug.cgi?id=24990
        Put SECTORDER_FLAGS into xcconfig files.

        * Configurations/Base.xcconfig:
        * Configurations/DebugRelease.xcconfig:

2009-03-31  Anders Carlsson  <andersca@apple.com>

        Reviewed by Adam Roben.

        WebKit side of <rdar://problem/6500266>.
        
        * Plugins/Hosted/NetscapePluginInstanceProxy.h:
        * Plugins/Hosted/NetscapePluginInstanceProxy.mm:
        (WebKit::NetscapePluginInstanceProxy::wheelEvent):
        Send the event.
        
        * Plugins/Hosted/WebHostedNetscapePluginView.mm:
        (-[WebHostedNetscapePluginView scrollWheel:]):
        Call NetscapePluginInstanceProxy::wheelEvent. If the plug-in processed the event, don't
        call super.
        
        * Plugins/Hosted/WebKitPluginHost.defs:
        Add definition.

2009-03-31  Darin Adler  <darin@apple.com>

        Reviewed by Adele Peterson.

        <rdar://problem/6740581> REGRESSION (r41793): Page Down and Page Up don’t work in Leopard Mail

        * WebView/WebHTMLView.mm:
        (-[WebResponderChainSink tryToPerform:with:]): Added. Without this we would think we had
        handled an event when we actually hadn't. Specifically, when -[WebFrameView scrollPageDown:]
        calls tryToPerform on the next responder.

2009-03-30  Greg Bolsinga  <bolsinga@apple.com>

        Reviewed by Simon Fraser.
        
        https://bugs.webkit.org/show_bug.cgi?id=24938
        
        Build fixes when building --no-svg
        
        DOMHTMLFrameElementPrivate.h and DOMHTMLIFrameElementPrivate.h are only available with ENABLE_SVG.

        * MigrateHeaders.make:

2009-03-29  Darin Adler  <darin@apple.com>

        Reviewed by Cameron Zwarich.

        * Plugins/WebNullPluginView.mm: Added now-needed includes.
        * WebView/WebHTMLRepresentation.mm: Ditto.
        * WebView/WebHTMLView.mm: Ditto.

2009-03-27  Timothy Hatcher  <timothy@apple.com>

        * MigrateHeaders.make: Remove DOMHTMLBodyElementPrivate.h since it
        is not generated anymore.

2009-03-27  Adam Roben  <aroben@apple.com>

        Don't include substitute data URLs in global history redirect chains

        <rdar://6690169>

        Reviewed by Darin Adler.

        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::updateGlobalHistory): Don't call
        updateGlobalHistoryRedirectLinks. FrameLoader calls this for us now.
        (WebFrameLoaderClient::updateGlobalHistoryRedirectLinks):
        Added an assertion to help catch cases where we might be adding a
        substitute data URL into a redirect chain.

2009-03-27  Darin Adler  <darin@apple.com>

        Reviewed by Adam Roben.

        <rdar://problem/6541923> REGRESSION (r38629): Tab cycle in empty tab is broken

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _wantsKeyDownForEvent:]): Only return YES when we have a Frame.

2009-03-27  Darin Adler  <darin@apple.com>

        Reviewed by John Sullivan and Anders Carlsson.

        <rdar://problem/5987442> Pasteboard not exposed to WebEditingDelegate for WebViewInsertActionPasted (needed for system services)

        Added SPI to tell which pasteboard is currently being inserted.
        I chose to put it on WebView to be forward-looking since we're migrating things
        from WebHTMLView to WebView in the future.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _pasteWithPasteboard:allowPlainText:]): Add calls to _setInsertionPasteboard.
        (-[WebHTMLView _pasteAsPlainTextWithPasteboard:]): Ditto.
        * WebView/WebView.mm:
        (-[WebViewPrivate dealloc]): Assert the pasteboard is nil.
        (-[WebViewPrivate finalize]): Ditto.
        (-[WebView _insertionPasteboard]): Return the pastebaord.
        (-[WebView _setInsertionPasteboard:]): Set the pasteboard.
        * WebView/WebViewInternal.h: Added _setInsertionPasteboard.
        * WebView/WebViewPrivate.h: Added _insertionPasteboard.

2009-03-25  Timothy Hatcher  <timothy@apple.com>

        Expose new DOM methods as public Objective-C API.

        <rdar://problem/5837350> Expose new DOM classes and methods
        as public API (match the additions to the JavaScript DOM)

        Reviewed by Mark Rowe and Darin Adler.

        * MigrateHeaders.make:
        * Misc/DOMDocumentPrivate.h: Added. Forwarding header for
        <rdar://problem/6730996>.

2009-03-26  Jungshik Shin  <jshin@chromium.org>

        Reviewed by Alexey Proskuryakov.

        Add WebPreferences for encoding autodetection on Mac.
  
        http://bugs.webkit.org/show_bug.cgi?id=16482

        * WebView/WebPreferenceKeysPrivate.h:
        * WebView/WebPreferences.mm:
        (+[WebPreferences initialize]):
        (-[WebPreferences usesEncodingDetector]):
        (-[WebPreferences setUsesEncodingDetector:]):
        * WebView/WebPreferencesPrivate.h:
        * WebView/WebView.mm:
        (-[WebView _preferencesChangedNotification:]):

2009-03-26  Anders Carlsson  <andersca@apple.com>

        Reviewed by Dan Bernstein.

        - Fix <rdar://problem/6687055> and <rdar://problem/6713639>.
        
        * Plugins/Hosted/NetscapePluginHostProxy.mm:
        (WKPCInvalidateRect):
        Call NetscapePluginInstanceProxy::invalidateRect.
        
        * Plugins/Hosted/NetscapePluginInstanceProxy.h:
        * Plugins/Hosted/NetscapePluginInstanceProxy.mm:
        (WebKit::NetscapePluginInstanceProxy::cleanup):
        Stop the request timer, set m_pluginView to nil.
        
        (WebKit::NetscapePluginInstanceProxy::pluginHostDied):
        No need to set m_pluginView to nil here anymore, it's now done in cleanup().
        
        (WebKit::NetscapePluginInstanceProxy::performRequest):
        (WebKit::NetscapePluginInstanceProxy::requestTimerFired):
        Assert that the plug-in view is not nil.
        
        (WebKit::NetscapePluginInstanceProxy::invalidateRect):
        Call setNeedsDisplayInRect here.

2009-03-25  Anders Carlsson  <andersca@apple.com>

        Reviewed by Darin Adler.

        <rdar://problem/6714964>
        CrashTracer: [REGRESSION] 51 crashes in Safari at com.apple.WebKit • WebNetscapePluginStream::deliverData + 775
        
        Don't release m_deliveryData since it's a RetainPtr. Also, use adoptNS instead of releasing newDeliveryData manually.
        
        * Plugins/WebBaseNetscapePluginStream.mm:
        (WebNetscapePluginStream::deliverData):

2009-03-25  Mike Thole  <mthole@apple.com>

        Reviewed by Kevin Decker.
        
        <rdar://problem/6453738> call SetWindow when user creates a new tab
        
        CoreGraphics plug-ins now receive an NPP_SetWindow call when moving to a background tab.
        Flash is excluded from this change in behavior, as it has historical WebKit-specific code
        that isn't compatible with this change.

        * Plugins/WebNetscapePluginView.h:
            Added an _isFlash ivar.
        * Plugins/WebNetscapePluginView.mm:
        (-[WebNetscapePluginView _createPlugin]):
            Set the new _isFlash ivar based on the bundle identifier.
        (-[WebNetscapePluginView saveAndSetNewPortStateForUpdate:]):
            When using the CG drawing model and in a non-drawable state,  set the portState
            to NULL and return early.
        (-[WebNetscapePluginView updateAndSetWindow]):
            When using the CG drawing model, call -setWindowIfNecessary even if the portState is NULL.
            Flash is an exception to this, due to its historical behavior.
        (-[WebNetscapePluginView setWindowIfNecessary]):
            Removed an assertion that was no longer true.  The [NSView focus] view
            is no longer guaranteed to be 'self' at this point.
            Also modified the debug logging for CG plug-ins to include the size of the 
            window's clipRect, which was useful in verifying the correct behavior of this patch.

2009-03-24  Dan Bernstein  <mitz@apple.com>

        Reviewed by Oliver Hunt.

        - speculative fix for <rdar://problem/6630134> Crash at
          Editor::compositionRange()

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView markedRange]): Null-check the Frame like most other
        methods in this class.

2009-03-23  Sam Weinig  <sam@webkit.org>

        Reviewed by Dan Bernstein.

        Fix for <rdar://problem/6140966>
        Empty Caches does not clear the Cross-site XMLHttpRequest preflight cache

        * Misc/WebCache.mm:
        (+[WebCache empty]):

2009-03-23  Adele Peterson  <adele@apple.com>

        Reviewed by Mark Rowe & Dave Hyatt.

        Merge some of the individual Mail quirks into two settings that we can check for future quirks.

        * WebView/WebView.mm:
        (runningLeopardMail):
        (runningTigerMail):
        (-[WebView _preferencesChangedNotification:]):

2009-03-23  Darin Adler  <darin@apple.com>

        * WebView/WebTextIterator.h: Fixed a spelling error in a comment.

2009-03-22  Dan Bernstein  <mitz@apple.com>

        Reviewed by John Sullivan.

        - fix <rdar://problem/6640741> Messages not displaying after the
          Safari 4 beta was installed

        Mail assumes that if -[WebArchive subresources] is not nil, then it
        contains at least one object.

        * WebView/WebArchive.mm:
        (-[WebArchive subresources]): Preserve the behavior of returning nil
        if there are no subresources.

2009-03-20  Adele Peterson  <adele@apple.com>

        Build fix.

        Reviewed by Darin Adler.

        * WebView/WebFrameView.mm: (-[WebFrameView initWithFrame:]):

2009-03-20  Timothy Hatcher  <timothy@apple.com>

        Change how threading exceptions are checked so they are reported
        by what round they were added. That way WebKit can decided the
        behavior per-round based on linked-on-or-after checks.

        <rdar://problem/6626741&6648478&6635474&6674079>

        Reviewed by Darin Adler.

        * History/WebBackForwardList.mm: Use the new WebCoreThreadViolationCheckRoundOne macro.
        * History/WebHistoryItem.mm: Ditto.
        * Misc/WebIconDatabase.mm: Ditto.

        * WebView/WebArchive.mm: Use the new WebCoreThreadViolationCheckRoundTwo macro.
        * WebView/WebResource.mm: Ditto.
        (+[WebResource _needMailThreadWorkaroundIfCalledOffMainThread]): Check Mail's bundle version
        to truly decide if it is an old Mail client.
        * WebView/WebView.mm: Ditto.

        * Misc/WebKitVersionChecks.h: Add a new linked-on-or-after version define.
        * WebView/WebFrameView.mm:
        (-[WebFrameView initWithFrame:]): Set the default thread violation behavior per-round
        based on difference version checks and the Mail workaround check.

2009-03-20  Darin Adler  <darin@apple.com>

        Reviewed by Timothy Hatcher.

        * WebView/WebTextIterator.h: Improved comments to point out some of the pitfalls
        of this SPI.

2009-03-20  Darin Adler  <darin@apple.com>

        Reviewed by Adele Peterson.

        Use a better technique to handle finding out if something responds to a selector
        in WebHTMLView's doCommandBySelector method.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView doCommandBySelector:]): Removed unneeded check for 0 coreFrame;
        this is already handled by coreCommandBySelector: so doesn't need to be checked
        twice. Got rid of initial value for eventWasHandled boolean to make it more clear.
        Use WebResponderChainSink to find out if a command is handled rather than walking
        the responder chain explicitly.
        (-[WebResponderChainSink initWithResponderChain:]): Added.
        (-[WebResponderChainSink detach]): Added.
        (-[WebResponderChainSink receivedUnhandledCommand]): Added.
        (-[WebResponderChainSink noResponderFor:]): Added.
        (-[WebResponderChainSink doCommandBySelector:]): Added.

2009-03-19  Timothy Hatcher  <timothy@apple.com>

        Remove #ifndef BUILDING_ON_TIGER around code that schedules runloop modes
        for Page, so the new RunLoopTimer in WebCore always gets a default mode.
        Fixes the layout test failures on the Tiger build bots.

        Reviewed by Mark Rowe.

        * WebView/WebView.mm:
        (-[WebView _commonInitializationWithFrameName:groupName:usesDocumentViews:]):
        (-[WebView scheduleInRunLoop:forMode:]):
        (-[WebView unscheduleFromRunLoop:forMode:]):

2009-03-18  Anders Carlsson  <andersca@apple.com>

        Reviewed by Oliver Hunt.

        WebKit side of <rdar://problem/6688244>.
        
        Try reinitializing the vendor port if it's invalid.
        
        * Plugins/Hosted/NetscapePluginHostManager.mm:
        (WebKit::NetscapePluginHostManager::spawnPluginHost):

2009-03-18  Anders Carlsson  <andersca@apple.com>

        Reviewed by Darin Adler.

        <rdar://problem/6504776> 
        CrashTracer: [USER] 188 crashes in Safari at com.apple.WebCore • WTF::HashTableIterator<WTF::RefPtr<WebCore::ResourceLoader>, ...
        
        If the m_pluginView member was zeroed out as a result of making a call into the plug-in, the pluginFunctionCallDepth would be off
        causing the plug-in never to be stopped. Simplify the code by using a RAII object.

        * Plugins/WebBaseNetscapePluginStream.mm:
        (PluginStopDeferrer::PluginStopDeferrer):
        (PluginStopDeferrer::~PluginStopDeferrer):
        (WebNetscapePluginStream::startStream):
        (WebNetscapePluginStream::wantsAllStreams):
        (WebNetscapePluginStream::destroyStream):

2009-03-17  Darin Adler  <darin@apple.com>

        Reviewed by Adele Peterson.

        <rdar://problem/6687005> Need support for new move-left/right selectors.

        * WebView/WebHTMLView.mm: Added the four new selectors to the command-forwarding list.
        * WebView/WebView.mm: Ditto.

2009-03-17  Darin Adler  <darin@apple.com>

        Reviewed by Adele Peterson.

        Bug 24477: REGRESSION (r41467): Page Down key scrolls two pages
        https://bugs.webkit.org/show_bug.cgi?id=24477
        rdar://problem/6674184

        * WebView/WebHTMLView.mm:
        (responderChainRespondsToSelector): Added.
        (-[WebHTMLView doCommandBySelector:]): Set eventWasHandled based on whether we
        can find a responder that responds to this selector rather than always assuming
        the selector will not be handled.

2009-03-17  Mark Rowe  <mrowe@apple.com>

        Fix the build.

        * Plugins/Hosted/HostedNetscapePluginStream.mm:

2009-03-17  David Kilzer  <ddkilzer@apple.com>

        Use -[NSURLResponse(WebCoreURLResponse) _webcore_MIMEType] consistently

        Reviewed by Darin Adler.

        WebKit r30323 added -_webcore_MIMEType to fix issues with
        incorrect MIME types in NS[HTTP]URLResponse objects.  However,
        uses of -[NSURLResponse MIMEType] still persist in WebKit that
        should be switched to use -_webcore_MIMEType.  Note that
        -[WebDataSource _responseMIMEType] calls back into WebCore to
        get the MIME type from the ResourceResponse object, which has
        already retrieved it via -_webcore_MIMEType.

        * Plugins/Hosted/HostedNetscapePluginStream.mm:
        (WebKit::HostedNetscapePluginStream::didReceiveResponse): Use
        -_webcore_MIMEType.
        * Plugins/WebBaseNetscapePluginStream.mm:
        (WebNetscapePluginStream::didReceiveResponse): Ditto.
        * Plugins/WebNetscapePluginView.mm:
        (-[WebNetscapePluginView pluginView:receivedData:]): Ditto.
        * Plugins/WebPluginController.mm:
        (-[WebPluginController pluginView:receivedResponse:]): Ditto.
        * WebView/WebHTMLRepresentation.mm:
        (-[WebHTMLRepresentation _isDisplayingWebArchive]): Use
        -[WebDataSource _responseMIMEType] instead.
        * WebView/WebPDFRepresentation.m:
        (-[WebPDFRepresentation finishedLoadingWithDataSource:]): Ditto.
        * WebView/WebPDFView.mm:
        (-[WebPDFView menuForEvent:]): Ditto.

2009-03-17  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Darin Adler

        https://bugs.webkit.org/show_bug.cgi?id=24396
        
        Add WTF_USE_ACCELERATED_COMPOSITING, defined to 0 for now.

        * WebKitPrefix.h:

2009-03-17  Kevin Ollivier  <kevino@theolliviers.com>

        Reviewed by Mark Rowe.

        Get BUILDING_ON_* defines from Platform.h.
        
        https://bugs.webkit.org/show_bug.cgi?id=24630

        * WebKitPrefix.h:

2009-03-16  Darin Adler  <darin@apple.com>

        Reviewed by Dan Bernstein.

        <rdar://problem/6577174> Rename the text directionality submenus to “Paragraph Direction” and “Selection Direction”

        * WebCoreSupport/WebViewFactory.mm:
        (-[WebViewFactory contextMenuItemTagParagraphDirectionMenu]): Changed string here, but only
        post-Leopard, since we want this to match the Mac OS X menu on Tiger and Leopard.
        (-[WebViewFactory contextMenuItemTagSelectionDirectionMenu]): Changed string here.

2009-03-16  Anders Carlsson  <andersca@apple.com>

        Reviewed by Oliver Hunt.

        Don't mig_deallocate random data in case an instance proxy method returns false.
        
        * Plugins/Hosted/NetscapePluginHostProxy.mm:
        (WKPCEvaluate):
        (WKPCInvoke):
        (WKPCInvokeDefault):
        (WKPCGetProperty):
        (WKPCEnumerate):

2009-03-16  Anders Carlsson  <andersca@apple.com>

        Reviewed by Oliver Hunt.

        <rdar://problem/6633944> 
        REGRESSION (Safari 4 PB): Many crashes in Flip4Mac involving loading the plugin
        
        Defer loading while calling webPlugInInitialize since it can end up spinning the run loop.
        
        * Plugins/WebPluginController.mm:
        (-[WebPluginController addPlugin:]):

2009-03-16  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        Fix <rdar://problem/6622601>
        
        Make sure to update both the window frame and the plug-in frame.
        
        * Plugins/Hosted/WebHostedNetscapePluginView.mm:
        (-[WebHostedNetscapePluginView addWindowObservers]):

2009-03-15  Dan Bernstein  <mitz@apple.com>

        Reviewed by Adele Peterson.

        - fix <rdar://problem/6607773> WebKit should support the "Default"
          paragraph writing direction -- or at least validate the menu item
          appropriately

        Made WebHTMLView validate user interface items with the selector
        -makeBaseWritingDirectionNatural: by returning NO and, if the item is
        a menu item, setting its state to "off".

        Strictly speaking, since -makeBaseWritingDirectionNatural: is never
        valid for WebViews, WebHTMLView should not need to respond to it and
        validate it, however because other responders respond to all three
        -makeBaseWritingDirection*: messages and set the menu item state, having
        WebHTMLView do the same makes application developers' lives easier.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView validateUserInterfaceItemWithoutDelegate:]):
        (-[WebHTMLView makeBaseWritingDirectionNatural:]):

2009-03-13  Mark Rowe  <mrowe@apple.com>

        Rubber-stamped by Dan Bernstein.

        Take advantage of the ability of recent versions of Xcode to easily switch the active
        architecture.

        * Configurations/DebugRelease.xcconfig:

2009-03-13  Anders Carlsson  <andersca@apple.com>

        Reviewed by Kevin Decker and Geoffrey Garen.

        <rdar://problem/6590384>
        REGRESSION (Safari 3-4): Tiger-only Crash occurs at WebView hostWindow () after reloading a set of tabs then quitting
        
        When we're doing fast teardown, plug-in views can be destroyed from -[WebView dealloc]'s [super dealloc] call, 
        and thus calling -[WebView hostWindow] will crash since _private is nil.
        
        * WebView/WebView.mm:
        (-[WebView hostWindow]):

2009-03-13  Anders Carlsson  <andersca@apple.com>

        And yet another attempt...
        
        * Plugins/WebNetscapePluginEventHandlerCocoa.h:
        (WebNetscapePluginEventHandlerCocoa::installKeyEventHandler):
        (WebNetscapePluginEventHandlerCocoa::removeKeyEventHandler):
        * Plugins/WebNetscapePluginEventHandlerCocoa.mm:

2009-03-13  Anders Carlsson  <andersca@apple.com>

        Another attempt at fixing the build.
        
        * Plugins/WebNetscapePluginEventHandlerCocoa.mm:
        (WebNetscapePluginEventHandlerCocoa::WebNetscapePluginEventHandlerCocoa):

2009-03-13  Anders Carlsson  <andersca@apple.com>

        Try to fix the SL build.

        * Plugins/WebNetscapePluginEventHandlerCocoa.h:
        * Plugins/WebNetscapePluginEventHandlerCocoa.mm:
        (WebNetscapePluginEventHandlerCocoa::keyDown):

2009-03-13  Greg Bolsinga  <bolsinga@apple.com>

        Reviewed by Simon Fraser.

        Update Geolocation perimission dialogs to be asynchronous.
        https://bugs.webkit.org/show_bug.cgi?id=24505

        WebGeolocation is a wrapper around WebCore::Geolocation. It mimics the
        coding style set by WebSecurityOrigin.
        
        WebChromeClient now calls the private UI delegate method 
        -webView:frame:requestGeolocationPermission:securityOrigin:

        * WebCoreSupport/WebChromeClient.h:
        * WebCoreSupport/WebChromeClient.mm:
        (WebChromeClient::requestGeolocationPermissionForFrame):
        * WebCoreSupport/WebGeolocation.mm: Added.
        (WebCore::if):
        (-[WebGeolocation shouldClearCache]):
        (-[WebGeolocation setIsAllowed:]):
        (-[WebGeolocation dealloc]):
        * WebCoreSupport/WebGeolocationInternal.h: Added.
        * WebCoreSupport/WebGeolocationPrivate.h: Added.
        * WebView/WebUIDelegatePrivate.h:

2009-03-13  Anders Carlsson  <andersca@apple.com>

        Reviewed by Dan Bernstein.

        <rdar://problem/6610666> Revise the Cocoa event model text API

        Replace the text input API with a simpler API that uses a separate text input window.
        
        * Plugins/WebNetscapePluginEventHandlerCocoa.h:
        * Plugins/WebNetscapePluginEventHandlerCocoa.mm:
        (WebNetscapePluginEventHandlerCocoa::WebNetscapePluginEventHandlerCocoa):
        Initialize m_keyEventHandler to 0.
        
        (WebNetscapePluginEventHandlerCocoa::keyDown):
        If the plug-in returns 0 from NPP_HandleEvent, pass the event to the TSM machinery.
        
        (WebNetscapePluginEventHandlerCocoa::focusChanged):
        Install/remove the key event handler as needed.
        
        (WebNetscapePluginEventHandlerCocoa::handleTSMEvent):
        Get the text and send a TextInput event.
        
        * Plugins/WebNetscapePluginView.h:
        * Plugins/WebNetscapePluginView.mm:
        Remove the old text input API.
        
